# Roundtable Dynamics Integration 11.7

Roundtable Dynamics Integration Information:
Roundtable version : 11.7
Dynamics version   : 11.4 and higher
OpenEdge version   : 10.2B and higher 
Date               : 05/2018

NOTE: This version of the integration code will only work with RTB 11.7 and higher

## Installation instructions
The integration code for Roundtable TSMS and Progress Dynamics should be installed into the root directory of the RTB client installation.

If you have a customized version of the RTB event handler - rtb_events.p - make sure to create a backup of this file before installing the Roundtable Dynamics integration code.

The installation will create a "scm" subdirectory in the RTB client installation. Once the installation has been completed, the contents of the scm directory must be compiled. This has to be done from an active roundtable session with an active connection to a Progress Dynamics ICFDB database, as there are references to the ICFDB database in the code.

Compiling the code can be done from a procedure Editor in a RTB session with a Dynamics enabled workspace selected by running the following code:
RUN scm_compile.p.

### Updating customized integration code
The integration code for RTB Dynamics is also usually included in Dynamics applications as part of the Dynamics baseline included in each workspace. If this integration code is being installed into an existing RTB Dynamics installation, the integration code in the main development workspace also needs to be updated. Once this has been updated, the changes can then be imported into the other workspaces to update these.

To update the integration code in a workspace and also to merge with own customizations by using the new integration code, the following approach is recommended:

1. Install the standard integration code into the RTB client root directory.

2. Using a file comparison tool, compare the contents of the <RTB client install root>/scm directory and the <workspace root>\src\dynamics\scm directory - merge the changes from the new integration code into the code in the workspace.

3. Start RTB and select the workspace with the changed code. Log into the Dynamics framework using the login screen that must start when the workspace is selected.

4. Run a selective compile to do a forced compile of the objects in the *rtb* and *scm* modules.

5. Create a task to update the changes to the integration code.
Use this task to check out the objects that were changed during the merge in step 2 above. If the objects have not been updated or customized previously, then it will be necessary to create custom variants of the objects. (This requires custom variant modules to be in place for the *rtb* and *scm* modules in the workspace).

6. Compile the objects in the task and test the changes. Make sure to log out of RTB and back in again to test that the Dynamics framework is started when a workspace is selected and that all the standard integration functionality works as it should - especially with any customizations that may have been made to the standard code.

* Please note that merging customizations and troubleshooting customizations to the RTB Dynamics integration code is not supported by Roundtable Technical Support.

Once the integration code has been installed and the workspaces have been updated with the changes to the integration code, the install is complete and you can start using Roundtable TSMS and Dynamics 11.

## OpenEdge Version Compatibility
Roundtable Dynamics Integration 11.7 is compatible with OpenEdge 10.2B and greater.

## Roundtable Compatibility
Roundtable Dynamics Integration 11.7 is compatible with Roundtable TSMS 11.7 and greater.

## Support
US, CANADA, and EUROPE:
http://www.roundtable-tsms.com/support

US and CANADA:
support@roundtable-tsms.com

EUROPE:
support-europe@roundtable-tsms.com

LATIN AMERICA, AFRICA, AND ASIA/PACIFIC:
Please contact the Progress Software Technical Support center for your region to receive front-line support.

We appreciate your continued use of Roundtable Software.

Roundtable Development Team
Roundtable Software
