/*------------------------------------------------------------------------
    File        : rtb_events_cl.p
    Description : Roundtable event handler - client.
    Notes       :
      This procedure will run on the client when running Roundtable in
      AppServer mode. See the Client Events comment section in rtb_events.p
      for documentation on Roundtable published events and parameters. 
  ----------------------------------------------------------------------*/
{rtb/i/rtb_events.i}

SUBSCRIBE TO {&RTB-USER-EVENT} ANYWHERE.

PROCEDURE {&RTB-USER-EVENT}:
/*------------------------------------------------------------------------------
  Purpose:    Roundtable Event Handler 
  Parameters: INPUT
                pcEvent
                pcContext
                pcOther
                pcContext2
              OUTPUT
               plOk
  Notes:      Common procedure for all events.
              RETURN a value from this procedure to return an error message
              to the caller.
------------------------------------------------------------------------------*/
  DEFINE INPUT  PARAMETER pcEvent    AS CHARACTER NO-UNDO.
  DEFINE INPUT  PARAMETER pcContext  AS CHARACTER NO-UNDO.
  DEFINE INPUT  PARAMETER pcOther    AS CHARACTER NO-UNDO.
  DEFINE INPUT  PARAMETER pcContext2 AS CHARACTER NO-UNDO.   
  DEFINE OUTPUT PARAMETER plOk       AS LOGICAL   NO-UNDO INITIAL YES.

  DEFINE VARIABLE cError AS CHARACTER NO-UNDO INITIAL "".

  /*
   Debugging:
     
  MESSAGE
    "Event:    " pcEvent    SKIP
    "Context:  " pcContext  SKIP
    "Other:    " pcOther    SKIP
    "Context2: " pcContext2 SKIP
    VIEW-AS ALERT-BOX
    BUTTONS OK-CANCEL
    TITLE "Roundtable Event"
    UPDATE plOk.
  
  IF NOT plOk THEN
    cError = "Canceled by user!".
  */
  
  RETURN cError.
  
END PROCEDURE.
