&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v8r12
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Check Version Notes Wizard" Procedure _INLINE
/* Actions: af/cod/aftemwizcw.w ? ? ? ? */
/* Version Notes Wizard
Check object version notes.
af/cod/aftemwizpw.w
*/
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Update-Object-Version" Procedure _INLINE
/* Actions: ? ? ? ? af/sup/afverxftrp.p */
/* This has to go above the definitions sections, as that is what it modifies.
   If its not, then the definitions section will have been saved before the
   XFTR code kicks in and changes it */
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Definition Comments Wizard" Procedure _INLINE
/* Actions: ? af/cod/aftemwizcw.w ? ? ? */
/* Program Definition Comment Block Wizard
Welcome to the Program Definition Comment Block Wizard. Press Next to proceed.
af/cod/aftemwizpw.w
*/
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Procedure
/*********************************************************************
* Copyright (C) 2006-2016 by Roundtable Software Inc. ("Roundtable"),*
*  All Rights Reserved.                                              *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
* nodeable limited (www.nodeable.io)                                 *
*********************************************************************/
/*---------------------------------------------------------------------------------
  File: rtbpreevent.p

  Description:  RTB pre event procedure for OpenEdge Arcitecht Integration

  Purpose:      Used to do any pre Roundtable hooks and events processing

  Parameters:   <none>

  History:
  --------
  (v:010000)    Task:             UserRef:
                Date:   01/2007    Author:     Thomas Hansen

  Update Notes: First version created based on rtbpreevent.p from the non
                OEA RTBDYN integration.

-----------------------------------------------------------------------------*/
/*                   This .W file was created with the Progress UIB.             */
/*-------------------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */
/* MIP-GET-OBJECT-VERSION pre-processors
   The following pre-processors are maintained automatically when the object is
   saved. They pull the object and version from Roundtable if possible so that it
   can be displayed in the about window of the container */

&scop object-name       rtbpreevent.p
DEFINE VARIABLE lv_this_object_name AS CHARACTER INITIAL "{&object-name}":U NO-UNDO.
&scop object-version    030000

DEFINE VARIABLE cObjectName AS CHARACTER NO-UNDO.

ASSIGN
    cObjectName = "{&object-name}":U.

ASSIGN
    THIS-PROCEDURE:PRIVATE-DATA = "rtbpreevntp.p":U.

/* MIP object identifying preprocessor */
&glob   mip-structured-procedure    yes

DEFINE VARIABLE gcRtbCurrentWorkspace     AS CHARACTER                           NO-UNDO.
DEFINE VARIABLE gcRtbCurrentWorkspacePath AS CHARACTER                           NO-UNDO.
DEFINE VARIABLE gcRtbCurrentWorkspaceRoot AS CHARACTER                           NO-UNDO.
DEFINE VARIABLE gcRtbCurrentUser          AS CHARACTER                           NO-UNDO.
DEFINE VARIABLE giRtbCurrentTask          AS INTEGER                             NO-UNDO.
DEFINE VARIABLE giRTBSid                  AS INTEGER                             NO-UNDO.
/*DEFINE VARIABLE gcRtbASConnection        AS CHARACTER NO-UNDO.*/
DEFINE VARIABLE gcRTBASConnectString      AS CHARACTER                           NO-UNDO.
DEFINE VARIABLE gcRTBASConnectURL         AS CHARACTER                           NO-UNDO.
DEFINE VARIABLE gcRtbCurrentUserPassword  AS CHARACTER                           NO-UNDO.
DEFINE VARIABLE gcASHostName              AS CHARACTER                           NO-UNDO.
DEFINE VARIABLE gcASPort                  AS CHARACTER                           NO-UNDO.
DEFINE VARIABLE gcASService               AS CHARACTER                           NO-UNDO.

DEFINE VARIABLE cMesWinTitle              AS CHARACTER                           NO-UNDO.
DEFINE VARIABLE cMesWinMessage            AS CHARACTER                           NO-UNDO.
DEFINE VARIABLE cMesWinButtonList         AS CHARACTER                           NO-UNDO.
DEFINE VARIABLE cMesWinButtonDefault      AS CHARACTER                           NO-UNDO.
DEFINE VARIABLE cMesWinButtonCancel       AS CHARACTER                           NO-UNDO.
DEFINE VARIABLE cMesWinAnswerValue        AS CHARACTER                           NO-UNDO.
DEFINE VARIABLE cMesWinAnswerDataType     AS CHARACTER                           NO-UNDO.
DEFINE VARIABLE cMesWinAnswerFormat       AS CHARACTER                           NO-UNDO.
DEFINE VARIABLE cMesWinButtonPressed      AS CHARACTER                           NO-UNDO.
DEFINE VARIABLE glDCUCancelled            AS LOGICAL                             NO-UNDO INITIAL FALSE.
DEFINE VARIABLE cRTBSessionSettings       AS CHARACTER                           NO-UNDO.
DEFINE VARIABLE hConfMan                  AS HANDLE                              NO-UNDO.
DEFINE VARIABLE hRtbApi                   AS HANDLE                              NO-UNDO.
DEFINE VARIABLE ghRtbAs                   AS HANDLE                              NO-UNDO.
DEFINE VARIABLE glDebug                   AS LOGICAL                             NO-UNDO INITIAL FALSE.
DEFINE VARIABLE glShowNotifyBallonTips    AS LOGICAL                             NO-UNDO INITIAL FALSE.
DEFINE VARIABLE oRtbProxyHelper           AS scm.custom.rtb.Utils.RTBProxyHelper NO-UNDO.

DEFINE STREAM sOut.
/* Add the OEIDE include to check if we are running from eclipse */
{adecomm/oeideservice.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Procedure
&Scoped-define DB-AWARE no



/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Prototypes ********************** */

&IF DEFINED(EXCLUDE-buildFileSCM) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD buildFileSCM Procedure
FUNCTION buildFileSCM RETURNS CHARACTER
    ( INPUT pcFilename AS CHARACTER )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-createFile) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD createFile Procedure
FUNCTION createFile RETURNS LOGICAL
    ( INPUT pcFilename AS CHARACTER )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-deleteFile) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD deleteFile Procedure
FUNCTION deleteFile RETURNS LOGICAL
    ( INPUT pcFilename AS CHARACTER )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-findFile) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD findFile Procedure
FUNCTION findFile RETURNS CHARACTER
    ( INPUT pcFilename AS CHARACTER )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Procedure
   Allow:
   Frames: 0
   Add Fields to: Neither
   Other Settings: CODE-ONLY COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB)
  CREATE WINDOW Procedure ASSIGN
         HEIGHT             = 36.57
         WIDTH              = 74.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME




&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Procedure


/* ***************************  Main Block  *************************** */
SUBSCRIBE PROCEDURE THIS-PROCEDURE TO "DCU_BeforeInitialize":U  ANYWHERE.
SUBSCRIBE PROCEDURE THIS-PROCEDURE TO "DCU_Cancel":U  ANYWHERE.
SUBSCRIBE PROCEDURE THIS-PROCEDURE TO "ICFCFM_UpgradeStart":U ANYWHERE.
SUBSCRIBE PROCEDURE THIS-PROCEDURE TO "ICFCFM_UpgradeComplete":U  ANYWHERE.
SUBSCRIBE PROCEDURE THIS-PROCEDURE TO "ICFStart_BeforeInitialize":U  ANYWHERE.
SUBSCRIBE PROCEDURE THIS-PROCEDURE TO "logEvent":U ANYWHERE.

/* subcribe to the events that usually come from RTB */
SUBSCRIBE PROCEDURE THIS-PROCEDURE TO "evRtbGetCurrentUser":U      ANYWHERE.
SUBSCRIBE PROCEDURE THIS-PROCEDURE TO "evRtbGetCurrentWorkspace":U ANYWHERE.

/* Subscribe to new custom events */
SUBSCRIBE PROCEDURE THIS-PROCEDURE TO "evRtbCustGetCurrentPassword":U     ANYWHERE.
SUBSCRIBE PROCEDURE THIS-PROCEDURE TO "evRtbCustGetASConnectString":U  ANYWHERE.
SUBSCRIBE PROCEDURE THIS-PROCEDURE TO "evRtbCustGetASConnectURL":U ANYWHERE.
SUBSCRIBE PROCEDURE THIS-PROCEDURE TO "evRtbCustGetASConnection":U ANYWHERE.
SUBSCRIBE PROCEDURE THIS-PROCEDURE TO "evRtbCustSetRTBASConnection":U ANYWHERE.
SUBSCRIBE PROCEDURE THIS-PROCEDURE TO "evRtbCustGetASHandle":U ANYWHERE.
SUBSCRIBE PROCEDURE THIS-PROCEDURE TO "evRtbCustGetSid":U ANYWHERE.

{ry/app/ryplipmain.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */
&IF DEFINED(EXCLUDE-compileModules) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE compileModules Procedure
PROCEDURE compileModules :
    /*------------------------------------------------------------------------------
      Purpose:
      Parameters:  pcCompileModules - the MATCHES list of module to compile.
      Notes:
    ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER pcCompileModules  AS CHARACTER  NO-UNDO.
    DEFINE INPUT  PARAMETER plShowErrors      AS LOGICAL    NO-UNDO.

    DEFINE VARIABLE iCompileLoop  AS INTEGER   NO-UNDO.
    DEFINE VARIABLE cCompileError AS CHARACTER NO-UNDO.

    PUBLISH "logEvent" (INPUT "IMPORT EVENT",
        INPUT "[":U + STRING(TIME , "HH:MM:SS") + "] Compiling DCU & RTB procedures.",
        INPUT "":U,
        INPUT gcRtbCurrentWorkspace,
        INPUT gcRtbCurrentUser,
        INPUT "LOG,STATUS":U,
        INPUT "dynrtb_import.log",
        INPUT "":U) .

    /* Do a selective compile of all of the objects in the specified modules */
    /* - *DCU* : The DCU specific modules */
    /* - *RTB* : The RTB and SCMRTB specific modules */
    /* - *af-aaa* : Files in the root Dynamics directory */
    /* - *af-app* : Files in the af/app directory */

    /*     The code has been changed to only do a selective compile - not a forced compile, as this */
    /*     will take a very long time when a large module like af-app is included                   */

    DO iCompileLoop = 1 TO NUM-ENTRIES(pcCompileModules,","):
        SESSION:SET-WAIT-STATE("GENERAL":U).
        PROCESS EVENTS.

        IF NOT VALID-HANDLE(hRtbApi) THEN
            RUN rtb/p/rtb_api.p PERSISTENT SET hRtbApi.

        IF VALID-HANDLE(hRtbApi) THEN
        DO:
            RUN set_session_id   IN hRtbApi( INPUT INTEGER(giRTBSid)).
            RUN set_workspace_id IN hRtbApi (INPUT gcRtbCurrentWorkspace).

        END.

        PUBLISH "logEvent" (INPUT "IMPORT EVENT",
            INPUT "[":U + STRING(TIME , "HH:MM:SS") + "] Compiling modules " + ENTRY(iCompileLoop, pcCompileModules) + ".":U,
            INPUT "":U,
            INPUT gcRtbCurrentWorkspace,
            INPUT gcRtbCurrentUser,
            INPUT "LOG,STATUS":U,
            INPUT "dynrtb_import.log",
            INPUT "":U) .

        RUN selective_compile IN hRtbApi
            (INPUT 0,               /* Ptask-num  - task number to select objects from or 0 to ignore tasks */
            INPUT ENTRY(iCompileLoop, pcCompileModules),            /* Pmodule    - module to select objects from or MATCHES pattern */
            INPUT "*":U,            /* Pobj-group - Object group to select objects from or MATCHES pattern */
            INPUT "PCODE":U,       /* Pobj-type  - Object types to select (PCODE, PFILE, etc.) or MATCHES pattern */
            INPUT "*":U,           /* Pobject    - Object to select or MATCHES pattern */
            INPUT YES,             /* Pforce     - Logical YES to force compile of (current) objects */
            INPUT NO,              /* Plistings  - Logical YES to generate compile listings */
            INPUT NO,              /* Pxref      - Logical YES to perform xref of selected object(s) */
            OUTPUT cCompileError).  /* Perror     - This will be non-blank if the process could no be performed */

        SESSION:SET-WAIT-STATE("":U).

        /* If there are errors during the compile, then show the
           contents of the log file in a procedure editor in the same
           way as RTB does
        */
        IF cCompileError <> "":U AND
            plShowErrors THEN
            IF SEARCH("rtb/p/rtb_rnpw.p") <> ? OR
                SEARCH("rtb/p/rtb_rnpw.r") <> ? THEN
                RUN rtb/p/rtb_rnpw.p (INPUT ENTRY(2,cCompileError), INPUT 0).
    END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-DCU_BeforeInitialize) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE DCU_BeforeInitialize Procedure
PROCEDURE DCU_BeforeInitialize :
    /*------------------------------------------------------------------------------
      Purpose:
      Parameters:  <none>
      Notes:
    ------------------------------------------------------------------------------*/

    DEFINE VARIABLE iSessionParamLoop      AS INTEGER   NO-UNDO.
    DEFINE VARIABLE cSessionParameters     AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cSessionParamEntry     AS CHARACTER NO-UNDO.

    DEFINE VARIABLE cSessionTypeDCU        AS CHARACTER NO-UNDO.

    DEFINE VARIABLE cSessionFullSetup      AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cSessionDefaultSetup   AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cSessionDefaultDCUType AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cSessionDefaultICFType AS CHARACTER NO-UNDO.

    ASSIGN
        cSessionParameters     = SESSION:ICFPARAM
        cSessionDefaultSetup   = "icfsetup.xml":U
        cSessionDefaultDCUType = "ProgressSetup":U
        cSessionDefaultICFType = cSessionDefaultDCUType.

    cSessionFullSetup = findFile(cSessionDefaultSetup).

    IF cSessionFullSetup <> "":U THEN
        ASSIGN cSessionDefaultSetup = cSessionFullSetup.

    blockSessionParam:
    DO iSessionParamLoop = 1 TO NUM-ENTRIES(cSessionParameters):

        ASSIGN
            cSessionParamEntry = ENTRY(iSessionParamLoop, cSessionParameters).

        /* If there are no = or more than one =, this is an invalid parameter, so ignore it. */
        IF NUM-ENTRIES(cSessionParamEntry,"=":U) <> 2 THEN
            NEXT blockSessionParam.

        IF ENTRY(1,cSessionParamEntry,"=":U) = "DCUSETUPTYPE":U THEN
            ASSIGN cSessionDefaultDCUType = ENTRY(2,cSessionParamEntry,"=":U).
    END.

    IF cSessionDefaultSetup <> "":U THEN
        ASSIGN cSessionTypeDCU = "ICFCONFIG=" + cSessionDefaultSetup.

    IF cSessionDefaultDCUType <> "":U THEN
        ASSIGN cSessionTypeDCU = cSessionTypeDCU + (IF cSessionTypeDCU <> "" THEN "," ELSE "")
                              + "DCUSETUPTYPE=" + cSessionDefaultDCUType.

    IF cSessionDefaultICFType <> "":U THEN
        ASSIGN cSessionTypeDCU = cSessionTypeDCU + (IF cSessionTypeDCU <> "" THEN "," ELSE "")
                             + "ICFSESSTYPE=" + cSessionDefaultICFType.

    IF cSessionTypeDCU = "":U THEN
        ASSIGN cSessionTypeDCU = SESSION:ICFPARAM.

    DYNAMIC-FUNCTION ("setSessionParam":U IN THIS-PROCEDURE, "ICFPARAM":U, cSessionTypeDCU ).

    DYNAMIC-FUNCTION ("setSessionParam":U IN THIS-PROCEDURE, "quit_on_end":U, "NO" ).

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-DCU_Cancel) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE DCU_Cancel Procedure
PROCEDURE DCU_Cancel :
    /*------------------------------------------------------------------------------
      Purpose:     Catch that the DCU has been cancelled
      Parameters:  <none>
      Notes:
    ------------------------------------------------------------------------------*/
    ASSIGN
        glDCUCancelled = TRUE.

    /* Now that the DCU upgrade has been cancelled,
       we need to remove the lock on the workspace.
    */
    DEFINE VARIABLE hData       AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hWSBuf      AS HANDLE    NO-UNDO.
    DEFINE VARIABLE cWSLockedBy AS CHARACTER NO-UNDO.
    DEFINE VARIABLE hOcBuf      AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hOcTT       AS HANDLE    NO-UNDO.
    DEFINE VARIABLE cError      AS CHARACTER NO-UNDO.

    IF NOT VALID-HANDLE(ghRtbAs) THEN
        PUBLISH  "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

    IF VALID-HANDLE(ghRtbAs) THEN
    DO:
        /* Get the workspace record */
        hData = oRtbProxyHelper:rtbGetWorkspaceHandle(gcRtbCurrentWorkspace).

        hWSBuf = hData:DEFAULT-BUFFER-HANDLE.
        hWSBuf:FIND-FIRST() NO-ERROR.
        IF hWSBUf:AVAILABLE THEN
        DO:
            IF INDEX(hWSBuf:BUFFER-FIELD("locked-by"):BUFFER-VALUE, "DCU":U) > 0 THEN
            DO:

                /* Create a copy of the original record we received */
                CREATE TEMP-TABLE hOcTT.
                hOcTT:CREATE-LIKE(hData).
                hOcTT:TEMP-TABLE-PREPARE(hWSBuf:NAME).

                hOcBuf = hOcTT:DEFAULT-BUFFER-HANDLE.
                hOcBuf:BUFFER-CREATE.
                hOcBuf:BUFFER-COPY(hWSBuf).

                /* Create another copy to hold the updated values */
                hOcBuf:BUFFER-CREATE.
                hOcBuf:BUFFER-COPY(hWSBuf).

                ASSIGN
                    hOcBuf:BUFFER-FIELD("locked-by"):BUFFER-VALUE = "":U.
                hOcBuf:BUFFER-FIELD("rowMod"):BUFFER-VALUE = "U".

                PUBLISH "logEvent" (INPUT "IMPORT POST-EVENT",
                    INPUT "[":U + STRING(TIME , "HH:MM:SS") + "] Removing lock on workspace after DCU upgrade." + "~n":U,
                    INPUT "":U,
                    INPUT gcRtbCurrentWorkspace,
                    INPUT gcRtbCurrentUser,
                    INPUT "LOG,STATUS":U,
                    INPUT "dynrtb_import.log",
                    INPUT "":U) .

                RUN rtb/proxy/p/rtbSetWorkspaceValues.p ON ghRtbAs
                    (INPUT TABLE-HANDLE hocTT,
                    OUTPUT cError).
            END.

        END.
    END.

    /* Clean up */
    IF VALID-HANDLE(hData) THEN
        DELETE OBJECT hData.

    /* Clean up */
    IF VALID-HANDLE(hOcTT) THEN
        DELETE OBJECT hOcTT.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-evRtbCustGetASConnection) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE evRtbCustGetASConnection Version
PROCEDURE evRtbCustGetASConnection:
    /*------------------------------------------------------------------------------
        Purpose:
        Parameters: <none>
        Notes:
    ------------------------------------------------------------------------------*/
    DEFINE OUTPUT PARAMETER phAS     AS HANDLE      NO-UNDO.

    ASSIGN
        phAS = ghRtbAs.

    IF NOT VALID-HANDLE(phAS) THEN
        RUN evRtbCustSetRTBASConnection("":U).
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ENDIF

&IF DEFINED(EXCLUDE-evRtbCustGetASConnectURL) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE evRtbCustGetASConnectURL Procedure
PROCEDURE evRtbCustGetASConnectURL:
    /*------------------------------------------------------------------------------
        Purpose:
        Parameters: <none>
        Notes:
    ------------------------------------------------------------------------------*/
    DEFINE OUTPUT PARAMETER pcAsConnectURL AS CHARACTER  NO-UNDO.

    IF gcRTBASConnectURL NE "":U THEN
        ASSIGN
            pcAsConnectURL = gcRTBASConnectURL.

    RETURN.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF




&IF DEFINED(EXCLUDE-evRtbCustGetASHandle) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE evRtbCustGetASHandle Procedure
PROCEDURE evRtbCustGetASHandle:
    /*------------------------------------------------------------------------------
            Purpose:
            Notes:
    ------------------------------------------------------------------------------*/
    DEFINE OUTPUT PARAMETER phAS AS HANDLE NO-UNDO.

    ASSIGN
        phAS = ghRtbAS.

    RETURN.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF



&IF DEFINED(EXCLUDE-evRtbCustGetSid) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE evRtbCustGetSid Procedure
PROCEDURE evRtbCustGetSid:
    /*------------------------------------------------------------------------------
            Purpose:
            Notes:
    ------------------------------------------------------------------------------*/
    DEFINE OUTPUT PARAMETER piRtbSid AS INTEGER NO-UNDO.

    ASSIGN
        piRtbSid = giRTBSid.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF



&IF DEFINED(EXCLUDE-evRtbCustGetASConnectString) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE evRtbCustGetASConnectString Procedure
PROCEDURE evRtbCustGetASConnectString :
    /*------------------------------------------------------------------------------
     Purpose:
     Parameters: <none>
     Notes:
 ------------------------------------------------------------------------------*/
    DEFINE OUTPUT PARAMETER pcAsConnectString AS CHARACTER  NO-UNDO.

    DEFINE VARIABLE cHost      AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cService   AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cPartition AS CHARACTER NO-UNDO.

    /* If we have an AppServer connection string, then use this */
    IF gcRTBASConnectString NE "":U THEN
        ASSIGN
            pcAsConnectString = gcRTBASConnectString.
    ELSE
    /* Otherwise - build a new one we can use */
    DO:
        ASSIGN
            pcAsConnectString = (IF gcASHostName NE "":U THEN " -H ":U + gcASHostName ELSE "":U) +
                                (IF gcASPort  NE "":U THEN " -S ":U + gcASPort ELSE "":U) +
                                (IF gcASService NE "":U THEN " -AppService ":U + gcASService ELSE "":U).
    END.

    IF pcAsConnectString BEGINS "AppServer" THEN
        ASSIGN
            gcRTBASConnectString = SUBSTITUTE("-URL &1", pcAsConnectString).

    /*    IF glDebug AND                                                                                  */
    /*        ShowNotifyBallonTips THEN                                                                   */
    /*        glshowNotifyBallonTip ("":U, SUBSTITUTE("Connection string: &1", gcRTBASConnectString), 50).*/

    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-evRtbCustGetCurrentPassword) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE evRtbCustGetCurrentPassword Procedure
PROCEDURE evRtbCustGetCurrentPassword :
    /*------------------------------------------------------------------------------
        Purpose:
        Parameters: <none>
        Notes:
    ------------------------------------------------------------------------------*/
    DEFINE OUTPUT PARAMETER pcUserPassword AS CHARACTER   NO-UNDO.

    pcUserPassword = gcRtbCurrentUserPassword.
    RETURN.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF
&IF DEFINED(EXCLUDE-evRtbCustSetRTBASConnection) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE evRtbCustSetRTBASConnection Version
PROCEDURE evRtbCustSetRTBASConnection:
    /*------------------------------------------------------------------------------
        Purpose: Set the AppServer Connection handle for the RTB AppServer
        Parameters: <none>
        Notes:
    ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER pcContext AS CHARACTER  NO-UNDO.

    DEFINE VARIABLE cError AS CHARACTER NO-UNDO.

    IF CONNECTED("RTB":U) AND
        NOT OEIDEIsRunning THEN
    DO:
        ASSIGN
            ghRtbAS              = SESSION:HANDLE
            gcRTBASConnectString = "":U.
    END.

    IF pcContext = "":U THEN
        RUN evRtbCustGetASConnectString (OUTPUT pcContext).

    IF pcContext BEGINS "AppServer" OR 
        pcContext BEGINS "http://":U THEN 
        ASSIGN
            pcContext = SUBSTITUTE("-URL &1", pcContext).

    ASSIGN
        gcRTBASConnectString = pcContext.

    IF glDebug AND
        glShowNotifyBallonTips THEN
        PUBLISH "showNotifyBallonTip" ("":U, SUBSTITUTE("AppServer connection: &1", gcRTBASConnectString), 50).

    IF gcRTBASConnectString NE "":U THEN
    DO:
        IF NOT VALID-HANDLE(ghRtbAs) THEN
            /* Now create the server and connect it */
            CREATE SERVER ghRtbAs.

        IF NOT ghRtbAs = SESSION:HANDLE THEN
        DO:
            IF NOT ghRtbAs:CONNECTED() THEN
            DO:
                ghRtbAs:CONNECT(SUBSTITUTE("&1", gcRTBASConnectString))NO-ERROR.

                IF ghRtbAs:CONNECTED () THEN
                DO:
                    RUN rtb/proxy/p/rtbSessionLogin.p ON ghRtbAs (
                        INPUT  gcRtbCurrentUser,
                        INPUT  gcRtbCurrentUserPassword,
                        OUTPUT giRTBSid,
                        OUTPUT cError).

                    IF cError NE "":U THEN
                        UNDO, THROW NEW Progress.Lang.AppError ("Roundtable session login error : " + cError, 0).
                END.
                ELSE
                DO:
                    ASSIGN
                        ghRtbAs = ?.
                    UNDO, THROW NEW Progress.Lang.AppError ("AppServer not connected...", 0).
                END.
            END.
        END.
    END.
    ELSE
        ASSIGN
            ghRtbAs = SESSION:HANDLE.

    PUBLISH "evRtbCustSetRTBASHandle" (ghRtbAs).
    IF VALID-OBJECT(oRtbProxyHelper) THEN
        oRtbProxyHelper:AppServerHandle = ghRtbAs.

    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ENDIF


&IF DEFINED(EXCLUDE-evRtbGetCurrentUser) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE evRtbGetCurrentUser Procedure
PROCEDURE evRtbGetCurrentUser :
    /*------------------------------------------------------------------------------
        Purpose:
        Parameters: <none>
        Notes:
    ------------------------------------------------------------------------------*/
    DEFINE OUTPUT PARAMETER pcUserId AS CHARACTER   NO-UNDO.

    ASSIGN
        pcUserId = gcRtbCurrentUser.

    RETURN.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-evRtbGetCurrentWorkspace) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE evRtbGetCurrentWorkspace Procedure
PROCEDURE evRtbGetCurrentWorkspace :
    /*------------------------------------------------------------------------------
        Purpose:
        Parameters: <none>
        Notes:
    ------------------------------------------------------------------------------*/
    DEFINE OUTPUT PARAMETER pcWorkspaceId AS CHARACTER   NO-UNDO.

    ASSIGN
        pcWorkspaceId = gcRtbCurrentWorkspace.

    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-ICFCFM_UpgradeComplete) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE ICFCFM_UpgradeComplete Procedure
PROCEDURE ICFCFM_UpgradeComplete :
    /*------------------------------------------------------------------------------
      Purpose:
      Parameters:  <none>
      Notes:
    ------------------------------------------------------------------------------*/
    DEFINE VARIABLE lOverrideCreated AS LOGICAL   NO-UNDO.
    DEFINE VARIABLE cFileName        AS CHARACTER NO-UNDO.
    DEFINE VARIABLE lActionUnderway  AS LOGICAL   NO-UNDO.
    DEFINE VARIABLE hData            AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hWSBuf           AS HANDLE    NO-UNDO.
    DEFINE VARIABLE cWSLockedBy      AS CHARACTER NO-UNDO.
    DEFINE VARIABLE hOcBuf           AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hOcTT            AS HANDLE    NO-UNDO.
    DEFINE VARIABLE cError           AS CHARACTER NO-UNDO.

    ASSIGN
        cFileName = buildFileSCM(gcRtbCurrentWorkspace).
    ASSIGN
        lOverrideCreated = deleteFile(cFileName).

    IF lOverrideCreated THEN
    DO:
        IF VALID-HANDLE(gshSessionManager) THEN
            /* Delete the actionUnderWay event that was created when the upgrade was started */
            RUN getActionUnderway IN gshSessionManager
                (INPUT  "SCM":U,
                INPUT  "DCUUPGRADE":U,
                INPUT  "":U,
                INPUT  "":U,
                INPUT  "":U,
                INPUT  YES,
                OUTPUT lActionUnderway).
    END. /* lOverrideCreated */
    /* Now that the DCU upgrade has either been completed,
       we need to remove the lock on the workspace. */

    IF NOT VALID-HANDLE(ghRtbAs) THEN
        PUBLISH  "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

    IF VALID-HANDLE(ghRtbAs) THEN
    DO:
        /* Get the workspace record */
        hData = oRtbProxyHelper:rtbGetWorkspaceHandle(gcRtbCurrentWorkspace).

        hWSBuf = hData:DEFAULT-BUFFER-HANDLE.
        hWSBuf:FIND-FIRST() NO-ERROR.
        IF hWSBUf:AVAILABLE THEN
        DO:
            IF INDEX(hWSBuf:BUFFER-FIELD("locked-by"):BUFFER-VALUE, "DCU":U) > 0 THEN
            DO ON ERROR UNDO, THROW:
                /* Create a copy of the original record we received */
                CREATE TEMP-TABLE hOcTT.
                hOcTT:CREATE-LIKE(hData).
                hOcTT:TEMP-TABLE-PREPARE(hWSBuf:NAME).

                hOcBuf = hOcTT:DEFAULT-BUFFER-HANDLE.
                hOcBuf:BUFFER-CREATE.
                hOcBuf:BUFFER-COPY(hWSBuf).

                /* Create another copy to hold the updated values */
                hOcBuf:BUFFER-CREATE.
                hOcBuf:BUFFER-COPY(hWSBuf).

                ASSIGN
                    hOcBuf:BUFFER-FIELD("locked-by"):BUFFER-VALUE = "":U.
                hOcBuf:BUFFER-FIELD("rowMod"):BUFFER-VALUE = "U".

                PUBLISH "logEvent" (
                    INPUT "IMPORT POST-EVENT",
                    INPUT "[":U + STRING(TIME , "HH:MM:SS") + "] Removing lock on workspace after DCU upgrade." + "~n":U,
                    INPUT "":U,
                    INPUT gcRtbCurrentWorkspace,
                    INPUT gcRtbCurrentUser,
                    INPUT "LOG,STATUS":U,
                    INPUT "dynrtb_import.log",
                    INPUT "":U) .

                oRtbProxyHelper:rtbSetRowValues(
                    INPUT "rtbWorkspace",
                    INPUT-OUTPUT TABLE-HANDLE hocTT).

                CATCH err AS Progress.Lang.Error :
                    UNDO, THROW err.
                END CATCH.
            END.
        END.
    END.

    /* Clean up */
    IF VALID-HANDLE(hData) THEN
        DELETE OBJECT hData.

    /* Clean up */
    IF VALID-HANDLE(hOcTT) THEN
        DELETE OBJECT hOcTT.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-ICFCFM_UpgradeStart) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE ICFCFM_UpgradeStart Procedure
PROCEDURE ICFCFM_UpgradeStart :
    /*------------------------------------------------------------------------------
      Purpose:
      Parameters:  <none>
      Notes:
    ------------------------------------------------------------------------------*/
    DEFINE VARIABLE hData            AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hWSBuf           AS HANDLE    NO-UNDO.
    DEFINE VARIABLE cWSLockedBy      AS CHARACTER NO-UNDO.
    DEFINE VARIABLE hOcBuf           AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hOcTT            AS HANDLE    NO-UNDO.
    DEFINE VARIABLE cError           AS CHARACTER NO-UNDO.

    DEFINE VARIABLE lOverrideCreated AS LOGICAL   NO-UNDO.

    DEFINE VARIABLE cFileName        AS CHARACTER NO-UNDO.

    ASSIGN
        cFileName = buildFileSCM(gcRtbCurrentWorkspace).

    ASSIGN
        lOverrideCreated = createFile(cFileName).

    IF lOverrideCreated
        THEN
    DO:
        IF VALID-HANDLE(gshSessionManager) THEN
        DO:
            /* Set the actionUnderWay event that indicates that we are in
               the middle of a DCU update
            */
            RUN setActionUnderway IN gshSessionManager
                (INPUT "SCM":U,
                INPUT "DCUUPGRADE":U,
                INPUT "":U,
                INPUT "":U,
                INPUT "":U).
        END.
    END. /* lOverrideCreated */
    /* Before we start the DCU we have to place a lock on the workspace,
       so that users who try and log on to the workspace during an upgrade are
       prevented from starting the Dynamics environment.  */


    IF NOT VALID-HANDLE(ghRtbAs) THEN
        PUBLISH  "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

    IF VALID-HANDLE(ghRtbAs) THEN
    DO:
        /* Get the workspace record */
        hData = oRtbProxyHelper:rtbGetWorkspaceHandle(gcRtbCurrentWorkspace).

        hWSBuf = hData:DEFAULT-BUFFER-HANDLE.
        hWSBuf:FIND-FIRST() NO-ERROR.
        IF hWSBUf:AVAILABLE THEN
        DO:
            IF INDEX(hWSBuf:BUFFER-FIELD("locked-by"):BUFFER-VALUE, "DCU":U) > 0 THEN
            DO ON ERROR UNDO, THROW:
                /* Create a copy of the original record we received */
                CREATE TEMP-TABLE hOcTT.
                hOcTT:CREATE-LIKE(hData).
                hOcTT:TEMP-TABLE-PREPARE(hWSBuf:NAME).

                hOcBuf = hOcTT:DEFAULT-BUFFER-HANDLE.
                hOcBuf:BUFFER-CREATE.
                hOcBuf:BUFFER-COPY(hWSBuf).

                /* Create another copy to hold the updated values */
                hOcBuf:BUFFER-CREATE.
                hOcBuf:BUFFER-COPY(hWSBuf).

                ASSIGN
                    hOcBuf:BUFFER-FIELD("locked-by"):BUFFER-VALUE = "DCU (Dynamics Upgrade in Process)":U.
                hOcBuf:BUFFER-FIELD("rowMod"):BUFFER-VALUE = "U".

                PUBLISH "logEvent" (INPUT "IMPORT PRE-EVENT",
                    INPUT "[":U + STRING(TIME , "HH:MM:SS") + "] Locking workspace before DCU upgrade starts." + "~n":U,
                    INPUT "":U,
                    INPUT gcRtbCurrentWorkspace,
                    INPUT gcRtbCurrentUser,
                    INPUT "LOG,STATUS":U,
                    INPUT "dynrtb_import.log",
                    INPUT "":U) .

                oRtbProxyHelper:rtbSetRowValues(
                    INPUT "rtbWorkspace",
                    INPUT-OUTPUT TABLE-HANDLE hocTT).

                CATCH err AS Progress.Lang.Error :
                    /***DIAG***/
                    MESSAGE {&line-number} PROGRAM-NAME(1) SKIP
                        err:GetMessage(1)
                        VIEW-AS ALERT-BOX INFO BUTTONS OK.
                END CATCH.
            END.
        END.
    END.

    /* Clean up */
    IF VALID-HANDLE(hData) THEN
        DELETE OBJECT hData.

    IF VALID-HANDLE(hOcTT) THEN
        DELETE OBJECT hOcTT.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-ICFStart_BeforeInitialize) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE ICFStart_BeforeInitialize Procedure
PROCEDURE ICFStart_BeforeInitialize :
    /*------------------------------------------------------------------------------
      Purpose:
      Parameters:  <none>
      Notes:
    ------------------------------------------------------------------------------*/
    DEFINE VARIABLE cSessionTypeRTB       AS CHARACTER NO-UNDO.
    DEFINE VARIABLE iSessionParamLoop     AS INTEGER   NO-UNDO.
    DEFINE VARIABLE cSessionParameters    AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cSessionParamEntry    AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cSessionDefaultConfig AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cSessionDefaultType   AS CHARACTER NO-UNDO.

    ASSIGN
        cSessionDefaultConfig = "icfconfig.xml":U
        cSessionDefaultType   = "Default":U
        cSessionParameters    = SESSION:ICFPARAM.

    blockSessionParam:
    DO iSessionParamLoop = 1 TO NUM-ENTRIES(cSessionParameters):

        ASSIGN
            cSessionParamEntry = ENTRY(iSessionParamLoop, cSessionParameters).

        /* If there are no = or more than one =, this is an invalid parameter, so ignore it. */
        IF NUM-ENTRIES(cSessionParamEntry,"=":U) NE 2 THEN
            NEXT blockSessionParam.

        IF ENTRY(1,cSessionParamEntry,"=":U) = "ICFCONFIG":U THEN
            ASSIGN cSessionDefaultConfig = ENTRY(2,cSessionParamEntry,"=":U).

        IF ENTRY(1,cSessionParamEntry,"=":U) = "ICFSESSTYPE":U THEN
            ASSIGN cSessionDefaultType = ENTRY(2,cSessionParamEntry,"=":U).
    END.

    IF gcRtbCurrentWorkspace NE "":U THEN
        ASSIGN cSessionDefaultType = "rtb_" + REPLACE(gcRtbCurrentWorkspace,"-","").

    IF cSessionDefaultConfig NE "":U THEN
        ASSIGN cSessionTypeRTB = "ICFCONFIG=" + cSessionDefaultConfig.

    IF cSessionDefaultType NE "":U THEN
        ASSIGN cSessionTypeRTB = cSessionTypeRTB + (IF cSessionTypeRTB NE "" THEN "," ELSE "")
                              + "ICFSESSTYPE=" + cSessionDefaultType.

    IF cSessionTypeRTB = "":U THEN
        ASSIGN cSessionTypeRTB = SESSION:ICFPARAM.

    DYNAMIC-FUNCTION ("setSessionParam":U IN THIS-PROCEDURE, "ICFPARAM":U, cSessionTypeRTB ).

    DYNAMIC-FUNCTION ("setSessionParam":U IN THIS-PROCEDURE, "quit_on_end":U, "NO" ).

    DYNAMIC-FUNCTION ("setSessionParam":U IN THIS-PROCEDURE, "shut_on_end":U, "NO" ).
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-import) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE import Procedure
PROCEDURE import :
    /*------------------------------------------------------------------------------
      Purpose:     After import
      Parameter :  pcScmContext       : ""
      / Meaning :  pcScmOther         : Workspace id
                   cErrorMessage : ignored

      Notes:       The main contents of this hook have been moved to the before-assign hook so
                   every movement of an object is captured rather than just via an import.

                   This procedure will be run automatically from Roundtable when an import is
                   completed.

    ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER pcFilename      AS CHARACTER  NO-UNDO.
    DEFINE OUTPUT PARAMETER opReturnMessage AS CHARACTER  NO-UNDO.

    DEFINE VARIABLE iLoop              AS INTEGER   NO-UNDO.
    DEFINE VARIABLE cMessage           AS CHARACTER NO-UNDO.
    DEFINE VARIABLE hHandle            AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hRtbevntp          AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hRtbApi            AS HANDLE    NO-UNDO.
    DEFINE VARIABLE cCompileError      AS CHARACTER NO-UNDO.
    DEFINE VARIABLE lOverrideCreated   AS LOGICAL   NO-UNDO.
    DEFINE VARIABLE lCompile           AS LOGICAL   NO-UNDO.
    DEFINE VARIABLE lViewCompileErrors AS LOGICAL   NO-UNDO.
    DEFINE VARIABLE cFullName          AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cButton            AS CHARACTER NO-UNDO.
    DEFINE VARIABLE lAnswer            AS LOGICAL   NO-UNDO.
    DEFINE VARIABLE hData              AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hWSBuf             AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hOcBuf             AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hOcTT              AS HANDLE    NO-UNDO.

    ASSIGN
        cFullName = findFile(pcFilename).

    IF cFullName <> "":U THEN
    DO:
        /* Check if the workspace is still locked by the import process-
           which will indicate that the import was cancelled. This is the only
           way we can check if the import process has been cancelled. */

        IF NOT VALID-HANDLE(ghRtbAs) THEN
            PUBLISH  "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

        IF VALID-HANDLE(ghRtbAs) THEN
        DO:
            /* Get the workspace record */
            hData = oRtbProxyHelper:rtbGetWorkspaceHandle(gcRtbCurrentWorkspace).

            hWSBuf = hData:DEFAULT-BUFFER-HANDLE.
            hWSBuf:FIND-FIRST() NO-ERROR.
            IF hWSBUf:AVAILABLE THEN
            DO:
                /* Check if the workspace is locked  */
                IF hWSBuf:BUFFER-FIELD("locked-by"):BUFFER-VALUE = "import":U THEN
                DO:
                    /* Delete the log file preventing the hooks from running. */
                    ASSIGN
                        lOverrideCreated = deleteFile(pcFilename).
                    /* Show a message to the user */
                    cMessage = "The import process was cancelled. The DCU upgrade process will therefore also be cancelled. " + "~n":U.
                    MESSAGE cMessage
                        VIEW-AS ALERT-BOX INFO
                        TITLE "DCU Upgrade":U.
                    RETURN.
                END.
            END.
        END.

        cMessage = "Before running the DCU it is necessary to compile all of the objects in the DCU and RTB modules." + "~n":U + "~n":U +
            "This will ensure that the latest version of the source code for the DCU and RTB procedures is being run. ".

        MESSAGE
            cMessage
            VIEW-AS ALERT-BOX INFO
            TITLE "RTB and Dynamics pre DCU upgrade compilation":U.

        /* Compile the DCU and framework code before start the DCU */
        RUN compileModules (INPUT "*dcu*,*rtb*,*af-aaa*,*af-app*",
            INPUT NO /* Show errors */).

        /* Kill all running environment plips.
           This only needs to be done if the DCU is to be run and should only be done once the messages
           above have been displayed correctly - as we use the session manage rto display the messages
        */

        PUBLISH "logEvent" (INPUT "IMPORT EVENT",
            INPUT "[":U + STRING(TIME , "HH:MM:SS") + "] Shutting down Dynamics environment ...",
            INPUT "":U,
            INPUT gcRtbCurrentWorkspace,
            INPUT gcRtbCurrentUser,
            INPUT "LOG,STATUS":U,
            INPUT "dynrtb_import.log",
            INPUT "":U) .

        /* The Configuration Manager is responsible for shutting down the environment */
        IF VALID-HANDLE(hConfMan) THEN
            APPLY "CLOSE":U TO hConfMan.

        /* As we may not have the SCM procedures shut down yet, as the event              */
        /* ICFCFM_StartSessionShutdown may NOT have been published from the               */
        /* configuration manager, we publish it separately to force the SCM               */
        /* procedures referencing the ICFDB database to shut down before we start the DCU */
        PUBLISH "ICFCFM_SessionShutdown".
        PUBLISH "logEvent" (INPUT "IMPORT EVENT",
            INPUT "[":U + STRING(TIME , "HH:MM:SS") + "] Running Dynamics Configuration Utility ..." + "~n":U,
            INPUT "":U,
            INPUT gcRtbCurrentWorkspace,
            INPUT gcRtbCurrentUser,
            INPUT "LOG,STATUS":U,
            INPUT "dynrtb_import.log",
            INPUT "":U) .

        PUBLISH "ICFCFM_UpgradeStart".

        RUN icfcfg.w.

        IF NOT glDCUCancelled THEN
        DO:
            PUBLISH "ICFCFM_UpgradeComplete".
            /* If the DCU has not been cancelled, then we continue with the rest of the
               post import processing */

            PUBLISH "logEvent" (INPUT "IMPORT EVENT",
                INPUT "[":U + STRING(TIME , "HH:MM:SS") + "] Dynamics Configuration Utility Upgrade Complete." + "~n":U,
                INPUT "":U,
                INPUT gcRtbCurrentWorkspace,
                INPUT gcRtbCurrentUser,
                INPUT "LOG,STATUS":U,
                INPUT "dynrtb_import.log",
                INPUT "":U).


            /* To ensure that the Framework is restarted with the correct session type settings,
               ICFSTART_beforeInitialize procedure has been added - this works in the same
               way as the procedure with the same name in rtb/prc/ryrtbevntp.p.
            */
            cMessage = "Before running the second stage of the DCU it is necessary to compile all of the objects in the DCU, RTB and essential framework modules." + "~n":U + "~n":U +
                "This will ensure that the latest version of the source code for the DCU, RTB and essential framework procedures are being run. ".

            MESSAGE
                cMessage
                VIEW-AS ALERT-BOX INFO
                TITLE "RTB and Dynamics post DCU upgrade compulsory compilation":U.

            /* Compile the DCU and framework code before re-starting the framework */
            RUN compileModules (INPUT "*dcu*,*rtb*,*af-app*,*ry-app*",
                INPUT YES /* Show errors */).
        END.
        ELSE
            PUBLISH "logEvent" (INPUT "IMPORT EVENT",
                INPUT "[":U + STRING(TIME , "HH:MM:SS") + "] Dynamics Configuration Utility Upgrade Cancelled." + "~n":U,
                INPUT "":U,
                INPUT gcRtbCurrentWorkspace,
                INPUT gcRtbCurrentUser,
                INPUT "LOG,STATUS":U,
                INPUT "dynrtb_import.log",
                INPUT "":U).

        /* Delete the lock file preventing the integration hooks from running */
        ASSIGN
            lOverrideCreated = deleteFile(pcFilename).

        IF lOverrideCreated THEN
        DO:

        END. /* lOverrideCreated */
        /* Re-start the Framework. */
        PUBLISH "logEvent" (INPUT "IMPORT EVENT",
            INPUT "[":U + STRING(TIME , "HH:MM:SS") + "] Re-starting Dynamics Environment." + "~n":U,
            INPUT "":U,
            INPUT gcRtbCurrentWorkspace,
            INPUT gcRtbCurrentUser,
            INPUT "LOG,STATUS":U,
            INPUT "dynrtb_import.log",
            INPUT "":U) .

        RUN icfstart.p.

        PUBLISH "logEvent" (INPUT "IMPORT EVENT",
            INPUT "[":U + STRING(TIME , "HH:MM:SS") + "] Dynamics Environment started." + "~n":U,
            INPUT "":U,
            INPUT gcRtbCurrentWorkspace,
            INPUT gcRtbCurrentUser,
            INPUT "LOG,STATUS":U,
            INPUT "dynrtb_import.log",
            INPUT "":U) .

    END. /* IF cFullName <> "":U */

    /* Write a closing comment to the import log file */
    ASSIGN
        cMessage = "[":U + STRING(TODAY) + " - ":U + STRING(TIME, "HH:MM:SS") + "] ":U +
                    "Import Pre-Processing Complete for Workspace : ":U + gcRtbCurrentWorkspace.

    PUBLISH "logEvent" (INPUT "IMPORT EVENT":U,
        INPUT cMessage,
        INPUT "":U,
        INPUT gcRtbCurrentWorkspace,
        INPUT gcRtbCurrentUser,
        INPUT "LOG":U,
        INPUT "dynrtb_import.log",
        INPUT "":U) .

    /* Clean up */
    IF VALID-HANDLE(hData) THEN
        DELETE OBJECT hData.

    IF VALID-HANDLE(hOcTT) THEN
        DELETE OBJECT hOcTT.

    RETURN.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-importBefore) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE importBefore Procedure
PROCEDURE importBefore :
    /*------------------------------------------------------------------------------
      Purpose   : Before import
      Parameter :
      Notes     : This procedure will be run automatically from Roundtable when an import is started.
    ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER pcFilename      AS CHARACTER  NO-UNDO.
    DEFINE OUTPUT PARAMETER opErrorMessage  AS CHARACTER  NO-UNDO.

    DEFINE VARIABLE lUpgrade         AS LOGICAL   NO-UNDO.
    DEFINE VARIABLE lChoice          AS LOGICAL   NO-UNDO.
    DEFINE VARIABLE lOverrideCreated AS LOGICAL   NO-UNDO.
    DEFINE VARIABLE cMessage         AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cDCUObjectList   AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cImportObject    AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cImportPmod      AS CHARACTER NO-UNDO.
    DEFINE VARIABLE hData            AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hQry             AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hBuf             AS HANDLE    NO-UNDO.
    DEFINE VARIABLE lAnswer          AS LOGICAL   NO-UNDO INITIAL FALSE.

    IF NOT VALID-HANDLE(ghRtbAs)  THEN
        PUBLISH "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

    ASSIGN
        lChoice          = YES
        lOverrideCreated = NO.

    ASSIGN
        cMessage = "[":U + STRING(TODAY) + " ":U + STRING(TIME, "HH:MM:SS") + "] ":U +
                     "ImportBefore Pre-Processing for workspace : ":U + gcRtbCurrentWorkspace.

    PUBLISH "logEvent" (INPUT "IMPORT-BEFORE PRE-EVENT":U,
        INPUT cMessage,
        INPUT "":U,
        INPUT gcRtbCurrentWorkspace,
        INPUT gcRtbCurrentUser,
        INPUT "LOG":U,
        INPUT "dynrtb_import.log",
        INPUT "OVERWRITE":U) .

    /*  Check if there are DCU files in the import that should result in a DCU session being run after the import. */
    /*                                                                                                             */
    /*  This is done by searching for the following objects :                                                      */
    /*  icfsetup.xml                                                                                               */
    /*  *patch.xml                                                                                                 */
    /*  setup.xml e.g. setup20A01.xml                                                                              */
    /*                                                                                                             */
    /*  This is only necessary to do in the *af-aaa and *db-icfdfd modules - where these objects will be located   */

    /* First set the upgrade status to be NO */
    ASSIGN
        lUpgrade = NO.

    hData = oRtbProxyHelper:rtbGetWorkspaceImportsHandle(gcRtbCurrentWorkspace).

    CREATE QUERY hQry.
    hBuf = hData:DEFAULT-BUFFER-HANDLE.
    hQry:SET-BUFFERS(hBuf).
    hQry:QUERY-PREPARE("FOR EACH " + hData:NAME).
    hQry:QUERY-OPEN.
    hQry:GET-FIRST.
    DO WHILE NOT hQry:QUERY-OFF-END:
        ASSIGN
            cImportObject = hBuf:BUFFER-FIELD("object"):BUFFER-VALUE
            cImportPmod   = hBuf:BUFFER-FIELD("pmod"):BUFFER-VALUE.

        /* Only look for certain files in the af-aa and db-icfdfd modules */
        IF (cImportPmod MATCHES "*db-icfdfd":U OR
            cImportPmod MATCHES "*af-aaa":U) THEN
            IF (cImportObject = "icfsetup.xml":U      OR
                cImportObject MATCHES "*patch~.xml":U OR
                cImportObject MATCHES "*setup*~.xml":U) AND
                (NOT hBuf:BUFFER-FIELD("done"):BUFFER-VALUE ) THEN
            DO:
                ASSIGN
                    cDcuObjectList = IF cDcuObjectList = "":U THEN cImportObject + "~n":U ELSE cDcuObjectList + cImportObject + "~n":U.
                ASSIGN
                    lUpgrade = YES.
            END.
        hQry:GET-NEXT.
    END.

    IF lUpgrade THEN
    DO:
        ASSIGN
            cMesWinTitle   = "Roundtable Import / DCU Extensions (Dynamics Enhancement)":U
            cMesWinMessage = "The IMPORT contains object(s) that are used by the Progress Dynamics Configuration Utility (DCU)." + "~n":U +
                                   "The following DCU objects are included in the import : " + "~n":U +
                                   cDcuObjectList + "~n":U +
                                   "This Import will be flagged as an Version Upgrade." + "~n":U + "~n":U +
                                   "The Progress Dynamics Configuration Utility (DCU) is a deployment utility used to automate the installation" +
                                   "of an upgrade to an application. Updates to Progress Dynamics are applied using the DCU." + "~n":U + "~n":U +
                                   "When working with Progress Dynamics through Roundtable, the DCU still must be run as part of the upgrade" +
                                   "to the receipt workspace, i.e. the workspace used to receipt the latest version of Progress Dynamics into it." +
                                   "The issue with Roundtable is that the updates installed by the DCU need to be applied to the other workspaces" +
                                   "managed in Roundtable, and these are managed through Roundtable by doing standard Roundtable imports." + "~n":U + "~n":U +
                                   "The DCU manages schema deltas, loading data, and running fix programs at various stages of the upgrade cycle " +
                                   "that typically must be done in a strict sequence that cannot be replicated by the standard Roundtable import process." +
                                   "The workspace import process therefore needs to integrate with the DCU in cases where an upgrade is being propagated" +
                                   "through the workspaces." + "~n":U + "~n":U +
                                    "The impact of cancelling a Version Upgrade is severe and could corrupt your Roundtable environment" +
                                   "Ensure you understand the impact of cancelling a Version Upgrade" + "~n":U + "~n":U +
                                   "Do you want to Continue with the Version Upgrade or Cancel and continue with a normal Import ?" + "~n":U + "~n":U +
                                   "(Yes) - Version Upgrade / (No) - Normal Import".

        MESSAGE
            cMesWinMessage
            VIEW-AS ALERT-BOX QUESTION
            BUTTONS YES-NO
            TITLE cMesWinTitle
            UPDATE lAnswer.

        IF lAnswer THEN
            lUpgrade = YES.
        ELSE
            lUpgrade = NO.
    END. /* IF lUpgrade */

    /* Make sure we have a valid handle to the session manager. If not, then the selective compile of the DCU procedures will
       be done without asking the user.*/
    IF lUpgrade THEN
    DO:
        ASSIGN
            cMesWinMessage = "For the Version Upgrade to continue, the DCU needs to update the Progress Dynamics Repository." + "~n":U + "~n":U +
                         "Please ensure ALL other connections has been shutdown before continueing" + "~n":U +
                         " - Client-Server" + "~n":U +
                         " - WebClient" + "~n":U +
                         " - Appserver agents & brokers" + "~n":U +
                         " - Webspeed Server agents & brokers".
        MESSAGE
            cMesWinMessage
            VIEW-AS ALERT-BOX INFO
            TITLE "Roundtable / DCU Extensions".

        ASSIGN
            cMesWinTitle   = "Roundtable Import / DCU Extensions (Dynamics Enhancement)":U
            cMesWinMessage = "Have you shutdown all other running session and servers ?" + "~n":U + "~n":U +
                                   "Should the Upgrade continue or do you wish to Cancel the Upgrade Process ?" + "~n":U + "~n":U +
                                   "(Yes) - Continue with Version Upgrade / (No) - Cancel Version Upgrade".

        MESSAGE
            cMesWinMessage
            VIEW-AS ALERT-BOX QUESTION
            BUTTONS YES-NO
            TITLE cMesWinTitle
            UPDATE lAnswer.

        IF lAnswer THEN
            ASSIGN opErrorMessage = "":U.
        ELSE
        DO:
            ASSIGN
                opErrorMessage = "Cancelled":U.
            RETURN.
        END.
    END. /* IF lUpgrade */

    IF lUpgrade THEN
    DO:
        ASSIGN
            lOverrideCreated = createFile(pcFilename).

        /* Continue with IMPORT without any Hooks or Replication */
        IF lOverrideCreated THEN
        DO:
        /* The code to disable the replication triggers has been placed in the event procedure ICFCFM_UpgradeStart - which is triggered from the DCU when it starts  */
        END. /* lOverrideCreated */
    END. /* IF lUpgrade */

    /* Write the status of the upgrade process to the log file */
    ASSIGN
        cMessage = "[":U + STRING(TIME, "HH:MM:SS":U) + "] Running RTB / DCU Integration Upgrade : " + STRING(lUpgrade) + ".":U + "~n":U.
    /* Warn the user that the logging is not going ot show the normal processing of objects being
      ASSIGNed or DELETEd from the workspace - as the integration hooks (rtb/prc/ryrtbevnt.p) has
      is disabled when running in upgrade mode
   */
    IF lUpgrade THEN
        ASSIGN
            cMessage = cMessage + "NOTE: Separate events for objects being imported into the workspace will not be logged.".

    PUBLISH "logEvent" (INPUT "IMPORT-BEFORE PRE-EVENT",
        INPUT cMessage,
        INPUT "":U,
        INPUT gcRtbCurrentWorkspace,
        INPUT gcRtbCurrentUser,
        INPUT "LOG":U,
        INPUT "dynrtb_import.log",
        INPUT "":U) .
    RETURN.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-initRTB) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE initRTB Procedure
PROCEDURE initRTB :
    /*------------------------------------------------------------------------------
      Purpose:
      Parameters:  <none>
      Notes:
    ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext2         AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    /* Make sure we have 5 entries here - as this may not have been implemented for all versions of the plugin */
    IF NUM-ENTRIES(pcOther) = 5 THEN
        ASSIGN
            gcRTBASConnectURL = ENTRY(5, pcOther).

    /* Set the current workspace  */
    ASSIGN
        gcRtbCurrentWorkspace = ENTRY(4, pcOther).

    RUN evRtbCustSetRTBASConnection(INPUT gcRTBASConnectURL).

    /* Get the RTB Session ID */
    IF NOT OEIDEIsRunning THEN
        PUBLISH "evRtbCustGetSid":U (OUTPUT giRTBSid).

    PUBLISH "changeWorkspace" (
        INPUT  pcEvent,
        INPUT  pcContext,
        INPUT  gcRtbCurrentWorkspace,
        OUTPUT pcErrorMessage).

    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-killPlip) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE killPlip Procedure
PROCEDURE killPlip :
    /*------------------------------------------------------------------------------
      Purpose:     entry point to instantly kill the plip if it should get lost in memory
      Parameters:  <none>
      Notes:
    ------------------------------------------------------------------------------*/
    IF VALID-HANDLE(ghRtbAS) AND
        ghRtbAS NE SESSION:HANDLE THEN
        IF ghRtbAS:CONNECTED () THEN
        DO:
            oRtbProxyHelper:rtbSessionLogout (giRTBSid).

            ghRtbAS:DISCONNECT().
            DELETE OBJECT ghRtbAS.
        END.

        {ry/app/ryplipkill.i}

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-logEvent) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE logEvent Procedure
PROCEDURE logEvent :
    /*------------------------------------------------------------------------------
      Purpose:     Process log messages being published from various event
                   handler procedures.
      Parameters:  <none>
      Notes:
    ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER pcEvent        AS CHARACTER  NO-UNDO.
    DEFINE INPUT  PARAMETER pcEventMessage AS CHARACTER  NO-UNDO.
    DEFINE INPUT  PARAMETER pcMessageType  AS CHARACTER  NO-UNDO.
    DEFINE INPUT  PARAMETER pcWorkspace    AS CHARACTER  NO-UNDO.
    DEFINE INPUT  PARAMETER pcUserId       AS CHARACTER  NO-UNDO.
    DEFINE INPUT  PARAMETER pcLogOutPut    AS CHARACTER  NO-UNDO.
    DEFINE INPUT  PARAMETER pcLogFile      AS CHARACTER  NO-UNDO.
    DEFINE INPUT  PARAMETER pcOther        AS CHARACTER  NO-UNDO.

    DEFINE VARIABLE cButton AS CHARACTER NO-UNDO.

    /* Set default properties if they have not been passed in */
    IF pcMessageType = "":U THEN
        ASSIGN pcMessageType = "INFORMATION".

    /* If no log file is specified, then use the default dynrtb-log.txt file */
    IF pcLogFile = "":U THEN
        ASSIGN pcLogFile = "dynrtb_log.log".

    IF pcLogOutput = "":U THEN
        ASSIGN pcLogOutput = "MESSAGE":U.

    IF LOOKUP("STATUS":U, pcLogOutPut) > 0 THEN
    DO:
        PUBLISH "evRtbSetStatusMessage":U (INPUT pcEventMessage).
    END. /*IF LOOKUP("STATUS":U, pcLogOutPut) > 0 ... */


    IF LOOKUP("LOG":U, pcLogOutPut) > 0 THEN
    DO:
        IF LOOKUP("OVERWRITE":U, pcOther) > 0 THEN
            OUTPUT TO VALUE(pcLogFile).
        ELSE
            OUTPUT TO VALUE(pcLogFile) APPEND.
        PUT UNFORMATTED pcEventMessage SKIP.
        OUTPUT CLOSE.
    END. /*IF LOOKUP("LOG":U, pcLogOutPut) > 0 ... */

    IF LOOKUP("MESSAGE":U, pcLogOutPut) > 0 THEN
    DO:
        MESSAGE
            pcEventMessage
            VIEW-AS ALERT-BOX INFORMATION
            BUTTONS OK.
    END. /*IF LOOKUP("MESSAGE":U, pcLogOutPut) > 0 ... */
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF


&IF DEFINED(EXCLUDE-login) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE login Procedure
PROCEDURE login:
    /*------------------------------------------------------------------------------
                Purpose   :
     Parameters:  <none>
     Notes:
   ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcEvent            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext          AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOther            AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcContext2         AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcErrorMessage     AS CHARACTER NO-UNDO.

    DEFINE VARIABLE cUserName      AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cUserPassword  AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cConnectString AS CHARACTER NO-UNDO.

    ASSIGN
        gcASHostName  = ENTRY(1, pcOther)
        gcASPort      = ENTRY(2, pcOther)
        gcASService   = ENTRY(3, pcOther)
        cUserName     = ENTRY(4, pcOther)
        cUserPassword = ENTRY(5, pcOther).

    IF NUM-ENTRIES(pcOther) = 6 THEN
        gcRTBASConnectURL = TRIM(ENTRY(6, pcOther)).

    RUN setRtbCurrentUser (
        INPUT cUserName,
        INPUT cUserPassword).

    IF gcRTBASConnectURL NE "":U THEN
        RUN evRtbCustSetRTBASConnection (gcRTBASConnectURL).

    ASSIGN
        pcErrorMessage = "":U NO-ERROR.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF


&IF DEFINED(EXCLUDE-overrideCheck) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE overrideCheck Procedure
PROCEDURE overrideCheck :
    /*------------------------------------------------------------------------------
      Purpose:
      Parameters:  <none>
      Notes:
    ------------------------------------------------------------------------------*/

    DEFINE INPUT  PARAMETER cCheckType              AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER opReturnMessage          AS CHARACTER NO-UNDO.

    DEFINE VARIABLE cFullFileName AS CHARACTER NO-UNDO.

    ASSIGN
        cFullFileName = buildFileSCM(gcRtbCurrentWorkspace).

    CASE cCheckType:
        WHEN "VALIDATE":U THEN
            DO:
                IF SEARCH(cFullFileName) <> ? THEN
                DO:
                    ASSIGN
                        opReturnMessage = "FOUND":U.
                END.
                ELSE
                    ASSIGN opReturnMessage = "":U.
            END.
        WHEN "CREATE":U THEN
            DO:
                OUTPUT STREAM sOut TO VALUE(cFullFileName).
                PUT STREAM sOut UNFORMATTED
                    TODAY "^" STRING(TIME) "^" TIME.
                OUTPUT STREAM sOut CLOSE.
            END.
        WHEN "DELETE":U THEN
            DO:
                OS-DELETE VALUE(cFullFileName).
            END.
    END CASE.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-plipSetup) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE plipSetup Procedure
PROCEDURE plipSetup :
    /*------------------------------------------------------------------------------
      Purpose:    Run by main-block of PLIP at startup of PLIP
      Parameters: <none>
      Notes:
    ------------------------------------------------------------------------------*/
    DEFINE VARIABLE iCount AS INTEGER   NO-UNDO.
    DEFINE VARIABLE cTitle AS CHARACTER NO-UNDO.

    {ry/app/ryplipsetu.i}

    IF CONNECTED("RTB") THEN
    DO:
        /* Get the current workspace  */
        PUBLISH "evRtbGetCurrentWorkspace":U (OUTPUT gcRtbCurrentWorkspace).

        /* Get the current user */
        PUBLISH "evRtbGetCurrentUser":U (OUTPUT gcRtbCurrentUser).

        /* Get the RTB Session ID */
        PUBLISH "evRtbGetSid":U (OUTPUT giRTBSid).

        /* check if we should be shwoing notifyicon balloontips */
        PUBLISH "evRtbCustGetShowNotifyBallonTips" (OUTPUT glShowNotifyBallonTips).
    END.

    PUBLISH "evRtbCustGetDebug" (OUTPUT glDebug).

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-plipShutdown) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE plipShutdown Procedure
PROCEDURE plipShutdown :
    /*------------------------------------------------------------------------------
      Purpose:     This procedure will be run just before the calling program
                   terminates
      Parameters:  <none>
      Notes:
    ------------------------------------------------------------------------------*/
    /* Clean up RTB API handle */
    IF VALID-HANDLE(hRtbApi) THEN
    DO:
        DELETE PROCEDURE hRtbApi.
        ASSIGN
            hRtbAPi = ?.
    END.

    IF VALID-OBJECT(oRtbProxyHelper) THEN
        DELETE OBJECT oRtbProxyHelper.

        {ry/app/ryplipshut.i}

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-processPreEvent) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE processPreEvent Procedure
PROCEDURE processPreEvent :
    /*------------------------------------------------------------------------------
      Purpose:
      Parameters:  <none>
      Notes:
    ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcScmEvent                 AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcScmContext               AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcScmOther                 AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER  pcScmContext2              AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER  opScmErrorMessage          AS CHARACTER NO-UNDO.

    DEFINE VARIABLE cFileName      AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cFullName      AS CHARACTER NO-UNDO.
    DEFINE VARIABLE hLoopHandle    AS HANDLE    NO-UNDO.
    DEFINE VARIABLE cUserName      AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cUserPassword  AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cConnectString AS CHARACTER NO-UNDO.

    /* Start the oRtbProxyHelper object - if it is available */
    IF NOT VALID-OBJECT(oRtbProxyHelper) THEN
    DO:
        oRtbProxyHelper = scm.custom.rtb.Env:RTBProxyHelper.

        IF VALID-HANDLE(ghRtbAs) AND
            oRtbProxyHelper:AppServerhandle NE ghRtbAs THEN
            oRtbProxyHelper:AppServerhandle = ghRtbAs.
    END.

    /* Get the handle of the configuration manager */
    IF NOT VALID-HANDLE(hConfMan) THEN
    DO:
        hLoopHandle = SESSION:FIRST-PROCEDURE.
        DO WHILE VALID-HANDLE(hLoopHandle):
            IF R-INDEX(hLoopHandle:FILE-NAME,"afxmlcfgp.p":U) > 0 OR
                R-INDEX(hLoopHandle:FILE-NAME,"afxmlcfgp.r":U) > 0 THEN
            DO:
                hConfMan = hLoopHandle.
                hLoopHandle = ?.
            END.
            ELSE
                hLoopHandle = hLoopHandle:NEXT-SIBLING.
        END. /* VALID-HANDLE(hLoopHandle) */
    END.

    ASSIGN
        cFileName = buildFileSCM(gcRtbCurrentWorkspace)
        cFullName = "":U.

    CASE pcScmEvent:
        WHEN "processImportBefore":U THEN
        RUN importBefore (INPUT cFileName, OUTPUT opScmErrorMessage).

        WHEN "processImport":U THEN
        RUN import (INPUT cFileName, OUTPUT opScmErrorMessage).

        WHEN "logout":U THEN
        RUN killPlip.

        WHEN  "init":U THEN
        RUN initRTB (INPUT pcScmEvent, INPUT pcScmContext, INPUT pcScmOther, INPUT pcScmContext2, OUTPUT opScmErrorMessage).

        WHEN  "login" THEN
        RUN login (INPUT pcScmEvent, INPUT pcScmContext, INPUT pcScmOther, INPUT pcScmContext2, OUTPUT opScmErrorMessage).

    /*      WHEN "login":U THEN                                                  */
    /*         DO:                                                               */
    /*            ASSIGN                                                         */
    /*               cUserName      = ENTRY(4, pcScmOther)                       */
    /*               cUserPassword  = ENTRY(5, pcScmOther)                       */
    /*               cConnectString = TRIM(REPLACE(pcScmOther, cUserName, "":U)).*/
    /*            RUN setRtbCurrentUser (INPUT cUserName, INPUT cUserPassword).  */
    /*            RUN setRTBASConnection (INPUT cConnectString).                 */
    /*         END.                                                              */
    END CASE.

    cFullName = findFile(cFileName).

    IF opScmErrorMessage = "":U THEN
        ASSIGN opScmErrorMessage = cFullName.

    RETURN.

END PROCEDURE.


/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF
&IF DEFINED(EXCLUDE-setRtbCurrentUser) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE setRtbCurrentUser Procedure
PROCEDURE setRtbCurrentUser :
    /*------------------------------------------------------------------------------
        Purpose:
        Parameters: <none>
        Notes:
    ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER pcCurrentUser         AS CHARACTER  NO-UNDO.
    DEFINE INPUT  PARAMETER pcCurrentUserPassword AS CHARACTER  NO-UNDO.

    ASSIGN
        gcRtbCurrentUser         = pcCurrentUser
        gcRtbCurrentUserPassword = pcCurrentUserPassword.

    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-setRtbCurrentWorkspace) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE setRtbCurrentWorkspace Procedure
PROCEDURE setRtbCurrentWorkspace :
    /*------------------------------------------------------------------------------
        Purpose:
        Parameters: <none>
        Notes:
    ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER pcCurrentWorkspace AS CHARACTER  NO-UNDO.

    ASSIGN
        gcRtbCurrentWorkspace = pcCurrentWorkspace.

    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-setRTBSessionType) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE setRTBSessionType Procedure
PROCEDURE setRTBSessionType :
    /*------------------------------------------------------------------------------
      Purpose:
      Parameters:  <none>
      Notes:
    ------------------------------------------------------------------------------*/
    DEFINE VARIABLE cSessionTypeRTB       AS CHARACTER NO-UNDO.

    DEFINE VARIABLE iSessionParamLoop     AS INTEGER   NO-UNDO.
    DEFINE VARIABLE cSessionParameters    AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cSessionParamEntry    AS CHARACTER NO-UNDO.

    DEFINE VARIABLE cSessionDefaultConfig AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cSessionDefaultType   AS CHARACTER NO-UNDO.

    ASSIGN
        cSessionDefaultConfig = "icfconfig.xml":U
        cSessionDefaultType   = "Default":U
        cSessionParameters    = SESSION:ICFPARAM.

    blockSessionParam:
    DO iSessionParamLoop = 1 TO NUM-ENTRIES(cSessionParameters):
        ASSIGN
            cSessionParamEntry = ENTRY(iSessionParamLoop, cSessionParameters).

        /* If there are no = or more than one =, this is an invalid parameter, so ignore it. */
        IF NUM-ENTRIES(cSessionParamEntry,"=":U) <> 2 THEN
            NEXT blockSessionParam.

        IF ENTRY(1,cSessionParamEntry,"=":U) = "ICFCONFIG":U THEN
            ASSIGN cSessionDefaultConfig = ENTRY(2,cSessionParamEntry,"=":U).

        IF ENTRY(1,cSessionParamEntry,"=":U) = "ICFSESSTYPE":U THEN
            ASSIGN cSessionDefaultType = ENTRY(2,cSessionParamEntry,"=":U).
    END.

    IF gcRtbCurrentWorkspace <> "":U THEN
        ASSIGN cSessionDefaultType = "rtb_" + REPLACE(gcRtbCurrentWorkspace,"-","").

    IF cSessionDefaultConfig <> "":U THEN
        ASSIGN cSessionTypeRTB = "ICFCONFIG=" + cSessionDefaultConfig.

    IF cSessionDefaultType <> "":U THEN
        ASSIGN cSessionTypeRTB = cSessionTypeRTB + (IF cSessionTypeRTB <> "" THEN "," ELSE "")
           + "ICFSESSTYPE=" + cSessionDefaultType.

    IF cSessionTypeRTB = "":U THEN
        ASSIGN cSessionTypeRTB = SESSION:ICFPARAM.

    DYNAMIC-FUNCTION ("setSessionParam":U IN THIS-PROCEDURE, "ICFPARAM":U, cSessionTypeRTB ).
    DYNAMIC-FUNCTION ("setSessionParam":U IN THIS-PROCEDURE, "quit_on_end":U, "NO" ).
    DYNAMIC-FUNCTION ("setSessionParam":U IN THIS-PROCEDURE, "shut_on_end":U, "NO" ).
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

/* ************************  Function Implementations ***************** */

&IF DEFINED(EXCLUDE-buildFileSCM) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION buildFileSCM Procedure
FUNCTION buildFileSCM RETURNS CHARACTER
    ( INPUT pcFilename AS CHARACTER ) :
    /*------------------------------------------------------------------------------
      Purpose:
        Notes:
    ------------------------------------------------------------------------------*/

    DEFINE VARIABLE cFileDir      AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cFileName     AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cFullFileName AS CHARACTER NO-UNDO.

    ASSIGN
        cFileDir      = RIGHT-TRIM(REPLACE(SESSION:TEMP-DIRECTORY,"~\":U,"~/":U),"~/":U)
        cFilename     = TRIM(pcFilename + ".log","~/":U)
        cFullFileName = cFileDir + "~/":U + cFilename
        .

    RETURN cFullFileName.   /* Function return value. */

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-createFile) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION createFile Procedure
FUNCTION createFile RETURNS LOGICAL
    ( INPUT pcFilename AS CHARACTER ) :
    /*------------------------------------------------------------------------------
      Purpose:
        Notes:
    ------------------------------------------------------------------------------*/

    DEFINE VARIABLE cFileExist AS CHARACTER NO-UNDO.

    OUTPUT STREAM sOut TO VALUE(pcFilename).
    PUT STREAM sOut UNFORMATTED
        TODAY "^" STRING(TIME) "^" TIME
        .
    OUTPUT STREAM sOut CLOSE.

    cFileExist = findFile(pcFilename).

    IF cFileExist <> "":U
        THEN RETURN TRUE.
    ELSE RETURN FALSE.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-deleteFile) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION deleteFile Procedure
FUNCTION deleteFile RETURNS LOGICAL
    ( INPUT pcFilename AS CHARACTER ) :
    /*------------------------------------------------------------------------------
      Purpose:
        Notes:
    ------------------------------------------------------------------------------*/

    DEFINE VARIABLE cFileExist AS CHARACTER NO-UNDO.

    OS-DELETE VALUE(pcFilename).

    cFileExist = findFile(pcFilename).

    IF cFileExist <> "":U
        THEN RETURN FALSE.
    ELSE RETURN TRUE.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-findFile) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION findFile Procedure
FUNCTION findFile RETURNS CHARACTER
    ( INPUT pcFilename AS CHARACTER ) :
    /*------------------------------------------------------------------------------
      Purpose:
        Notes:
    ------------------------------------------------------------------------------*/

    FILE-INFO:FILENAME = SEARCH(pcFilename).

    IF FILE-INFO:FULL-PATHNAME = ?
        THEN
        RETURN "":U.
    ELSE
    DO:
        IF  FILE-INFO:FILE-MOD-DATE = TODAY
            OR (FILE-INFO:FILE-MOD-DATE = TODAY - 1
            AND FILE-INFO:FILE-MOD-TIME > TIME)
            THEN
            RETURN FILE-INFO:FULL-PATHNAME.
        ELSE
            RETURN "":U.
    END.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF
