&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v8r12
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Check Version Notes Wizard" Procedure _INLINE
/* Actions: af/cod/aftemwizcw.w ? ? ? ? */
/* Update Version Notes Wizard
Check object version notes.
af/cod/aftemwizpw.w
*/
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Update-Object-Version" Procedure _INLINE
/* Actions: ? ? ? ? af/sup/afverxftrp.p */
/* This has to go above the definitions sections, as that is what it modifies.
   If its not, then the definitions section will have been saved before the
   XFTR code kicks in and changes it */
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Definition Comments Wizard" Procedure _INLINE
/* Actions: ? af/cod/aftemwizcw.w ? ? ? */
/* Program Definition Comment Block Wizard
Welcome to the Program Definition Comment Block Wizard. Press Next to proceed.
af/cod/aftemwizpw.w
*/
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Procedure 
/*********************************************************************
* Copyright (C) 2006-2014 by Roundtable Software Inc. ("Roundtable"),*
*  All Rights Reserved.                                              *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
*                                                                    *
*********************************************************************/
/*---------------------------------------------------------------------------------
  File: ryreplicat.p

  Description:  SCM Replication Trigger Code

  Purpose:      This procedure is called from replication triggers for SCM control. It is used
                to do all SCM  checks such as whether the object is checked out in a valid
                task, etc.
                These hooks can be disabled if no SCM is being used, either by
                disconnecting the RVDB database or setting the flag on the security
                control table that disables all SCM checks - i.e. this file.

  Parameters:   <none>

  History:
  --------
  (v:010000)    Task:        5461   UserRef:    astra2
                Date:   17/04/2000  Author:     Anthony Swindells

  Update Notes: Created from Template aftemprocp.p

  (v:010001)    Task:    93000004   UserRef:    
                Date:   02/28/2007  Author:     Thomas Hansen

  Update Notes: [Object checked out] 02/28/2007 thomas:
                - Create a new parameter which indicates whether the record is NEW.  Use this to implement CREATE behaviour for Write of a New recodr.  At Create time, not all of the information necessary for creating an entry in roundtable is available.  By the time the Write occurs we presume that this info is available.
                - Fixed issues with replication and scmObjectExists.

  (v:010002)    Task:    90000097   UserRef:    
                Date:   30/04/2001  Author:     Anthony Swindells

  Update Notes: Change code to rather work with new XML mechanism and remove use
                of transaction and action tables.

  (v:010003)    Task:    90000177   UserRef:    
                Date:   07/27/2001  Author:     Pieter J Meyer

  Update Notes: XML Hooks

  (v:010007)    Task:    90000021   UserRef:    
                Date:   02/12/2002  Author:     Dynamics Admin User

  Update Notes: 

  (v:020000)    Task:          46   UserRef:    
                Date:   05/06/2003  Author:     Thomas Hansen

  Update Notes: Issue 10557:
                Fixed typo in startPersistentprocs which was not looking for the
                r-code version of the RTB super procedure.

  (v:030000)    Task:          49   UserRef:    
                Date:   06/11/2003  Author:     Thomas Hansen

  Update Notes: Create maintenace tool for SCM tool

  (v:030001)    Task:          49   UserRef:    
                Date:   06/24/2003  Author:     Thomas Hansen

  Update Notes: Create maintenace tool for SCM tool

  (v:040000)    Task:          49   UserRef:    
                Date:   06/24/2003  Author:     Thomas Hansen

  Update Notes: Updated with structured error handling on doreplication and associated code

-------------------------------------------------------------*/
/*                   This .W file was created with the Progress UIB.             */
/*-------------------------------------------------------------------------------*/

/* ***************************  Definitions  ************************** */
/* MIP-GET-OBJECT-VERSION pre-processors
   The following pre-processors are maintained automatically when the object is
   saved. They pull the object and version from Roundtable if possible so that it
   can be displayed in the about window of the container */

{src/adm2/globals.i}

/* Define RTB global shared variables - used for RTB integration hooks (if installed) */
DEFINE VARIABLE gcRtbCurrentWorkspace AS CHARACTER NO-UNDO.
DEFINE VARIABLE giRtbCurrentTaskNum   AS INTEGER   NO-UNDO.

&scop object-name       ryreplicat.p
DEFINE VARIABLE lv_this_object_name   AS CHARACTER INITIAL "{&object-name}":U NO-UNDO.
&scop object-version    040000

/* MIP object identifying preprocessor */
&glob   mip-structured-procedure    yes

DEFINE INPUT PARAMETER phTableBufferHandle        AS HANDLE       NO-UNDO.
DEFINE INPUT PARAMETER phOldBufferHandle          AS HANDLE       NO-UNDO.
DEFINE INPUT PARAMETER pcTableName                AS CHARACTER    NO-UNDO.
DEFINE INPUT PARAMETER pcTableFla                 AS CHARACTER    NO-UNDO.  
DEFINE INPUT PARAMETER pcTablePkFields            AS CHARACTER    NO-UNDO.             
DEFINE INPUT PARAMETER pcAction                   AS CHARACTER    NO-UNDO.   
DEFINE INPUT PARAMETER lNew                       AS LOGICAL      NO-UNDO. 
DEFINE INPUT PARAMETER pcPrimaryFla               AS CHARACTER    NO-UNDO.
DEFINE INPUT PARAMETER pcPrimaryKeyFields         AS CHARACTER    NO-UNDO.

DEFINE VARIABLE glActionUnderway           AS LOGICAL   NO-UNDO.
DEFINE VARIABLE gdWorkspaceObj             AS DECIMAL   NO-UNDO.
DEFINE VARIABLE gcWorkspaceCode            AS CHARACTER NO-UNDO.
DEFINE VARIABLE glCreatingItem             AS LOGICAL   NO-UNDO.
DEFINE VARIABLE glDeletingItem             AS LOGICAL   NO-UNDO.
DEFINE VARIABLE gcArguments                AS CHARACTER NO-UNDO.
DEFINE VARIABLE gcObjectName               AS CHARACTER NO-UNDO.
DEFINE VARIABLE gcObjectName_ext           AS CHARACTER NO-UNDO.
DEFINE VARIABLE gcObjectName_ado           AS CHARACTER NO-UNDO.
DEFINE VARIABLE cObjectDescription         AS CHARACTER NO-UNDO.
DEFINE VARIABLE glNullsInPrimaryKey        AS LOGICAL   NO-UNDO.
DEFINE VARIABLE ghScmTool                  AS HANDLE    NO-UNDO.
DEFINE VARIABLE ghObjRow                   AS HANDLE    NO-UNDO.
DEFINE VARIABLE ghObjBuf                   AS HANDLE    NO-UNDO.
DEFINE VARIABLE ghVerRow                   AS HANDLE    NO-UNDO.
DEFINE VARIABLE ghVerBuf                   AS HANDLE    NO-UNDO.
DEFINE VARIABLE ghAS                       AS HANDLE    NO-UNDO.
DEFINE VARIABLE glErrorStatus              AS LOGICAL   NO-UNDO.
DEFINE VARIABLE gcReturnValue              AS CHARACTER NO-UNDO.
DEFINE VARIABLE glScmObjectExists          AS LOGICAL   NO-UNDO.
DEFINE VARIABLE glScmObjectExistsInWs      AS LOGICAL   NO-UNDO.
DEFINE VARIABLE giScmVersionInWorkspace    AS INTEGER   NO-UNDO.
DEFINE VARIABLE glScmCheckedOutInWorkspace AS LOGICAL   NO-UNDO.
DEFINE VARIABLE giScmVersionTaskNumber     AS INTEGER   NO-UNDO.
DEFINE VARIABLE giScmHighestVersion        AS INTEGER   NO-UNDO.

/* Database logical name for primary table */
DEFINE VARIABLE gcDBName                   AS CHARACTER NO-UNDO.                                               
DEFINE VARIABLE gcConfigurationType        AS CHARACTER NO-UNDO.
DEFINE VARIABLE gcTypeTableName            AS CHARACTER NO-UNDO.
DEFINE VARIABLE gcScmIdentifyingFieldname  AS CHARACTER NO-UNDO.
DEFINE VARIABLE gcScmIdentifyingFieldext   AS CHARACTER NO-UNDO.
DEFINE VARIABLE gcScmPrimaryKeyFields      AS CHARACTER NO-UNDO.
DEFINE VARIABLE gcDescriptionFieldname     AS CHARACTER NO-UNDO.
DEFINE VARIABLE gcProductModuleFieldname   AS CHARACTER NO-UNDO.
DEFINE VARIABLE gcObjectTypeFieldname      AS CHARACTER NO-UNDO.
DEFINE VARIABLE gdPRIProductModuleObj      AS DECIMAL   NO-UNDO.
DEFINE VARIABLE gcPRIProductModuleCode     AS CHARACTER NO-UNDO.
DEFINE VARIABLE gdPRIObjectTypeObj         AS DECIMAL   NO-UNDO.
DEFINE VARIABLE gcPRIObjectDescription     AS CHARACTER NO-UNDO.
DEFINE VARIABLE glDebug                    AS LOGICAL   NO-UNDO INITIAL FALSE.

&SCOPED-DEFINE VER-INCREMENT   010000
&SCOPED-DEFINE REV-INCREMENT   000100
&SCOPED-DEFINE PAT-INCREMENT   000001

{checkerr.i &define-only = YES}

DEFINE BUFFER lb_ryc_smartobject FOR ryc_smartobject.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Procedure
&Scoped-define DB-AWARE no



/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Prototypes ********************** */

&IF DEFINED(EXCLUDE-assignmentUnderway) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD assignmentUnderway Procedure 
FUNCTION assignmentUnderway RETURNS LOGICAL
    ( plRemove AS LOGICAL )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-deletionUnderway) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD deletionUnderway Procedure 
FUNCTION deletionUnderway RETURNS LOGICAL
    ( plRemove AS LOGICAL )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-getFieldValue) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD getFieldValue Procedure 
FUNCTION getFieldValue RETURNS CHARACTER
    ( hBufferHandle           AS HANDLE, 
    pcDescriptionFieldname  AS CHARACTER)  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-getQuotedFieldValue) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD getQuotedFieldValue Procedure 
FUNCTION getQuotedFieldValue RETURNS CHARACTER
    ( phBufferHandle          AS HANDLE, 
    pcDescriptionFieldname  AS CHARACTER)  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Procedure
   Allow: 
   Frames: 0
   Add Fields to: Neither
   Other Settings: CODE-ONLY COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB) 
  CREATE WINDOW Procedure ASSIGN
         HEIGHT             = 19.76
         WIDTH              = 52.2.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME

 


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Procedure 


/* ***************************  Main Block  *************************** */
/* Get the current workspace  */
PUBLISH "evRtbGetCurrentWorkspace":U (OUTPUT gcRtbCurrentWorkspace).

/* Get the current task */
PUBLISH "evRtbGetCurrentTask":U (OUTPUT giRtbCurrentTaskNum).
PUBLISH "evRtbCustGetASConnection":U (OUTPUT ghAS).
ghScmTool = DYNAMIC-FUNCTION('getProcedureHandle':U IN THIS-PROCEDURE, INPUT "PRIVATE-DATA:SCMTool":U).

ASSIGN
    gcConfigurationType       = "RYCSO":U
    gcTypeTableName           = "ryc_smartobject":U
    gcScmIdentifyingFieldname = "object_filename":U
    gcScmIdentifyingFieldext  = "object_extension":U
    gcScmPrimaryKeyFields     = "smartobject_obj":U
    gcDescriptionFieldname    = "object_description"
    gcProductModuleFieldname  = "product_module_obj":U
    gcObjectTypeFieldname     = "object_type_obj":U.

/* DO NOTHING IF HANDLE TO SCM SUPER OR APPSERVER NOT VALID*/
IF NOT VALID-HANDLE(ghScmTool) OR 
    NOT VALID-HANDLE(ghAS) THEN 
    RETURN. 

/* DO NOTHING IF NO RTB CONNECTED */
IF NOT CONNECTED("RTB":U) THEN
    RETURN.

/* Check if SCM checks on */
FIND FIRST gsc_security_control NO-LOCK NO-ERROR.
IF AVAILABLE gsc_security_control AND 
    gsc_security_control.scm_checks_on = NO THEN 
    RETURN.

ASSIGN
    gcArguments = "TableName="       + pcTableName          + "~n"
               + "TableFLa="         + pcTableFla           + "~n"
               + "TablePkFields="    + pcTablePkFields      + "~n"
               + "Action="           + pcAction             + "~n"
               + "New="              + STRING(lNew)         + "~n"
               + "PrimaryFla="       + pcPrimaryFla         + "~n"
               + "PrimaryKeyFields=" + pcPrimaryKeyFields   + "~n".

/* ignore CREATE actions - this work is done on WRITE NEW */

/* remove extraneuous control characters put in there by ERwin */
RUN fixTablePkFields.

IF VALID-HANDLE(gshSessionManager) THEN
    RUN getActionUnderway IN gshSessionManager
        (INPUT  "SCM":U,
        INPUT  "ANY":U,
        INPUT  "":U,
        INPUT  "":U,
        INPUT  "":U,
        INPUT  NO,
        OUTPUT glActionUnderway). 

IF glActionUnderway = YES THEN 
    RETURN.

IF deletionUnderway(FALSE) AND 
    pcTableFla <> pcPrimaryFla THEN 
    RETURN.

/* create trigger does nothing */
IF pcAction = "CREATE" THEN 
DO:
    ASSIGN 
        gcReturnValue = gcReturnValue NO-ERROR. /* clear error status */
    RETURN.    
END.

outer-block:
DO ON ERROR UNDO outer-block, RETURN RETURN-VALUE:

    /*  RUN startPersistentProcs.*/
    IF RETURN-VALUE <> "":U THEN 
        RETURN RETURN-VALUE.

    /* Set Action Underway for "DYN" */
    IF VALID-HANDLE(gshSessionManager) THEN
        RUN setActionUnderway IN gshSessionManager
            (INPUT "DYN":U,
            INPUT pcAction,
            INPUT "",
            INPUT pcPrimaryFla,
            INPUT pcPrimaryKeyFields).

    RUN doReplication NO-ERROR.

    glErrorStatus = ERROR-STATUS:ERROR.
    gcReturnValue = RETURN-VALUE.

    /* Clear Action Underway for "DYN" */
    IF VALID-HANDLE(gshSessionManager) THEN 
    DO:
        RUN getActionUnderway IN gshSessionManager
            (INPUT  "DYN":U,
            INPUT pcAction,
            INPUT "",
            INPUT pcPrimaryFla,
            INPUT pcPrimaryKeyFields,
            INPUT  YES,
            OUTPUT glActionUnderway).

        IF pcTableFla <> pcPrimaryFla THEN 
        DO:
            RUN getActionUnderway IN gshSessionManager
                (INPUT "DYN":U,
                INPUT "DEL":U,
                INPUT gcObjectName,
                INPUT "RYCSO":U,
                INPUT "":U,
                INPUT  YES,
                OUTPUT glActionUnderway).
        END.

    END.

    RUN stopPersistentProcs.
    RUN deleteHandles.  

    IF glErrorStatus THEN 
        RETURN ERROR gcReturnValue.
    ELSE
        RETURN gcReturnValue.
END.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&IF DEFINED(EXCLUDE-createItem) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE createItem Procedure 
PROCEDURE createItem :
    /*------------------------------------------------------------------------------
                 Purpose:     
                 Parameters:  <none>
                 Notes:       
               ------------------------------------------------------------------------------*/
    /*   DEFINE OUTPUT PARAMETER pcError  AS CHARACTER NO-UNDO.*/
   
    DEFINE VARIABLE cProductModuleCode AS CHARACTER NO-UNDO.
    DEFINE VARIABLE dProductModuleObj  AS DECIMAL   NO-UNDO.
    DEFINE VARIABLE dObjectTypeObj     AS DECIMAL   NO-UNDO.
    DEFINE VARIABLE cObjectTypeCode    AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cObjectDescription AS CHARACTER NO-UNDO. 

    DEFINE VARIABLE cRowident          AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cError             AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cScmProductModule  AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cScmObjectType     AS CHARACTER NO-UNDO. 

    /* see if this item, which is new to the repository, exists in the SCM tool */
    RUN scmObjectExists.

    IF glScmObjectExists THEN 
    DO:
        /* a couple of checks first */
        IF NOT glScmObjectExistsInWs THEN
        DO: 
            ASSIGN 
                cError = {errortxt.i 'RV' '26' '?' '?' gcObjectName gcWorkspaceCode gcArguments}.
            UNDO, THROW NEW Progress.Lang.AppError(cError, 0).            
        END. 
          
        IF NOT glScmCheckedOutInWorkspace THEN 
        DO:
            ASSIGN 
                cError = {errortxt.i 'RV' '27' '?' '?' gcObjectName gcWorkspaceCode gcArguments}.
            UNDO, THROW NEW Progress.Lang.AppError(cError, 0).      
        END.
         
        IF giScmVersionTaskNumber <> giRtbCurrentTaskNum THEN
        DO:
            ASSIGN 
                cError = {errortxt.i 'RV' '28' '?' '?' gcObjectName giRtbCurrentTaskNum giScmVersionTaskNumber}.
            UNDO, THROW NEW Progress.Lang.AppError(cError, 0).  
        END.  
    END.
    ELSE
    DO:
        /* before we create the workspace object we must ensure that a version record exists.
        Pre-existence of this item is not a problem */
      
        RUN rtb/proxy/p/rtbGetObject.p ON ghAs (
            INPUT gcWorkspaceCode,
            INPUT "PCODE",
            INPUT gcObjectName_ado,
            INPUT gcPRIProductModuleCode,
            OUTPUT TABLE-HANDLE ghObjRow).
    
        ghObjBuf = ghObjRow:DEFAULT-BUFFER-HANDLE.
        ghObjBuf:FIND-FIRST() NO-ERROR.      

        /* If the object buffer does not exist, we can go ahead and try to create it...  */
        IF NOT ghObjBuf:AVAILABLE THEN 
        DO:
            /* get product module */
            IF gcProductModuleFieldname <> "":U THEN 
            DO:
                /* determine the product module from the primary table buffer */
                dProductModuleObj = DECIMAL(getFieldValue(phTableBufferHandle, gcProductModuleFieldname)).
                /* If we are unable to find this as we are not updating the primary buffer, but a related one
                   such as RYCAV, then we need to use the gdPRIProductModuleObj value set in detemineObjectName 
                   to find the product module*/
                IF pcPrimaryFLA NE pcTableFLA AND 
                    dProductModuleObj = 0      AND 
                    gdPRIProductModuleObj NE 0 THEN 
                    ASSIGN 
                        dProductModuleObj = gdPRIProductModuleObj.
            END.
            ELSE
            DO:
                ASSIGN 
                    cError = {errortxt.i 'RV' '14' '?' '?' gcConfigurationType giRtbCurrentTaskNum gcArguments}.
                UNDO, THROW NEW Progress.Lang.AppError(cError, 0).    
            END.   

            FIND FIRST gsc_product_module NO-LOCK
                WHERE gsc_product_module.product_module_obj = dProductModuleObj
                NO-ERROR.

            /* get object type */
            IF gcObjectTypeFieldname <> "":U THEN 
                /* determine the product module from the primary table buffer */
                dObjectTypeObj = DECIMAL(getFieldValue(phTableBufferHandle, gcObjectTypeFieldname)).
            ELSE
            DO:
                ASSIGN 
                    cError = {errortxt.i 'RV' '14' '?' '?' gcConfigurationType giRtbCurrentTaskNum gcArguments}.
                UNDO, THROW NEW Progress.Lang.AppError(cError, 0).     
            END.   

            FIND gsc_object_type NO-LOCK
                WHERE gsc_object_type.object_type_obj = dObjectTypeObj
                NO-ERROR.

            /* get object description */
            IF gcDescriptionFieldname <> "":U THEN 
            DO:
                /* determine the product module from the primary table buffer */
                cObjectDescription = getFieldValue(phTableBufferHandle, gcDescriptionFieldname).

                /* If the Object Description is blank when the object is created, then set the description 
                   to be the same as the Object Name  */
                IF cObjectDescription = "":U THEN
                    ASSIGN cObjectDescription = getFieldValue(phTableBufferHandle, gcScmIdentifyingFieldname).
                /* If the object description is still blank, then we may not be using the primary buffer to create the 
                  object - in which case we can use the gcPRIObjectDescription set in determineObjectName */
                IF pcPrimaryFLA NE pcTableFLA AND 
                    cObjectDescription = "":U  AND 
                    gcPRIObjectDescription NE "":U THEN 
                    ASSIGN 
                        cObjectDescription = gcPRIObjectDescription.
            END.
            ELSE
            DO:
                ASSIGN 
                    cError = {errortxt.i 'RV' '14' '?' '?' gcConfigurationType giRtbCurrentTaskNum gcArguments}.
                UNDO, THROW NEW Progress.Lang.AppError(cError, 0).    
            END.   

            IF VALID-HANDLE(ghScmTool) THEN 
            DO:
                RUN scmCreateObjectControl IN ghScmTool
                    (INPUT gcObjectName,
                    INPUT "PCODE":U,
                    INPUT (IF AVAILABLE gsc_object_type    THEN gsc_object_type.object_type_code       ELSE "":U),   /* Code Subtype */
                    INPUT (IF AVAILABLE gsc_product_module THEN gsc_product_module.product_module_code ELSE "":U),
                    INPUT (IF AVAILABLE gsc_object_type    THEN gsc_object_type.object_type_code       ELSE "":U), /* Group */
                    INPUT "00000":U,
                    INPUT cObjectDescription,
                    INPUT "":U,       /* ip_options                */
                    INPUT giRtbCurrentTaskNum,
                    INPUT NO,           /* ip_ui_on                  */
                    INPUT "CENTRAL":U,  /* ip_share_status           */
                    INPUT YES,          /* ip_create_physical_file   */
                    INPUT "":U,         /* ip_physical_file_template */
                    OUTPUT cRowIdent,
                    OUTPUT cError).
                  
                IF cError <> "":U THEN
                DO:
                    IF glDebug THEN 
                        /***DIAG***/
                        MESSAGE {&line-number} PROGRAM-NAME(1) SKIP
                            "ERROR: " cError	
                            VIEW-AS ALERT-BOX INFO BUTTONS OK.
                     
                    UNDO, THROW NEW Progress.Lang.AppError(cError, 0).    
                END.
            END. /* IF VALID-HANDLE(ghScmTool) ...*/
        END. /* IF NOT AVAILABLE rtb_object ...*/
    END. /* IF glScmObjectExists ...*/
   
    CATCH err AS Progress.Lang.Error :
        /***DIAG***/
        MESSAGE {&line-number} PROGRAM-NAME(1) SKIP
            err:GetMessage(1)	
            VIEW-AS ALERT-BOX INFO BUTTONS OK.
        UNDO, THROW err. 
    END CATCH.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-deleteHandles) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE deleteHandles Procedure 
PROCEDURE deleteHandles :
    /*------------------------------------------------------------------------------
                Purpose: Delete the handles for proxy temp-table handles.
                Parameters: <none>
                Notes:
            ------------------------------------------------------------------------------*/
    IF VALID-HANDLE(ghObjRow) THEN 
        DELETE OBJECT ghObjRow.

    IF VALID-HANDLE(ghVerRow) THEN 
        DELETE OBJECT ghVerRow.

    ASSIGN 
        ghScmTool = ? 
        ghAS      = ?. 
   
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-deleteItem) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE deleteItem Procedure 
PROCEDURE deleteItem :
    /*------------------------------------------------------------------------------
              Purpose:     
              Parameters:  <none>
              Notes:       
            ------------------------------------------------------------------------------*/
    DEFINE VARIABLE cError AS CHARACTER NO-UNDO.

    /* the user has chosen to delete the record in the Primary table which is this data item.
       In response we need to remove it from the workspace and notify the SCM tool that it has been
       removed.
    */

    /* see if this item, which should be in the repository, exists in the SCM tool */
    RUN scmObjectExists.

    IF NOT glScmObjectExists THEN 
    DO:
        ASSIGN 
            cError = {errortxt.i 'RV' '26' '?' '?' gcObjectName gcWorkspaceCode gcArguments}.
        UNDO, THROW NEW Progress.Lang.AppError(cError, 0).     
    END.   
          
    IF NOT glScmObjectExistsInWs THEN 
    DO:
        ASSIGN 
            cError = {errortxt.i 'RV' '26' '?' '?' gcObjectName gcWorkspaceCode gcArguments}.
        UNDO, THROW NEW Progress.Lang.AppError(cError, 0).
    END.   

    IF VALID-HANDLE(ghScmTool) THEN 
    DO:
        RUN scmDeleteObjectControl IN ghScmTool
            (INPUT ghObjBuf:BUFFER-FIELD('pmod':U):BUFFER-VALUE,
            INPUT "PCODE":U,
            INPUT ghObjBuf:BUFFER-FIELD('object':U):BUFFER-VALUE,
            INPUT giRtbCurrentTaskNum,
            INPUT "no-prompt":U,  /* ip_params */
            OUTPUT cError).
         
        IF cError <> "":U THEN 
            UNDO, THROW NEW Progress.Lang.AppError(cError, 0).
    END.

    /*
    We may experience timing issues to do with item deletions.
    For instance, is the REPLICATION-DELETE trigger on the primary table ALWAYS the last REPLICATION trigger to fire
    in the case of a ParentDelete=Cascade scenario?
    This may later cause us to "mark an item for deletion" as opposed to actually deleting it at this time.
    */

    ERROR-STATUS:ERROR = NO.
    RETURN.
   
    CATCH err AS Progress.Lang.Error :
        IF glDebug THEN 
            /***DIAG***/
            MESSAGE {&line-number} PROGRAM-NAME(1) SKIP
                err:GetMessage(1)	
                VIEW-AS ALERT-BOX INFO BUTTONS OK.
      
        UNDO, THROW err. 
    END CATCH.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-determineObjectName) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE determineObjectName Procedure 
PROCEDURE determineObjectName :
    /*------------------------------------------------------------------------------
         Purpose:     work out object name either from table if primary table else
                      using dynamic query to get record and obtain name from field
                      on table.
         Parameters:  <none>
         Notes:       
       ------------------------------------------------------------------------------*/
    DEFINE VARIABLE hBufferHandle         AS HANDLE    NO-UNDO.
    DEFINE VARIABLE cWhereString          AS CHARACTER NO-UNDO.  
    DEFINE VARIABLE iIdx                  AS INTEGER   NO-UNDO.
    DEFINE VARIABLE lOk                   AS LOGICAL   NO-UNDO.
    DEFINE VARIABLE cOldObjectName        AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cNewObjectName        AS CHARACTER NO-UNDO.
    DEFINE VARIABLE dOldProductModule     AS DECIMAL   NO-UNDO.
    DEFINE VARIABLE cOldProductModuleCode AS CHARACTER NO-UNDO.
    DEFINE VARIABLE dNewProductModule     AS DECIMAL   NO-UNDO.
    DEFINE VARIABLE cNewProductModuleCode AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cError                AS CHARACTER NO-UNDO.

    IF glDebug THEN 
        /***DIAG***/
        MESSAGE {&line-number} PROGRAM-NAME(1) SKIP
            pcTableFla SKIP 
            pcPrimaryFla
            VIEW-AS ALERT-BOX INFO BUTTONS OK.

    IF pcTableFla = pcPrimaryFla THEN 
    DO:
        /*
        this is the primary table - no need to open a query.
        Indeed we cannot open a query because this would fail to find the record if it is being deleted
        */

        ASSIGN
            glNullsInPrimaryKey = FALSE  /* although there were nulls we have found a corresponding record, so continue. */
            gcDBName            = phTableBufferHandle:DBNAME
            cNewObjectName      = getFieldValue(phTableBufferHandle, gcScmIdentifyingFieldname)
            gcObjectName        = cNewObjectName.

        IF VALID-HANDLE(phOldBufferHandle)            AND 
            CAN-QUERY(phOldBufferHandle,"AVAILABLE":U) AND 
            phOldBufferHandle:AVAILABLE = TRUE         THEN        
            ASSIGN cOldObjectName = getFieldValue(phOldBufferHandle, gcScmIdentifyingFieldname).
        ELSE 
            ASSIGN cOldObjectName = cNewObjectName.

        IF cOldObjectName = "":U OR 
            cOldObjectName = ?    THEN
            ASSIGN cOldObjectName = cNewObjectName.

        /* Objects cannot be renamed - so we need to stop if there is a name change coming in  */
        IF cNewObjectName <> ?               AND 
            cNewObjectName <> "":U            AND 
            cNewObjectName <> cOldObjectName THEN
        DO:
            ASSIGN 
                cError = {errortxt.i 'AF' '110' '?' '?' cOldObjectName cNewObjectName gcArguments}.
            UNDO, THROW NEW Progress.Lang.AppError(cError, 0). 
        END.   

        IF gcProductModuleFieldname <> "":U THEN 
        DO:     
            ASSIGN 
                dNewProductModule = DECIMAL(getFieldValue(phTableBufferHandle, gcProductModuleFieldname)).
                
            /* Thomas Hansen / appSolutions 31/01/2012: Find the product module so that we know this for finding objects */
            IF dNewProductModule NE 0 THEN 
            DO:
                FIND FIRST gsc_product_module NO-LOCK
                    WHERE gsc_product_module.product_module_obj = dNewProductModule
                    NO-ERROR.
                IF AVAILABLE gsc_product_module THEN
                DO:
                    ASSIGN 
                        gcPRIProductModuleCode = gsc_product_module.product_module_code. 
            
                    RUN scmGetScmXref IN ghScmTool (
                        INPUT "RTB":U,
                        INPUT "GSCPM":U,
                        INPUT  gcPRIProductModuleCode,
                        INPUT  0,
                        OUTPUT gcPRIProductModuleCode,
                        OUTPUT cError).
                        
                    RUN scmSitePrefixAdd IN ghScmTool (INPUT-OUTPUT gcPRIProductModuleCode).
                END.             
            END.
                
            IF VALID-HANDLE(phOldBufferHandle)            AND 
                CAN-QUERY(phOldBufferHandle,"available":U) AND 
                phOldBufferHandle:AVAILABLE = TRUE         THEN
                ASSIGN
                    dOldProductModule = DECIMAL(getFieldValue(phOldBufferHandle, gcProductModuleFieldname)).
            ELSE
                ASSIGN dOldProductModule = dNewProductModule.
        END.
        ELSE
            ASSIGN
                dNewProductModule = 0
                dOldProductModule = 0.

        /* We cannot move product module in ICFDB - this has to be done from RTB.   */
        IF dNewProductModule <> ?                 AND 
            dNewProductModule <> 0                 AND 
            dOldProductModule <> 0                 AND 
            dOldProductModule <> ?                 AND 
            dNewProductModule <> dOldProductModule THEN 
        DO:
            /* Find the names of the product modules and use these instead of the _obj values in the error message */
            FIND FIRST gsc_product_module WHERE product_module_obj = dNewProductModule NO-LOCK NO-ERROR.
            IF AVAILABLE gsc_product_module THEN
                ASSIGN cNewProductModuleCode = "product module " + gsc_product_module.product_module_code
                                         + "(" + STRING(dNewProductModule) + ")".

            FIND FIRST gsc_product_module WHERE product_module_obj = dOldProductModule NO-LOCK NO-ERROR.
            IF AVAILABLE gsc_product_module THEN
                ASSIGN cOldProductModuleCode = "product module " + gsc_product_module.product_module_code
                                         + "(" + STRING(dOldProductModule) + ")".
                                     
            /* Pass a message back informing the user that the product modules are different. */
            ASSIGN 
                cError = {errortxt.i 'AF' '110' '?' '?' cOldProductModuleCode cNewProductModuleCode gcArguments}.
            UNDO, THROW NEW Progress.Lang.AppError(cError, 0).
        /*         RETURN ERROR*/
        END.

        RETURN.
    END.

    /* If we are not in a delete event, then the buffer that is passed into the replication 
       procedure is not valid - it does not yet exist in memory - but has been written to the 
       database. Therefore we have to create a new separate buffer to access the object details. 
    */
    IF NOT glDeletingItem THEN 
    DO:
        CREATE BUFFER hBufferHandle FOR TABLE gcTypeTableName.
        ASSIGN 
            gcDBName = hBufferHandle:DBNAME.

        ASSIGN 
            cWhereString = "WHERE ":U.

        DO iIdx = 1 TO NUM-ENTRIES(pcPrimaryKeyFields):
            ASSIGN 
                glNullsInPrimaryKey = LOOKUP(getQuotedFieldValue(phTableBufferHandle, ENTRY(iIdx,pcPrimaryKeyFields)),',?,0,"0"') > 0.

            IF iIdx > 1 THEN
                ASSIGN cWhereString = cWhereString + " AND ".

            ASSIGN 
                cWhereString = cWhereString + gcTypeTableName + "." + ENTRY(iIdx,gcScmPrimaryKeyFields) + " = " + getQuotedFieldValue(phTableBufferHandle, ENTRY(iIdx,pcPrimaryKeyFields)) + " ". 

        END.
        IF glNullsInPrimaryKey THEN
            RETURN.
        ELSE
            hBufferHandle:FIND-FIRST(cWherestring, NO-LOCK) NO-ERROR. 

        IF NOT hBufferHandle:AVAILABLE THEN 
        DO:
            /* cleanup dynamic query */
            hBufferHandle:BUFFER-RELEASE() NO-ERROR.
            DELETE OBJECT hBufferHandle.
            ASSIGN 
                hBufferHandle = ?.

            IF glNullsInPrimaryKey THEN 
                RETURN.
            ELSE 
            DO:
                ASSIGN 
                    cError = {errortxt.i 'RV' '20' '?' '?' cWhereString gcScmIdentifyingFieldname gcArguments}.
                UNDO, THROW NEW Progress.Lang.AppError(cError, 0).
            /*            RETURN ERROR*/
            END.

            ASSIGN 
                cError = {errortxt.i 'RV' '19' '?' '?' cWhereString gcScmIdentifyingFieldname gcArguments}.
            UNDO, THROW NEW Progress.Lang.AppError(cError, 0).
        /*         RETURN ERROR*/
        END.

        ASSIGN 
            gcObjectName        = getFieldValue(hBufferHandle, gcScmIdentifyingFieldname)
            glNullsInPrimaryKey = FALSE.  /* although there were nulls we have found a corresponding record, so continue. */

        /* Store the PRImary object (rycso) attributes for possible creating in SCM later */
        ASSIGN 
            gdPRIProductModuleObj  = DECIMAL(getFieldValue(hBufferHandle, gcProductModuleFieldname))
            gdPRIObjectTypeObj     = DECIMAL(getFieldValue(hBufferHandle, gcObjectTypeFieldname))
            gcPRIObjectDescription = getFieldValue(hBufferHandle, gcDescriptionFieldname). 

        /* Thomas Hansen / appSolutions 31/01/2012: Find the product module so that we know this for finding objects */
        IF gdPRIProductModuleObj NE 0 THEN 
        DO:
            FIND FIRST gsc_product_module NO-LOCK
                WHERE gsc_product_module.product_module_obj = gdPRIProductModuleObj
                NO-ERROR.
            IF AVAILABLE gsc_product_module THEN
            DO:
                ASSIGN 
                    gcPRIProductModuleCode = gsc_product_module.product_module_code. 
            
                RUN scmGetScmXref IN ghScmTool (
                    INPUT "RTB":U,
                    INPUT "GSCPM":U,
                    INPUT  gcPRIProductModuleCode,
                    INPUT  0,
                    OUTPUT gcPRIProductModuleCode,
                    OUTPUT cError).
                RUN scmSitePrefixAdd IN ghScmTool (INPUT-OUTPUT gcPRIProductModuleCode).
            END.             
        END.

        /* cleanup dynamic query */        
        hBufferHandle:BUFFER-RELEASE() NO-ERROR.  
        DELETE OBJECT hBufferHandle.  
        ASSIGN 
            hBufferHandle = ?.
    END.
   
    CATCH err AS Progress.Lang.Error :
        UNDO, THROW err. 
    END CATCH.
   
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-determineObjectNameExt) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE determineObjectNameExt Procedure 
PROCEDURE determineObjectNameExt :
    /*------------------------------------------------------------------------------
              Purpose:     work out object name either from table if primary table else
                           using dynamic query to get record and obtain name from field
                           on table.
              Parameters:  <none>
              Notes:       
            ------------------------------------------------------------------------------*/
    DEFINE VARIABLE hBufferHandle         AS HANDLE    NO-UNDO.
    DEFINE VARIABLE cWhereString          AS CHARACTER NO-UNDO.
    DEFINE VARIABLE lQueryOK              AS LOGICAL   NO-UNDO.

    DEFINE VARIABLE cQueryObjectFullName  AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cQueryObjectName      AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cQueryObjectExt       AS CHARACTER NO-UNDO.

    DEFINE VARIABLE cQueryTableName       AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cQueryObjectFieldName AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cQueryObjectFieldExt  AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cError                AS CHARACTER NO-UNDO.

    ASSIGN
        cQueryTableName       = "ryc_smartobject":U
        cQueryObjectFieldName = "object_filename":U
        cQueryObjectFieldExt  = "object_extension":U
        cQueryObjectFullName  = gcObjectName
        cQueryObjectName      = gcObjectName
        cQueryObjectExt       = "":U.

    IF glDebug THEN 
        /***DIAG***/
        MESSAGE {&line-number} PROGRAM-NAME(1) SKIP
            cQueryTableName       SKIP
            cQueryObjectFieldName SKIP
            cQueryObjectFieldExt  SKIP 
            cQueryObjectFullName  SKIP 
            cQueryObjectName      SKIP
            cQueryObjectExt       
            VIEW-AS ALERT-BOX INFO BUTTONS OK.

    /* If we are deleting and item, it is not gonig to be possible to create 
     a new buffer for the table, as this has already been deleted at this stage.
     Instead, we can use the buffer that is benig passed in, as thi sstill exists 
     in memory - and can be accessed directly. 
    
     So for the delete event the phTableBufferHandle can be used directly. 
    */

    IF glDeletingItem THEN 
    DO:    
        /* First of all, we only want to check if the current buffer is for the 
           table defined in the cQueryTablename variable. We are not interested in 
           other buffers.  */
        IF phTableBufferHandle:TABLE = cQueryTableName THEN 
        DO:
            /* Make sure the buffer is available. */
            IF phTableBufferHandle:AVAILABLE THEN 
            DO:
                ASSIGN
                    cQueryObjectName = getFieldValue(phTableBufferHandle, cQueryObjectFieldName)
                    cQueryObjectExt  = getFieldValue(phTableBufferHandle, cQueryObjectFieldExt).
                IF cQueryObjectExt <> "":U THEN 
                    ASSIGN cQueryObjectFullName = cQueryObjectName + "." + cQueryObjectExt.
                ELSE 
                    ASSIGN cQueryObjectFullName = cQueryObjectName.

                ASSIGN
                    gcObjectName     = cQueryObjectFullName
                    gcObjectName_ext = cQueryObjectExt.        
            END.       
            /* Buffer is not available - finding the object is therefore going to fail */
            ELSE 
            DO:
                ASSIGN 
                    cError = {errortxt.i 'RV' '19' '?' '?' cWhereString cQueryObjectFieldName gcArguments}.
                UNDO, THROW NEW Progress.Lang.AppError(cError, 0). 
            /*            RETURN ERROR {errortxt.i 'RV' '19' '?' '?' cWhereString cQueryObjectFieldName gcArguments}.*/
            END.     
        END.  
    END.
    ELSE
    DO:
        /* If we are in a write event, then the buffer that is passed into the 
           replaication code is not yet been committed to memory, and is therefore 
           not available directly from the phTableBufferHandle. It has been written 
           to the database however, and we can therefore create a new buffer and access 
           the record from there.
             */
        CREATE BUFFER hBufferHandle FOR TABLE cQueryTableName .
        ASSIGN 
            gcDBName = hBufferHandle:DBNAME.

        ASSIGN 
            cWhereString = "WHERE ":U  + cQueryTableName + ".":U + cQueryObjectFieldName + " = ":U + QUOTER(cQueryObjectFullName).
               
        hBufferHandle:FIND-FIRST(cWhereString, NO-LOCK) NO-ERROR. 

        IF NOT hBufferHandle:AVAILABLE THEN 
        DO:
            /* cleanup dynamic query */

            hBufferHandle:BUFFER-RELEASE() NO-ERROR.
            DELETE OBJECT hBufferHandle.
            ASSIGN 
                hBufferHandle = ?.

            ASSIGN 
                cError = {errortxt.i 'RV' '19' '?' '?' cWhereString cQueryObjectFieldName gcArguments}.
            UNDO, THROW NEW Progress.Lang.AppError(cError, 0). 
        /*                     */
        /*         RETURN ERROR*/
        END.

        ASSIGN
            cQueryObjectName = getFieldValue(hBufferHandle, cQueryObjectFieldName)
            cQueryObjectExt  = getFieldValue(hBufferHandle, cQueryObjectFieldExt).
        IF cQueryObjectExt <> "":U THEN 
            ASSIGN cQueryObjectFullName = cQueryObjectName + "." + cQueryObjectExt.
        ELSE 
            ASSIGN cQueryObjectFullName = cQueryObjectName.

        ASSIGN
            gcObjectName     = cQueryObjectFullName
            gcObjectName_ext = cQueryObjectExt.

        /* cleanup dynamic query */        
        hBufferHandle:BUFFER-RELEASE() NO-ERROR.

        DELETE OBJECT hBufferHandle.

        ASSIGN 
            hBufferHandle = ?.  
    END.
   
    CATCH err AS Progress.Lang.Error :
        UNDO, THROW err. 
    END CATCH.
   
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-determineTask) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE determineTask Procedure 
PROCEDURE determineTask :
    /*------------------------------------------------------------------------------
              Purpose:     
              Parameters:  <none>
              Notes:       
            ------------------------------------------------------------------------------*/
    DEFINE VARIABLE lScmTaskOpen AS LOGICAL   NO-UNDO.
    DEFINE VARIABLE cError       AS CHARACTER NO-UNDO.

    ASSIGN
        lScmTaskOpen = IF giRtbCurrentTaskNum NE 0 THEN TRUE ELSE FALSE.  

    IF giRtbCurrentTaskNum = ? OR 
        giRtbCurrentTaskNum = 0 THEN
    DO:
        ASSIGN 
            cError = {errortxt.i 'RV' '5' '?' '?' gcArguments}.
        UNDO, THROW NEW Progress.Lang.AppError(cError, 0). 
    END.
       
    IF NOT lScmTaskOpen THEN
    DO:
        ASSIGN 
            cError = {errortxt.i 'RV' '25' '?' '?' gcArguments}.
        UNDO, THROW NEW Progress.Lang.AppError(cError, 0). 
    END.
    
    CATCH err AS Progress.Lang.Error :
        UNDO, THROW err. 		
    END CATCH.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-determineWorkspace) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE determineWorkspace Procedure 
PROCEDURE determineWorkspace :
    /*------------------------------------------------------------------------------
              Purpose:     
              Parameters:  <none>
              Notes:       
            ------------------------------------------------------------------------------*/
    DEFINE VARIABLE cError AS CHARACTER NO-UNDO.

    /* get the Workspace details */
    ASSIGN 
        gcWorkspaceCode = gcRtbCurrentWorkspace.

    IF gcWorkspaceCode = ?     OR 
        gcWorkspaceCode = "":U  THEN
    DO:
        ASSIGN 
            cError = {errortxt.i 'RV' '2' '?' '?' gcArguments}.
        UNDO, THROW NEW Progress.Lang.AppError(cError, 0). 
    END.

    ASSIGN 
        gcArguments = gcArguments + "~nWORKSPACE='" + gcWorkspaceCode + "'":U.

    RETURN.

    CATCH err AS Progress.Lang.Error :
        UNDO, THROW err. 
    END CATCH.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-doReplication) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE doReplication Procedure 
PROCEDURE doReplication :
    /*------------------------------------------------------------------------------
                 Purpose:     Guts of replication code
                 Parameters:  <none>
                 Notes:       Replication of objects are as follows
                
                    CREATE :  Nothing, this will be handled by the WRITE section
                
                    WRITE  :  Find the RTB object else create the record
                              Checkout the object in the current workspace
                
                    DELETE :  Find the RTB object
                              Delete object records from workspace
                
                    UPDATE :
                
               ------------------------------------------------------------------------------*/
    DEFINE VARIABLE cError AS CHARACTER NO-UNDO.
   
    IF glDebug THEN 
        /***DIAG***/
        MESSAGE {&line-number} PROGRAM-NAME(1) SKIP
            pcAction	
            VIEW-AS ALERT-BOX INFO BUTTONS OK.
   
    DO ON ERROR UNDO, THROW:    
        /*   DO: /*RETURN ERROR RETURN-VALUE:*/*/
        /* Determine the action to follow */
        ASSIGN    
            glCreatingItem = (pcAction = "WRITE":U  AND pcTableFla = pcPrimaryFla AND lNew )
            glDeletingItem = (pcAction = "DELETE":U AND pcTableFla = pcPrimaryFla).

        /* First we need to determine the object name */
        RUN determineObjectName.
      
        /* Some of the involved tables have nulls-allowed relationships to the primary table. We return if the primary key is null.*/
        IF glNullsInPrimaryKey THEN 
            RETURN.
      
        RUN determineObjectNameExt.
      
        /* do nothing if doing an assignment */
        IF assignmentUnderway(FALSE) THEN 
            RETURN.

        /* We need to determine the Workspace */
        RUN determineWorkspace.

        /* We need to determine the Task */
        RUN determineTask.

        ASSIGN 
            gcObjectName_ado = gcObjectName.
         
        IF VALID-HANDLE(ghScmTool) THEN
            RUN scmADOExtAdd IN ghScmTool (INPUT-OUTPUT gcObjectName_ado).

        IF glDebug THEN 
            /***DIAG***/
            MESSAGE {&line-number} PROGRAM-NAME(1) SKIP
                "gcProductModuleFieldname : " gcProductModuleFieldname SKIP 
                "gcPRIProductModuleCode   : " gcPRIProductModuleCode SKIP 
                "gcObjectName : " gcObjectName_ado        
                VIEW-AS ALERT-BOX INFO BUTTONS OK.
                
        /* now check for availability of the RTB object itself in the designated workspace */
        RUN rtb/proxy/p/rtbGetObject.p ON ghAs 
            (INPUT gcWorkspaceCode,
            INPUT "PCODE",
            INPUT gcObjectName_ado,
            INPUT gcPRIProductModuleCode, 
            OUTPUT TABLE-HANDLE ghObjRow).
                                                
        ghObjBuf = ghObjRow:DEFAULT-BUFFER-HANDLE.
        ghObjBuf:FIND-FIRST() NO-ERROR.      
        /*
           /* {af/sup/afdebug.i} */
           MESSAGE
              SKIP cObjectName
              SKIP gcObjectName_ext
              SKIP cObjectName_ado
              SKIP AVAILABLE(rtb_object)
              SKIP "ACT  " pcAction
              SKIP "CRE  " glCreatingItem
              SKIP "DEL  " glDeletingItem
              SKIP "WORK " gcWorkspaceCode
              SKIP "TASK " giTaskNumber
              VIEW-AS ALERT-BOX INFORMATION.
        */
        IF glCreatingItem THEN 
        DO:
            IF glDebug THEN 
                /***DIAG***/
                MESSAGE {&line-number} PROGRAM-NAME(1) SKIP
                    "Creating ..."	
                    VIEW-AS ALERT-BOX INFO BUTTONS OK.
         
            RUN createItem.
         
            IF glDebug THEN 
                /***DIAG***/
                MESSAGE {&line-number} PROGRAM-NAME(1) SKIP
                    "Created!"	
                    VIEW-AS ALERT-BOX INFO BUTTONS OK.
         
        /*            RETURN ERROR cError.*/
        END. /* creating the item */
        ELSE
            IF glDeletingItem THEN 
            DO:   
                IF ghObjBuf:AVAILABLE THEN 
                DO ON ERROR UNDO:
                    RUN deleteItem.
               
                    CATCH err AS Progress.Lang.Error :
                        IF glDebug THEN 
                            /***DIAG***/
                            MESSAGE {&line-number} PROGRAM-NAME(1) SKIP
                                err:GetMessage(1)	
                                VIEW-AS ALERT-BOX INFO BUTTONS OK.
                        UNDO, THROW err. 
                    END CATCH.
                END.
            
            
                ELSE 
                DO:
                /* attempt to delete data in the repository when we have no record of it existing in that workspace  - let the deletion proceed */
                END.
            
                deletionUnderway(TRUE).
            END. /* item pre-exists */
            ELSE 
            DO:
                IF NOT ghObjBuf:AVAILABLE THEN 
                DO ON ERROR UNDO:
                    /* Try and create the object as it may exist in ICFDB and not in SCM.
                       This prevents errors with objects that are in the Dynamics repository, but
                       not in the RTB repository for some reason.  */
                       
                    IF glDebug THEN 
                        /***DIAG***/
                        MESSAGE {&line-number} PROGRAM-NAME(1) SKIP
                            "Updating, but creating..."	
                            VIEW-AS ALERT-BOX INFO BUTTONS OK.
                       
                    RUN createItem.

                    /* Re-find the object in RTB */ 
                    RUN rtb/proxy/p/rtbGetObject.p ON ghAs 
                        (INPUT gcWorkspaceCode,
                        INPUT  "PCODE",
                        INPUT  gcObjectName_ado,
                        INPUT  gcPRIProductModuleCode, 
                        OUTPUT TABLE-HANDLE ghObjRow).
                                                
                    ghObjBuf = ghObjRow:DEFAULT-BUFFER-HANDLE.
                    ghObjBuf:FIND-FIRST() NO-ERROR.
               
                    /* If we don't have an object available for some reason, 
                       then we have a problem and need to let the user know */
                    IF NOT ghObjBuf:AVAILABLE THEN
                    DO:
                        ASSIGN 
                            cError = "Failed to create " + gcObjectName_ado.
                        UNDO, THROW NEW Progress.Lang.AppError(cError, 0).  
                    /*                  RETURN ERROR  {errortxt.i 'RV' '7' '?' '?' pcPrimaryFla gcObjectName_ado gcArguments}.*/
                    END.   

                    CATCH err AS Progress.Lang.Error :
                        gcArguments = gcArguments + "~n":U + RETURN-VALUE.
                        ASSIGN 
                            cError = {errortxt.i 'RV' '11' '?' '?' pcPrimaryFla gcObjectName gcWorkspaceCode gcArguments}.
                        UNDO, THROW NEW Progress.Lang.AppError(cError, 0).
                    END CATCH.
                END.

                IF ghObjBuf:AVAILABLE THEN 
                    ASSIGN 
                        glScmObjectExists     = TRUE
                        glScmObjectExistsInWs = TRUE.
                    
                IF glDebug THEN 
                    /***DIAG***/
                    MESSAGE {&line-number} PROGRAM-NAME(1) SKIP
                        "getting version details..."
                        VIEW-AS ALERT-BOX INFO BUTTONS OK.

                /* Get object version details*/       
                RUN rtb/proxy/p/rtbGetVersion.p ON ghAs
                    (INPUT ghObjBuf::obj-type,
                    INPUT ghObjBuf::object,
                    INPUT ghObjBuf::pmod,
                    INPUT ghObjBuf::VERSION,
                    OUTPUT TABLE-HANDLE ghVerRow).

                ghVerBuf = ghVerRow:DEFAULT-BUFFER-HANDLE.
                ghVerBuf:FIND-FIRST() NO-ERROR.

                /* Set this here instead of making a new bunch of calls */
                IF ghVerBuf:AVAILABLE THEN 
                    ASSIGN
                        glScmCheckedOutInWorkspace = (IF ghVerBuf::obj-status = "W":U THEN YES ELSE NO)
                        giScmVersionTaskNumber     = ghVerBuf::task-num.
                ELSE 
                    ASSIGN
                        giScmVersionTaskNumber = 0.      

                IF NOT ghVerBuf:AVAILABLE THEN 
                DO:
                    ASSIGN 
                        cError = {errortxt.i 'RV' '7' '?' '?' pcPrimaryFla gcObjectName_ado gcArguments}.
                    UNDO, THROW NEW Progress.Lang.AppError(cError, 0).
                END.      
            
                RUN updateItem.

            /*            IF cError NE "":U OR                                  */
            /*               ERROR-STATUS:ERROR THEN                            */
            /*               UNDO,  THROW NEW Progress.Lang.AppError(cError, 0).*/
            /*               RETURN ERROR cError.*/
            END.
         
        /* successful completion */
        ERROR-STATUS:ERROR = FALSE.
        RETURN. 
    END. /* do on error undo, return return-value */

    CATCH err AS Progress.Lang.Error :
        IF glDebug THEN 
            /***DIAG***/
            MESSAGE {&line-number} PROGRAM-NAME(1) SKIP
                "Error : " err:GetMessage(1)
                VIEW-AS ALERT-BOX INFO BUTTONS OK.
            
        ERROR-STATUS:ERROR = TRUE.
        RETURN ERROR err:GetMessage(1).
    END CATCH.
   
    FINALLY:
        IF glDebug THEN 
            /***DIAG***/
            MESSAGE {&line-number} PROGRAM-NAME(1) SKIP
                "Replication done..." SKIP 
                "ERROR-STATUS:error : " ERROR-STATUS:ERROR	
                VIEW-AS ALERT-BOX INFO BUTTONS OK.	
    END FINALLY.
   
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-fixTablePkFields) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE fixTablePkFields Procedure 
PROCEDURE fixTablePkFields :
    /*------------------------------------------------------------------------------
              Purpose:     
              Parameters:  <none>
              Notes:       
            ------------------------------------------------------------------------------*/
    ASSIGN 
        pcTablePkFields = REPLACE(REPLACE(REPLACE(pcTablePkFields," ":U,"":U),CHR(13),"":U),CHR(10),"":U).

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmObjectExists) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmObjectExists Procedure 
PROCEDURE scmObjectExists :
    /*------------------------------------------------------------------------------
              Purpose:     
              Parameters:  <none>
              Notes:       
            ------------------------------------------------------------------------------*/
    IF VALID-HANDLE(ghScmTool) THEN 
    DO:
        IF glDebug THEN 
            /***DIAG***/
            MESSAGE {&line-number} PROGRAM-NAME(1) SKIP
                "gcObjectName_ado : " gcObjectName_ado SKIP 
                "gcPRIProductModuleCode : " gcPRIProductModuleCode SKIP 
                "gcWorkspaceCode : "	 gcWorkspaceCode
                VIEW-AS ALERT-BOX INFO BUTTONS OK.
      
        RUN scmObjectExists IN ghScmTool (
            INPUT  gcObjectName_ado,
            INPUT  gcPRIProductModuleCode,
            INPUT  gcWorkspaceCode,
            OUTPUT glScmObjectExists,
            OUTPUT glScmObjectExistsInWs,
            OUTPUT giScmVersionInWorkspace,
            OUTPUT glScmCheckedOutInWorkspace,
            OUTPUT giScmVersionTaskNumber,
            OUTPUT giScmHighestVersion).
         
        IF glDebug THEN 
            /***DIAG***/
            MESSAGE {&line-number} PROGRAM-NAME(1) SKIP
                "glScmObjectExists : " glScmObjectExists SKIP 
                "glScmObjectExistsInWs : " glScmObjectExistsInWs SKIP 
                "giScmVersionInWorkspace : " giScmVersionInWorkspace
                VIEW-AS ALERT-BOX INFO BUTTONS OK.
    END.
    ELSE
        UNDO, THROW NEW Progress.Lang.AppError("Scm Tool handle (ghScmTool) not valid!", 0). 

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-startPersistentProcs) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE startPersistentProcs Procedure 
PROCEDURE startPersistentProcs :
    /*------------------------------------------------------------------------------
              Purpose:     
              Parameters:  <none>
              Notes:       
            ------------------------------------------------------------------------------*/

    DEFINE VARIABLE lv_proc_hdl AS HANDLE NO-UNDO.

    IF CONNECTED("rtb":U)                       AND 
        NOT VALID-HANDLE(ghScmTool)               AND 
        (SEARCH("rtb/prc/afrtbprocp.p":U) <> ?   OR 
        SEARCH("rtb/prc/afrtbprocp.r":U) <> ?)  THEN
    DO:
        RUN rtb/prc/afrtbprocp.p PERSISTENT SET ghScmTool.
        ASSIGN 
            ghScmTool:PRIVATE-DATA = "SCMTool":U.     
    END.

    IF NOT VALID-HANDLE(ghScmTool) THEN 
    DO:
        RETURN ERROR "Could not start SCM procedure (rtb/prc/afrtbprocp.p) for Roundtable API".
    END.

    RETURN.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-stopPersistentProcs) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE stopPersistentProcs Procedure 
PROCEDURE stopPersistentProcs :
/*------------------------------------------------------------------------------
  Purpose:     
  Parameters:  <none>
  Notes:       
------------------------------------------------------------------------------*/
/*IF VALID-HANDLE(ghScmTool) THEN*/
/*DO:                           */
/*  RUN killPlip IN ghScmTool.   */
/*END.                          */

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-updateItem) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE updateItem Procedure 
PROCEDURE updateItem :
    /*------------------------------------------------------------------------------
              Purpose:     
              Parameters:  <none>
              Notes:       
            ------------------------------------------------------------------------------*/
    /*   DEFINE OUTPUT PARAMETER pcError  AS CHARACTER NO-UNDO.*/
  
    DEFINE VARIABLE iRecid                AS RECID     NO-UNDO.
    DEFINE VARIABLE rRowid                AS ROWID     NO-UNDO.
    DEFINE VARIABLE cError                AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cNewObjectDescription AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cOldObjectDescription AS CHARACTER NO-UNDO. 

    IF glDebug THEN 
        /***DIAG***/
        MESSAGE {&line-number} PROGRAM-NAME(1) SKIP
            "Updating..."	
            VIEW-AS ALERT-BOX INFO BUTTONS OK.

    IF NOT glScmObjectExistsInWs THEN
    DO:
        ASSIGN 
            cError = {errortxt.i 'RV' '11' '?' '?' pcPrimaryFla gcObjectName gcWorkspaceCode gcArguments}.
        UNDO, THROW NEW Progress.Lang.AppError(cError, 0). 
    /*      RETURN /*ERROR*/.*/
    END.
  
    IF glScmCheckedOutInWorkspace THEN 
    DO:
        /* the item is checked out explicitly */
        IF giScmVersionTaskNumber <> giRtbCurrentTaskNum  THEN
        DO: 
            ASSIGN 
                cError = {errortxt.i 'RV' '12' '?' '?' pcPrimaryFla gcObjectName giRtbCurrentTaskNum giScmVersionTaskNumber gcArguments}.
            UNDO, THROW NEW Progress.Lang.AppError(cError, 0). 
        /*         RETURN /*ERROR pcError*/.*/
        END.   
        /* this item is explicitly checked out */

        /* Check if the description of the object has changed - 
           if it has we need to update this in RTB as well*/
        IF gcDescriptionFieldname <> "":U THEN 
        DO:
            ASSIGN 
                cNewObjectDescription = getFieldValue(phTableBufferHandle, gcDescriptionFieldname).                       

            IF VALID-HANDLE(phOldBufferHandle)            AND 
                CAN-QUERY(phOldBufferHandle,"AVAILABLE":U) AND 
                phOldBufferHandle:AVAILABLE = TRUE         THEN 
                ASSIGN cOldObjectDescription = getFieldValue(phOldBufferHandle, gcDescriptionFieldname).
            ELSE 
                ASSIGN cOldObjectDescription = cNewObjectDescription.        
        END. /* IF gcDescriptionFieldname <> "":U ...*/

        IF cNewObjectDescription <> cOldObjectDescription THEN 
        DO:    
            RUN scmUpdateObjectDescription IN ghScmTool (INPUT gcWorkspaceCode, 
                INPUT ghObjBuf::object, 
                INPUT gcPRIProductModuleCode,  
                INPUT "PCODE":U,       /* PCODE */
                INPUT YES, /* Overwrite */
                INPUT cNewObjectDescription).   
        END.
    END.
    ELSE
    DO:
        /* Checkout the item */
        IF VALID-HANDLE(ghScmTool) THEN 
            RUN scmCheckOutObjectControl IN ghScmTool (
                INPUT "patch":U,
                INPUT ghObjBuf::pmod,
                INPUT "PCODE":U,
                INPUT ghObjBuf::object,
                INPUT giRtbCurrentTaskNum,
                INPUT NO, /* ip_ui_on */
                INPUT NO, /* ip_allow_nonprimary */
                INPUT NO, /* ip_allow_orphans */
                OUTPUT rRowid,
                OUTPUT cError) NO-ERROR.
        IF cError NE "":U THEN 
            UNDO, THROW NEW Progress.Lang.AppError(cError, 0). 
    END.
  
    RETURN. 

    CATCH err AS Progress.Lang.Error :
        UNDO, THROW err. 
    END CATCH.
   
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

/* ************************  Function Implementations ***************** */

&IF DEFINED(EXCLUDE-assignmentUnderway) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION assignmentUnderway Procedure 
FUNCTION assignmentUnderway RETURNS LOGICAL
    ( plRemove AS LOGICAL ) :
    /*------------------------------------------------------------------------------
      Purpose:  
        Notes:  
    ------------------------------------------------------------------------------*/

    DEFINE VARIABLE lBufferHandle       AS HANDLE    NO-UNDO.
    DEFINE VARIABLE cPrimaryKeyValues   AS CHARACTER.
    DEFINE VARIABLE iIdx                AS INTEGER.
    DEFINE VARIABLE lAssignmentUnderway AS LOGICAL.    

    DO iIdx = 1 TO NUM-ENTRIES(pcPrimaryKeyFields):        
        IF iIdx > 1 THEN cPrimaryKeyValues = cPrimaryKeyValues + CHR(3).
        cPrimaryKeyValues = cPrimaryKeyValues + getFieldValue(phTableBufferHandle, ENTRY(iIdx,pcPrimaryKeyFields)).
    END.

    RUN getActionUnderway IN gshSessionManager
        (INPUT  "DYN":U,
        INPUT  "ASS":U,
        INPUT  gcObjectName,
        INPUT  "":U,
        INPUT  "":U,
        INPUT  plRemove,
        OUTPUT lAssignmentUnderway).

    RETURN lAssignmentUnderway.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-deletionUnderway) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION deletionUnderway Procedure 
FUNCTION deletionUnderway RETURNS LOGICAL
    ( plRemove AS LOGICAL ) :
    /*------------------------------------------------------------------------------
      Purpose:  
        Notes:  
    ------------------------------------------------------------------------------*/
    DEFINE VARIABLE lBufferHandle     AS HANDLE    NO-UNDO.
    DEFINE VARIABLE cPrimaryKeyValues AS CHARACTER NO-UNDO.
    DEFINE VARIABLE iIdx              AS INTEGER   NO-UNDO.
    DEFINE VARIABLE lDeletionUnderway AS LOGICAL   NO-UNDO.

    DO iIdx = 1 TO NUM-ENTRIES(pcPrimaryKeyFields):        
        IF iIdx > 1 THEN 
            cPrimaryKeyValues = cPrimaryKeyValues + CHR(3).
       
        ASSIGN 
            cPrimaryKeyValues = cPrimaryKeyValues + getFieldValue(phTableBufferHandle, ENTRY(iIdx,pcPrimaryKeyFields)).
    END.

    RUN getActionUnderway IN gshSessionManager
        (INPUT  "DYN":U,
        INPUT  "DEL":U,
        INPUT  "":U,
        INPUT  pcPrimaryFla,
        INPUT  cPrimaryKeyValues,
        INPUT  plRemove,
        OUTPUT lDeletionUnderway).

    RETURN lDeletionUnderway.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-getFieldValue) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION getFieldValue Procedure 
FUNCTION getFieldValue RETURNS CHARACTER
    ( hBufferHandle           AS HANDLE, 
    pcDescriptionFieldname  AS CHARACTER) :
    /*------------------------------------------------------------------------------
      Purpose:  
        Notes:  
    ------------------------------------------------------------------------------*/

    DEFINE VARIABLE hBufferField AS HANDLE NO-UNDO.

    ASSIGN
        hBufferField = hBufferHandle:BUFFER-FIELD(pcDescriptionFieldname)
    NO-ERROR.

    IF ERROR-STATUS:ERROR
        THEN RETURN "".  /* field not found in buffer */

    IF VALID-HANDLE(hBufferField) 
        THEN RETURN hBufferField:BUFFER-VALUE().
    ELSE RETURN "".

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-getQuotedFieldValue) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION getQuotedFieldValue Procedure 
FUNCTION getQuotedFieldValue RETURNS CHARACTER
    ( phBufferHandle          AS HANDLE, 
    pcDescriptionFieldname  AS CHARACTER) :
    /*------------------------------------------------------------------------------
      Purpose:  
        Notes:  
    ------------------------------------------------------------------------------*/

    DEFINE VARIABLE hBufferField AS HANDLE NO-UNDO.

    ASSIGN
        hBufferField = phBufferHandle:BUFFER-FIELD(pcDescriptionFieldname)
    NO-ERROR.
            
    IF ERROR-STATUS:ERROR THEN RETURN "".  /* field not found in buffer */

    IF VALID-HANDLE(hBufferField)
        THEN 
    DO:
        IF hBufferField:DATA-TYPE = "CHARACTER"  
            THEN RETURN "'"        + hBufferField:BUFFER-VALUE() + "'".
        ELSE RETURN  TRIM(QUOTER( hBufferField:BUFFER-VALUE() )).
    END.
    ELSE RETURN "".

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF


