&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v8r12
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Check Version Notes Wizard" Procedure _INLINE
/* Actions: af/cod/aftemwizcw.w ? ? ? ? */
/* Update Version Notes Wizard
Check object version notes.
af/cod/aftemwizpw.w
*/
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Update-Object-Version" Procedure _INLINE
/* Actions: ? ? ? ? af/sup/afverxftrp.p */
/* This has to go above the definitions sections, as that is what it modifies.
   If its not, then the definitions section will have been saved before the
   XFTR code kicks in and changes it */
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _XFTR "Definition Comments Wizard" Procedure _INLINE
/* Actions: ? af/cod/aftemwizcw.w ? ? ? */
/* Program Definition Comment Block Wizard
Welcome to the Program Definition Comment Block Wizard. Press Next to proceed.
af/cod/aftemwizpw.w
*/
/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Procedure
/*********************************************************************
* Copyright (C) 2006-2016 by Roundtable Software Inc. ("Roundtable"),*
*  All Rights Reserved.                                              *
*                                                                    *
* Software distributed under the License is distributed on an "AS IS"*
* basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. You*
* should refer to the License for the specific language governing    *
* rights and limitations under the License.                          *
*                                                                    *
* Contributors:                                                      *
* nodeable limited (www.nodeable.io)                                 *
*********************************************************************/
/*---------------------------------------------------------------------------------
  File: afrtbprocp.p

  Description:  Roundtable API procedures

  Purpose:      Procedures that process the Roundtable repository directly using information
                from the available Roundtable global variables.

                This procedure contains all access to RTB database. It will not compile if
                RTB is not used.

                Alternative procedures should be provided for other SCM tools.

  Parameters:

  History:
  --------
  (v:020000)    Task:    11000745   UserRef:
                Date:   02/18/2007  Author:     Thomas Hansen

  Update Notes: Rewrote code using the new RTB proxy procedures without direct database access.

  (v:010001)    Task:    93000004   UserRef:
                Date:   02/25/2007  Author:     Thomas Hansen

  Update Notes: [Object checked out] 02/25/07 23:07 thomas:
                - Fixed issue with incorrect query handle reference for scmGetModuleList.

  (v:010002)    Task:    93000004   UserRef:
                Date:   02/28/2007  Author:     Thomas Hansen

  Update Notes: [Object checked out] 02/28/07 09:24 thomas :
                - Fixed issues with scmObjectExists not finding version records with rtb/proxy/p/rtbGetVersions
                - as this does not support wildcards at the moment.
                - Fixed issues with scmCreateObject not creating objects if plCreatePhysicla file is set to no.

  (v:010003)    Task:    93000008   UserRef:
                Date:   05/08/2007  Author:     Thomas Hansen

  Update Notes: [Object checked-out] 05/2007 thomas :
                Object updated as part of update to Dynamics 10.1B01.

  (v:010004)    Task:    93000008   UserRef:
                Date:   05/11/2007  Author:     System Operator

  Update Notes: [Object checked out] 05/10/07 15:09 thomas :
                Fix errors on scmCreateObject.

  (v:010006)    Task:    93000010   UserRef:
                Date:   02/04/2008  Author:     System Operator

  Update Notes: [Object checked out] 02/04/08 09:35 thomas :
                Fix parameter error on rtb/proxy/p/rtbGetSubtypes.p call.

  (v:010007)    Task:    93000010   UserRef:
                Date:   02/04/2008  Author:     System Operator

  Update Notes: [Object checked out] 02/04/08 14:31 thomas :
                Fix error in scmCreateObject when errors are found on creating objects in RTB.
  (v:010001)    Task:    95000006   UserRef:
                Date:   04/03/2009  Author:     System Operator

  Update Notes: [Object checked out] 04/03/2009 12:06:12+02:00 thomas:
                - Clean up of buffer handles in proxy API usage.
                - Minor updates to comments

  (v:010000)    Task:         502   UserRef:
                Date:   02/02/2012  Author:     Thomas Hansen

  Update Notes: [Custom variant created] 30/01/2012 14:44:46+01:00 thomas :
                - Lots of updates to support the need for product module on getting objects from the repository.

  (v:020001)    Task:    12000191   UserRef:
                Date:   27/08/2012  Author:     Thomas Hansen

  Update Notes: [Object checked out] 16/08/2012 17:02:27+02:00 thomas :

--------------------------------------------------------*/
/*                   This .W file was created with the Progress UIB.             */
/*-------------------------------------------------------------------------------*/


/* ***************************  Definitions  ************************** */
/* GET-OBJECT-VERSION pre-processors
   The following pre-processors are maintained automatically when the object is
   saved. They pull the object and version from Roundtable if possible so that it
   can be displayed in the about window of the container */

&scop object-name       afrtbprocp.p
DEFINE VARIABLE lv_this_object_name AS CHARACTER INITIAL "{&object-name}":U NO-UNDO.
&scop object-version    020001

{src/adm2/globals.i}

/* Variables needed for RTB integration */
DEFINE VARIABLE gcRtbCurrentWorkspace     AS CHARACTER                           NO-UNDO.
DEFINE VARIABLE gcRtbCurrentWorkspacePath AS CHARACTER                           NO-UNDO.
DEFINE VARIABLE gcRtbCurrentWorkspaceRoot AS CHARACTER                           NO-UNDO.
DEFINE VARIABLE gcRtbCurrentUser          AS CHARACTER                           NO-UNDO.
DEFINE VARIABLE giRtbSid                  AS INTEGER                             NO-UNDO.
DEFINE VARIABLE giRTBSiteNumber           AS INTEGER                             NO-UNDO.
DEFINE VARIABLE glRTBSiteNumberFound      AS LOGICAL                             NO-UNDO INITIAL FALSE.
DEFINE VARIABLE ghRtbAs                   AS HANDLE                              NO-UNDO.

/*DEFINE VARIABLE hData                     AS HANDLE                          NO-UNDO.*/
DEFINE VARIABLE hQry                      AS HANDLE                              NO-UNDO.
DEFINE VARIABLE hBuf                      AS HANDLE                              NO-UNDO.

DEFINE VARIABLE hFileIO                   AS HANDLE                              NO-UNDO.
DEFINE VARIABLE hProp                     AS HANDLE                              NO-UNDO.

DEFINE VARIABLE cRowid                    AS CHARACTER                           NO-UNDO.
DEFINE VARIABLE cObject                   AS CHARACTER                           NO-UNDO.
DEFINE VARIABLE cError                    AS CHARACTER                           NO-UNDO.
DEFINE VARIABLE i                         AS INTEGER                             NO-UNDO.

DEFINE VARIABLE notifyIcon1               AS System.Windows.Forms.NotifyIcon     NO-UNDO.
DEFINE VARIABLE Components                AS System.ComponentModel.Container     NO-UNDO.
DEFINE VARIABLE glShowNotifyBallonTips    AS LOGICAL                             NO-UNDO INITIAL TRUE.
DEFINE VARIABLE glDebug                   AS LOGICAL                             NO-UNDO INITIAL FALSE.
DEFINE VARIABLE oRtbProxyHelper           AS scm.custom.rtb.Utils.RTBProxyHelper NO-UNDO.

/* Include the ttSecurityControl temp-table */
{af/app/afttsecurityctrl.i}

/* Astra object identifying preprocessor */
&glob   AstraPlip    yes

DEFINE VARIABLE cObjectName AS CHARACTER NO-UNDO.

ASSIGN
    cObjectName = "{&object-name}":U.

&scop   mip-notify-user-on-plip-close   NO

DEFINE VARIABLE hRtbApi AS HANDLE NO-UNDO.

/* --- Temp-table needed by internal procedure create_xrefs --- */
DEFINE TEMP-TABLE TTxref
    FIELD src-object AS CHARACTER
    FIELD ref-type   AS CHARACTER FORMAT "x(20)"
    FIELD obj-text   AS CHARACTER FORMAT "x(200)" EXTENT 4
    INDEX OBJECT AS PRIMARY
    src-object ASCENDING.


/* MIP-GET-OBJECT-VERSION pre-processors
   The following pre-processors are maintained automatically when the object is
   saved. They pull the object and version from Roundtable if possible so that it
   can be displayed in the about window of the container */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Procedure
&Scoped-define DB-AWARE no



/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME


/* ************************  Function Prototypes ********************** */

&IF DEFINED(EXCLUDE-scmChecksOn) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD scmChecksOn Procedure
FUNCTION scmChecksOn RETURNS LOGICAL
    ( /* parameter-definitions */ )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmGetCurrentTask) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD scmGetCurrentTask Procedure
FUNCTION scmGetCurrentTask RETURNS INTEGER
    ( /* parameter-definitions */ )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmGetCurrentWorkspace) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD scmGetCurrentWorkspace Procedure
FUNCTION scmGetCurrentWorkspace RETURNS CHARACTER
    ( /* parameter-definitions */ )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmGetCurrentWorkspaceRoot) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD scmGetCurrentWorkspaceRoot Procedure
FUNCTION scmGetCurrentWorkspaceRoot RETURNS CHARACTER
    ( /* parameter-definitions */ )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmGetModuleList) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD scmGetModuleList Procedure
FUNCTION scmGetModuleList RETURNS CHARACTER
    ( /* parameter-definitions */ )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmGetObjectTypeList) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION-FORWARD scmGetObjectTypeList Procedure
FUNCTION scmGetObjectTypeList RETURNS CHARACTER
    ( /* parameter-definitions */ )  FORWARD.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF


/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Procedure
   Allow:
   Frames: 0
   Add Fields to: Neither
   Other Settings: CODE-ONLY COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB)
  CREATE WINDOW Procedure ASSIGN
         HEIGHT             = 28.38
         WIDTH              = 55.2.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME




&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Procedure


/* ***************************  Main Block  *************************** */

{ry/app/ryplipmain.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&IF DEFINED(EXCLUDE-createDirectory) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE createDirectory Procedure
PROCEDURE createDirectory :
    /*------------------------------------------------------------------------------
             Purpose:     Procedure to create a directory, being sure to create the full
                          directory path. The standard os-create-dir will not create a full
                          path.
             Parameters:  pcPath
                          pcErrorCode
             Notes:

             Status:  *** This procedure has not been converted to use Proxies.
           ------------------------------------------------------------------------------*/

    DEFINE INPUT  PARAMETER pcPath          AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER pcErrorCode     AS CHARACTER NO-UNDO.

    DEFINE VARIABLE i   AS INTEGER   NO-UNDO.
    DEFINE VARIABLE pos AS INTEGER   NO-UNDO.
    DEFINE VARIABLE tmp AS CHARACTER NO-UNDO.

    ASSIGN
        pcPath = REPLACE(pcPath,"~/","~\").
    IF SUBSTRING(pcPath,LENGTH(pcPath),1,"CHARACTER":U) NE "~\":U THEN
        ASSIGN pcPath = pcPath + "~\":U.

    /* WIN95-UNC - Check for UNC \\SERVER\SHARE and treat it like a
       drive specification. In which case, there is no basename and the prefix
       is the UNC and drive spec. -*/
    IF CAN-DO("OS2,WIN32,MSDOS,UNIX":U,OPSYS) THEN
    DO:
        IF pcPath BEGINS "~\~\"  AND
            NUM-ENTRIES(pcPath,"~\") > 4 THEN
        DO:        /* start creating the dir at the 5 slashes down */
            ASSIGN
                pos = INDEX(pcPath,"~\":U).
            DO i = 1 TO 3:
                ASSIGN
                    pos = INDEX(pcPath,"~\":U,pos + 1).
            END.
        END.
        ELSE
            ASSIGN pos = INDEX(pcPath,"~\":U).
    END.

    DO WHILE pos <> 0:
        ASSIGN
            tmp = SUBSTRING(pcPath,1,pos).
        OS-CREATE-DIR VALUE(tmp).
        IF OS-ERROR <> 0 THEN
        DO:
            ASSIGN
                pcErrorCode = "Failed to create directory, error code: " + STRING(OS-ERROR).
            RETURN.
        END.
        ASSIGN
            pos = INDEX(pcPath,"~\":U,pos + 1).
    END.

    ERROR-STATUS:ERROR = NO.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-killPlip) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE killPlip Procedure
PROCEDURE killPlip :
    /*------------------------------------------------------------------------------
             Purpose:     entry point to instantly kill the plip if it should get lost in memory
             Parameters:  <none>
             Notes:
           ------------------------------------------------------------------------------*/
    IF VALID-OBJECT(oRtbProxyHelper) THEN
        DELETE OBJECT oRtbProxyHelper.

    {ry/app/ryplipkill.i}

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-objectDescription) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE objectDescription Procedure
PROCEDURE objectDescription :
    /*------------------------------------------------------------------------------
             Purpose:     Pass out a description of the PLIP, used in Plip temp-table
             Parameters:  <none>
             Notes:       This should be changed manually for each plip
           ------------------------------------------------------------------------------*/

    DEFINE OUTPUT PARAMETER cDescription AS CHARACTER NO-UNDO.

    ASSIGN
        cDescription = "RTB Procedures PLIP".

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-plipSetup) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE plipSetup Procedure
PROCEDURE plipSetup :
    /*------------------------------------------------------------------------------
             Purpose:    Run by main-block of PLIP at startup of PLIP
             Parameters: <none>
             Notes:
           ------------------------------------------------------------------------------*/
    DEFINE VARIABLE cProcName   AS CHARACTER NO-UNDO.
    DEFINE VARIABLE hProcHandle AS HANDLE    NO-UNDO.
    DEFINE VARIABLE cError      AS CHARACTER NO-UNDO.
    {ry/app/ryplipsetu.i}

    /* Get the current workspace  */
    PUBLISH "evRtbGetCurrentWorkspace":U (OUTPUT gcRtbCurrentWorkspace).

    /* Get the current user */
    PUBLISH "evRtbGetCurrentUser":U (OUTPUT gcRtbCurrentUser).

    /* Get the RTB Session ID */
    PUBLISH "evRtbCustGetSid":U (OUTPUT giRtbSid).

    /* Get the ghRtbAs handle if this is not already set */
    PUBLISH "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

    SUBSCRIBE PROCEDURE THIS-PROCEDURE TO "scmSetICFParams" ANYWHERE.

    IF glShowNotifyBallonTips THEN
    DO:
        SUBSCRIBE PROCEDURE THIS-PROCEDURE TO "showNotifyBallonTip" ANYWHERE.

        RUN setupNotifyIcon IN TARGET-PROCEDURE.
        PUBLISH "showNotifyBallonTip" (
            IF gcRtbCurrentWorkspace NE "":U THEN SUBSTITUTE("RTB Dynamics - &1", gcRtbCurrentWorkspace) ELSE "RTB Dynamics":U,
            "Roundtable Dynamics Integration starting...",
            50).
    END.

    /* Start the oRtbProxyHelper object - if it is available */
    IF NOT VALID-OBJECT(oRtbProxyHelper) THEN
    DO:
        oRtbProxyHelper = scm.custom.rtb.Env:RTBProxyHelper.

        IF VALID-HANDLE(ghRtbAs) AND
            oRtbProxyHelper:AppServerhandle NE ghRtbAs THEN
            oRtbProxyHelper:AppServerhandle = ghRtbAs.
    END.

    IF glDebug THEN
    DO:
        LOG-MANAGER:LOGFILE-NAME = SUBSTITUTE("&1_rtbdyn_log.txt", gcRtbCurrentUser).
        LOG-MANAGER:LOG-ENTRY-TYPES = ? .
    END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-plipShutdown) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE plipShutdown Procedure
PROCEDURE plipShutdown :
    /*------------------------------------------------------------------------------
             Purpose:     This procedure will be run just before the calling program
                          terminates
             Parameters:  <none>
             Notes:
           ------------------------------------------------------------------------------*/
    DEFINE VARIABLE cProcName      AS CHARACTER NO-UNDO.
    DEFINE VARIABLE hValidHanldles AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hProcHandle    AS HANDLE    NO-UNDO.

    ASSIGN
        cProcName      = "rtb_api.p":U
        hValidHanldles = SESSION:FIRST-PROCEDURE.

    DO WHILE VALID-HANDLE(hValidHanldles) AND
        NOT (VALID-HANDLE(hProcHandle)):

        IF hValidHanldles:PRIVATE-DATA = cProcName THEN
            ASSIGN hProcHandle = hValidHanldles.

        ASSIGN
            hValidHanldles = hValidHanldles:NEXT-SIBLING.
    END.

    /* Clean up RTB API handle */
    IF VALID-HANDLE(hRtbApi) OR
        VALID-HANDLE(hProcHandle) THEN
    DO:
        DELETE PROCEDURE hRtbApi.
        ASSIGN
            hRtbApi = ?.
    END.

    IF glShowNotifyBallonTips THEN
        PUBLISH "showNotifyBallonTip" ("":U, "Shutting down Roundtable Dynamics integration...", 200).

    IF VALID-OBJECT(components) THEN
    DO:
        components:dispose().
    END.

    {ry/app/ryplipshut.i}

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rtb-get-objectinfo) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rtb-get-objectinfo Procedure
PROCEDURE rtb-get-objectinfo :
    /*------------------------------------------------------------------------------
             Purpose:     To retrieve information about the current open object in the
                          current workspace for the current task.

             Parameters:
               INPUT   pcObject              object name (including extension)
               INPUT   piTaskNumber          current task
               OUTPUT  ipObjectVersion       current version of object in task
               OUTPUT  pcObjectSummary       summary description of object
               OUTPUT  pcObjectDescription   | delimited list for full object description
               OUTPUT  pcObjectUpdNotes      version update notes
               OUTPUT  pcPreviousVersions    comma seperated list of object versions before the current version
               OUTPUT  ipObjectVersionTask   The task the version is/was changed under
             Notes:

           ------------------------------------------------------------------------------*/
    DEFINE INPUT         PARAMETER pcObject              AS CHARACTER NO-UNDO.
    DEFINE INPUT-OUTPUT  PARAMETER pcProductModule       AS CHARACTER NO-UNDO.
    DEFINE INPUT         PARAMETER piTaskNumber          AS INTEGER   NO-UNDO.
    DEFINE OUTPUT        PARAMETER ipObjectVersion       AS INTEGER   NO-UNDO.
    DEFINE OUTPUT        PARAMETER pcObjectSummary       AS CHARACTER NO-UNDO.
    DEFINE OUTPUT        PARAMETER pcObjectDescription   AS CHARACTER NO-UNDO.
    DEFINE OUTPUT        PARAMETER pcObjectUpdNotes      AS CHARACTER NO-UNDO.
    DEFINE OUTPUT        PARAMETER pcPreviousVersions    AS CHARACTER NO-UNDO.
    DEFINE OUTPUT        PARAMETER ipObjectVersionTask   AS INTEGER   NO-UNDO.

    DEFINE VARIABLE cWorkspaceID            AS CHARACTER NO-UNDO.
    DEFINE VARIABLE hTaskData               AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hObjData                AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hObjBuf                 AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hVerData                AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hVerBuf                 AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hTaskBuf                AS HANDLE    NO-UNDO.
    DEFINE VARIABLE cVersionTextDescription AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cRowIdent               AS CHARACTER NO-UNDO.

    IF NOT VALID-HANDLE(ghRtbAs)  THEN
        PUBLISH "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

    RUN rtb/proxy/p/rtbGetTask.p ON ghRtbAs
        (INPUT piTaskNumber,
        OUTPUT TABLE-HANDLE hTaskData).

    hTaskBuf = hTaskData:DEFAULT-BUFFER-HANDLE.
    hTaskBuf:FIND-FIRST() NO-ERROR.

    ASSIGN
        cWorkspaceID = hTaskBuf::wspace-id.

    /* If we do not have a product module specified, we may be coming from a part of the
       ADE that cannot get the product module yet, so we have to try and find the object
       by searching the workspace for all objects with this name - and if we only get
       one entry returned - we can use the product module from here.
    */
    IF pcProductmodule = "":U THEN
    DO:
        cRowIdent = "FIRST".

        RUN rtb/proxy/p/rtbGetWorkspaceObjects.p ON ghRtbAs
            (INPUT-OUTPUT cRowIdent,
            INPUT  0,
            INPUT  cWorkspaceID,
            INPUT  "PCODE":U,
            INPUT  pcObject,
            OUTPUT TABLE-HANDLE hObjData).

        hObjBuf = hObjData:DEFAULT-BUFFER-HANDLE.
        hObjBuf:FIND-FIRST() NO-ERROR.

        IF NOT hObjBuf:AVAILABLE THEN
        DO:
            IF VALID-HANDLE(hObjData) THEN
                DELETE OBJECT hObjData.
            RETURN.
        END.
    END.
    ELSE
    DO:
        RUN rtb/proxy/p/rtbGetObject.p ON ghRtbAs (
            INPUT cWorkspaceID,
            INPUT "PCODE",
            INPUT pcObject,
            INPUT pcProductModule,
            OUTPUT TABLE-HANDLE hObjData).

        hObjBuf = hObjData:DEFAULT-BUFFER-HANDLE.
        hObjBuf:FIND-FIRST() NO-ERROR.

        IF NOT hObjBuf:AVAILABLE THEN
        DO:
            IF VALID-HANDLE(hObjData) THEN
                DELETE OBJECT hObjData.
            RETURN.
        END.
    END.

    /*   Find the version record of the object in
         the workspace as we need details from this*/
    IF cWorkspaceID NE "":U AND
        hObjBuf:AVAILABLE THEN
    DO:
        /* Get object version details */
        RUN rtb/proxy/p/rtbGetVersion.p ON ghRtbAs (
            INPUT  hObjBuf::obj-type,
            INPUT  hObjBuf::object,
            INPUT  hObjBuf::pmod,
            INPUT  hObjBuf::VERSION,
            OUTPUT TABLE-HANDLE hVerData).

        hVerBuf = hVerData:DEFAULT-BUFFER-HANDLE.
        hVerBuf:FIND-FIRST() NO-ERROR.

        IF NOT hVerBuf:AVAILABLE THEN
        DO:
            IF VALID-HANDLE(hVerData) THEN
                DELETE OBJECT hVerData.
            RETURN.
        END.
        ELSE
        DO:
            ASSIGN
                ipObjectVersion     = hVerBuf::VERSION
                pcObjectSummary     = hVerBuf::description
                pcObjectUpdNotes    = hVerBuf::upd-notes
                ipObjectVersionTask = hVerBuf::task-num
                pcProductModule     = hVerBuf::pmod.
        END.
    END.

    /* Find out how many entries there are in the description */
    ASSIGN
        cVersionTextDescription = hVerBuf::verTextDesc.
    ASSIGN
        pcObjectDescription = REPLACE(cVersionTextDescription, CHR(10), "|":U).

    IF pcObjectUpdNotes = "" AND
        hTaskBuf:AVAILABLE THEN
        ASSIGN pcObjectUpdNotes = pcObjectUpdNotes + hTaskBuf::taskDescription.

    /* If we still do not have any version update notes, then just get the
       task summary.
    */
    IF pcObjectUpdNotes = "":U AND
        hTaskBuf:AVAILABLE THEN
        ASSIGN pcObjectUpdNotes = TRIM(hTaskBuf::summary).

    ASSIGN
        cRowIdent = "FIRST":U.
    RUN rtb/proxy/p/rtbGetVersions.p ON ghRtbAs
        (INPUT-OUTPUT cRowIdent,
        INPUT  0,
        INPUT  "PCODE",
        INPUT  pcObject,
        INPUT  pcProductModule,
        OUTPUT TABLE-HANDLE hVerData).

    CREATE QUERY hQry.
    hBuf = hVerData:DEFAULT-BUFFER-HANDLE.
    hQry:SET-BUFFERS(hBuf).
    hQry:QUERY-PREPARE("FOR EACH " + hVerData:NAME).
    hQry:QUERY-OPEN.
    hQry:GET-FIRST.

    DO WHILE NOT hQry:QUERY-OFF-END:
        ASSIGN
            pcPreviousVersions = pcPreviousVersions +
                                (IF NUM-ENTRIES(pcPreviousVersions) > 0 THEN ",":U ELSE "":U) +
                                STRING(hBuf::VERSION).
        hQry:GET-NEXT.
    END.

    ERROR-STATUS:ERROR = NO.
    RETURN.

    FINALLY:
        IF VALID-HANDLE(hTaskData) THEN
            DELETE OBJECT hTaskData.

        IF VALID-HANDLE(hObjData) THEN
            DELETE OBJECT hObjData.

        IF VALID-HANDLE(hVerData) THEN
            DELETE OBJECT hVerData.

        IF VALID-HANDLE(hQry) THEN
            DELETE OBJECT hQry.
    END FINALLY.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rtb-get-taskinfo) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rtb-get-taskinfo Procedure
PROCEDURE rtb-get-taskinfo :
    /*------------------------------------------------------------------------------
             Purpose:      To retrieve information on the currently selected Roundtable Task
             Parameters:
               OUTPUT  piTaskNumber
               OUTPUT  pcTaskSummary
               OUTPUT  pcTaskDescription     (15 entries, | delimited)
               OUTPUT  pcTaskProgrammer
               OUTPUT  pcTaskUserref
               OUTPUT  pcTaskWorkspace
               OUTPUT  pdTaskEnteredDate

             Notes:
           ------------------------------------------------------------------------------*/
    DEFINE OUTPUT PARAMETER piTaskNumber       AS INTEGER   NO-UNDO INITIAL 0 .
    DEFINE OUTPUT PARAMETER pcTaskSummary      AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER pcTaskDescription  AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER pcTaskProgrammer   AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER pcTaskUserref      AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER pcTaskWorkspace    AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER pdTaskEnteredDate  AS DATE      NO-UNDO.

    DEFINE VARIABLE iRtbCurrentTask AS INTEGER NO-UNDO.
    DEFINE VARIABLE hTaskBuf        AS HANDLE  NO-UNDO.
    DEFINE VARIABLE hTaskData       AS HANDLE  NO-UNDO.

    /* Get the current task */
    PUBLISH "evRtbGetCurrentTask":U (OUTPUT iRtbCurrentTask).

    IF iRtbCurrentTask > 0 THEN
    DO:
        IF NOT VALID-HANDLE(ghRtbAs)  THEN
            PUBLISH "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

        /* Get task info */
        RUN rtb/proxy/p/rtbGetTask.p ON ghRtbAs
            (INPUT iRtbCurrentTask,
            OUTPUT TABLE-HANDLE hTaskData).

        hTaskBuf = hTaskData:DEFAULT-BUFFER-HANDLE.
        hTaskBuf:FIND-FIRST() NO-ERROR.

        ASSIGN
            piTaskNumber      = hTaskBuf::task-num
            pcTaskSummary     = TRIM(hTaskBuf::summary)
            pcTaskProgrammer  = TRIM(LC(hTaskBuf::programmer))
            pcTaskUserref     = TRIM(hTaskBuf::user-task-ref)
            pcTaskWorkspace   = TRIM(LC(hTaskBuf::wspace-id))
            pdTaskEnteredDate = hTaskBuf::entered-when
            pcTaskDescription = hTaskBuf::taskDescription.
    END.

    ERROR-STATUS:ERROR = NO.
    RETURN.

    FINALLY:
        IF VALID-HANDLE(hTaskData) THEN
            DELETE OBJECT hTaskData.
    END FINALLY.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rtb-get-userinfo) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rtb-get-userinfo Procedure
PROCEDURE rtb-get-userinfo :
    /*------------------------------------------------------------------------------
             Purpose:     To retrieve information on the current Roundtable user
             Parameters:
               OUTPUT  op_user_code
               OUTPUT  op_user_name
             Notes:
           ------------------------------------------------------------------------------*/
    DEFINE OUTPUT PARAMETER pcUserCode    AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER pcUserName    AS CHARACTER NO-UNDO.

    DEFINE VARIABLE hUserBuf  AS HANDLE    NO-UNDO.
    DEFINE VARIABLE cRowIdent AS CHARACTER NO-UNDO.
    DEFINE VARIABLE hUserData AS HANDLE    NO-UNDO.

    /* Get the current user */
    PUBLISH "evRtbGetCurrentUser":U (OUTPUT gcRtbCurrentUser).

    IF NOT VALID-HANDLE(ghRtbAs)  THEN
        PUBLISH "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

    ASSIGN
        cRowIdent = "FIRST":U.

    RUN rtb/proxy/p/rtbGetUsers.p ON ghRtbAs
        (INPUT-OUTPUT cRowIdent,
        INPUT 0,
        OUTPUT TABLE-HANDLE hUserData).

    hUserBuf = hUserData:DEFAULT-BUFFER-HANDLE.
    hUserBuf:FIND-FIRST("WHERE user-id = " + "'":U + gcRtbCurrentUser + "'":U, NO-LOCK) NO-ERROR.

    IF hUserBuf:AVAILABLE THEN
        ASSIGN
            pcUserCode = hUserBuf::USER-ID
            pcUserName = hUserBuf::user-name.

    ERROR-STATUS:ERROR = NO.
    RETURN.

    FINALLY:
        IF VALID-HANDLE(hUserData) THEN
            DELETE OBJECT hUserData.
    END FINALLY.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rtb-get-version-notes) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rtb-get-version-notes Procedure
PROCEDURE rtb-get-version-notes :
    /*------------------------------------------------------------------------------
             Purpose:     To Retrieve version notes about a passed in object version. All
                          details are passed back in | delimited lists in case multiple
                          records exists for the same version. This would only be the case
                          if an object has moved modules, but must be coped with and the
                          multiple records returned, as they may have been done under
                          different tasks and by different people, etc.

                          This is not a problem in the other proecdures as we are only
                          dealing with the version notes for the current objects module !

             Parameters:
               INPUT   pcObject              object name (including extension)
               INPUT   pcProductModule       product module
               INPUT   pcObject_version      version of object
               OUTPUT  pcObjectUpdNotes      version update notes
               OUTPUT  piTaskNumber          Task version was editted under
               OUTPUT  pcTaskProgrammer      Author of task
               OUTPUT  pcTaskUserref         Project reference for task
               OUTPUT  pcTaskDate            Task entered date or completed date if complete

             Notes:
           ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER pcObject               AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER pcProductModule        AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER ipObjectVersion        AS INTEGER   NO-UNDO.
    DEFINE OUTPUT PARAMETER pcObjectUpdNotes       AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER piTaskNumber           AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER pcTaskProgrammer       AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER pcTaskUserref          AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER pcTaskDate             AS CHARACTER NO-UNDO.

    DEFINE VARIABLE iLoop                AS INTEGER   NO-UNDO.
    DEFINE VARIABLE cLine                AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cText                AS CHARACTER NO-UNDO.
    DEFINE VARIABLE hTaskRow             AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hObjRow              AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hVerRow              AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hTaskBuf             AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hObjBuf              AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hVerBuf              AS HANDLE    NO-UNDO.
    DEFINE VARIABLE iTask                AS INTEGER   NO-UNDO.
    DEFINE VARIABLE cObjVersionRowid     AS CHARACTER NO-UNDO.
    DEFINE VARIABLE hVersionAncestryData AS HANDLE    NO-UNDO.

    /* We do not have a proxy call that takes the object and object version as input parameters,
       we know that the only place this procedure is used, is from the SCM version notes
       XFTR of the AppBuilder - and this starts off by using the current object.

       So we can simnply use the object name to find the details we need and gom from there... */

    /* New code to use RTB proxies for RTB 10.1A */
    /*   Find current version of object in the workspace*/
    IF gcRtbCurrentWorkspace  NE "":U THEN
    DO:

        IF NOT VALID-HANDLE(ghRtbAs)  THEN
            PUBLISH "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

        RUN rtb/proxy/p/rtbGetObject.p ON ghRtbAs
            (INPUT gcRtbCurrentWorkspace,
            INPUT "PCODE",
            INPUT pcObject,
            INPUT pcProductModule,
            OUTPUT TABLE-HANDLE hObjRow).

        hObjBuf = hObjRow:DEFAULT-BUFFER-HANDLE.
        hObjBuf:FIND-FIRST() NO-ERROR.

        IF NOT hObjBuf:AVAILABLE THEN
        DO:
            IF VALID-HANDLE(hObjRow) THEN
                DELETE OBJECT hObjRow.
            RETURN.
        END.
        ELSE
        DO:
            ASSIGN
                cObjVersionRowid = hObjBuf::objVersionRowid.
            RUN rtb/proxy/p/rtbGetVersionAncestry.p ON ghRtbAs
                (INPUT hObjBuf::obj-type,
                INPUT hObjBuf::object,
                INPUT hObjBuf::pmod,
                INPUT hObjBuf::VERSION,
                OUTPUT TABLE-HANDLE hVersionAncestryData).

            CREATE QUERY hQry.
            hBuf = hVersionAncestryData:DEFAULT-BUFFER-HANDLE.
            hQry:SET-BUFFERS(hBuf).
            hQry:QUERY-PREPARE(SUBSTITUTE("FOR EACH &1",hVersionAncestryData:NAME)).
            hQry:QUERY-OPEN.
            hQry:GET-FIRST.

            REPEAT WHILE NOT hQry:QUERY-OFF-END:
                ASSIGN
                    iTask = hBuf::task-num.
                IF iTask > 0 THEN
                DO:
                    /* Get task info */
                    RUN rtb/proxy/p/rtbGetTask.p ON ghRtbAs
                        (INPUT iTask,
                        OUTPUT TABLE-HANDLE hTaskRow).

                    hTaskBuf = hTaskRow:DEFAULT-BUFFER-HANDLE.
                    hTaskBuf:FIND-FIRST() NO-ERROR.
                    IF hTaskBuf:AVAILABLE THEN
                    DO:
                        ASSIGN
                            pcTaskProgrammer = pcTaskProgrammer
                                      + (IF NUM-ENTRIES(pcTaskProgrammer,"|":U) > 0 THEN "|":U ELSE "":U)
                                      + REPLACE(hTaskBuf:BUFFER-FIELD('programmer':U):BUFFER-VALUE,"|":U," ":U)
                            pcTaskUserref    = pcTaskUserref
                                      + (IF NUM-ENTRIES(pcTaskUserref,"|":U) > 0 THEN "|":U ELSE "":U)
                                      + REPLACE(TRIM(hTaskBuf:BUFFER-FIELD('user-task-ref':U):BUFFER-VALUE),"|":U," ":U)
                            pcTaskDate       = pcTaskDate
                                      + (IF NUM-ENTRIES(pcTaskDate,"|":U) > 0 THEN "|":U ELSE "":U)
                                      + STRING(hTaskBuf:BUFFER-FIELD('entered-when':U):BUFFER-VALUE).
                    END.
                END.

                ASSIGN
                    piTaskNumber     = piTaskNumber
                                 + (IF NUM-ENTRIES(piTaskNumber,"|":U) > 0 THEN "|":U ELSE "":U)
                                 + STRING(hBuf::task-num)

                    pcObjectUpdNotes = pcObjectUpdNotes
                                + (IF NUM-ENTRIES(pcObjectUpdNotes,"|":U) > 0 THEN "|":U ELSE "":U)
                                + REPLACE(hBuf::upd-notes,"|":U," ":U).

                IF ENTRY(NUM-ENTRIES(piTaskNumber,"|":U),pcObjectUpdNotes,"|":U) = "" AND
                    hTaskBuf:AVAILABLE THEN
                DO:
                    ASSIGN
                        cText = hTaskBuf:BUFFER-FIELD('taskDescription':U):BUFFER-VALUE.
                    ASSIGN
                        ENTRY(NUM-ENTRIES(piTaskNumber,"|":U),pcObjectUpdNotes,"|":U) = (IF REPLACE(cText,"|":U," ":U) NE "":U THEN REPLACE(cText,"|":U," ":U) ELSE TRIM(hTaskBuf:BUFFER-FIELD('taskDescription':U):BUFFER-VALUE)).
                END.

                hQry:GET-NEXT.
            END.

            IF VALID-HANDLE(hQry) THEN
                DELETE OBJECT hQry.
        END.
    END.

    ERROR-STATUS:ERROR = NO.
    RETURN.

    FINALLY:
        IF VALID-HANDLE(hObjRow) THEN
            DELETE OBJECT hObjRow.

        IF VALID-HANDLE(hTaskRow) THEN
            DELETE OBJECT hTaskRow.

        IF VALID-HANDLE(hVersionAncestryData) THEN
            DELETE OBJECT hVersionAncestryData.

        IF VALID-HANDLE(hQry) THEN
            DELETE OBJECT hQry.

    END FINALLY.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rtb-set-objectinfo) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rtb-set-objectinfo Procedure
PROCEDURE rtb-set-objectinfo :
    /*------------------------------------------------------------------------------
             Purpose:     To update information about the passed in object for the passed in
                          task, back into roundtable.
             Parameters:
               INPUT   pcObject              object name (including extension)
               INPUT   piTaskNumber          current task
               INPUT   ipObjectVersion       current version of object in task
               INPUT   pcObject_summary      summary description of object
               INPUT   pcObjectDescription   full object description
               INPUT   pcObject_upd_notes    version update notes
             Notes:
           ------------------------------------------------------------------------------*/
    DEFINE INPUT PARAMETER  pcObject              AS CHARACTER NO-UNDO.
    DEFINE INPUT PARAMETER  pcProductModule       AS CHARACTER NO-UNDO.
    DEFINE INPUT PARAMETER  piTaskNumber          AS INTEGER   NO-UNDO.
    DEFINE INPUT PARAMETER  ipObjectVersion       AS INTEGER   NO-UNDO.

    /* These details updated */
    DEFINE INPUT PARAMETER  pcObjectSummary       AS CHARACTER NO-UNDO.
    DEFINE INPUT PARAMETER  pcObjectDescription   AS CHARACTER NO-UNDO.
    DEFINE INPUT PARAMETER  pcObjectUpdNotes      AS CHARACTER NO-UNDO.

    DEFINE VARIABLE cTaskWorkspace AS CHARACTER NO-UNDO.
    DEFINE VARIABLE iLoop          AS INTEGER   NO-UNDO.
    DEFINE VARIABLE iNumEntries    AS INTEGER   NO-UNDO.
    DEFINE VARIABLE hObjRow        AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hObjBuf        AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hVerRow        AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hVerBuf        AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hTaskBuf       AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hOcBuf         AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hOcTT          AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hTaskData      AS HANDLE    NO-UNDO.

    /* Find passed in task to get current workspace */
    IF piTaskNumber > 0 THEN
    DO:
        IF NOT VALID-HANDLE(ghRtbAs)  THEN
            PUBLISH "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

        /* Get task info */
        RUN rtb/proxy/p/rtbGetTask.p ON ghRtbAs
            (INPUT piTaskNumber,
            OUTPUT TABLE-HANDLE hTaskData).

        hTaskBuf = hTaskData:DEFAULT-BUFFER-HANDLE.
        hTaskBuf:FIND-FIRST() NO-ERROR.

        IF NOT hTaskBuf:AVAILABLE THEN
        DO:
            MESSAGE
                "Could not update object in Roundtable as the task was not found"
                VIEW-AS ALERT-BOX.
            RETURN.
        END.
        ELSE
            ASSIGN cTaskWorkspace = TRIM(hTaskBuf:BUFFER-FIELD('wspace-id':U):BUFFER-VALUE).
    END.

    /*   Find current version of object in the workspace*/
    IF cTaskWorkspace NE "":U THEN
    DO:
        RUN rtb/proxy/p/rtbGetObject.p ON ghRtbAs
            (INPUT cTaskWorkspace,
            INPUT  "PCODE",
            INPUT  pcObject,
            INPUT  pcProductModule,
            OUTPUT TABLE-HANDLE hObjRow).

        hObjBuf = hObjRow:DEFAULT-BUFFER-HANDLE.
        hObjBuf:FIND-FIRST() NO-ERROR.

        IF NOT hObjBuf:AVAILABLE THEN
        DO:
            MESSAGE
                "Could not update object in Roundtable as the object was not found"
                VIEW-AS ALERT-BOX.
            IF VALID-HANDLE(hObjRow) THEN
                DELETE OBJECT hObjRow.
            RETURN.
        END.

        /* Get object version details */
        RUN rtb/proxy/p/rtbGetVersion.p ON ghRtbAs (
            INPUT  hObjBuf::obj-type,
            INPUT  hObjBuf::object,
            INPUT  hObjBuf::pmod,
            INPUT  hObjBuf::VERSION,
            OUTPUT TABLE-HANDLE hVerRow).

        hVerBuf = hVerRow:DEFAULT-BUFFER-HANDLE.
        hVerBuf:FIND-FIRST() NO-ERROR.

        IF NOT hVerBuf:AVAILABLE THEN
        DO:
            MESSAGE
                "Could not update object version - not found !"
                VIEW-AS ALERT-BOX.

            IF VALID-HANDLE(hVerRow) THEN
                DELETE OBJECT hVerRow.
            RETURN.
        END.

        /* Create a copy of the original record we received */
        CREATE TEMP-TABLE hOcTT.
        hOcTT:CREATE-LIKE(hVerRow).
        hOcTT:TEMP-TABLE-PREPARE(hVerBuf:NAME).

        hOcBuf = hOcTT:DEFAULT-BUFFER-HANDLE.
        hOcBuf:BUFFER-CREATE.
        hOcBuf:BUFFER-COPY(hVerBuf).

        /* Create another copy to hold the updated values */
        hOcBuf:BUFFER-CREATE.
        hOcBuf:BUFFER-COPY(hVerBuf).
        hOcBuf::rowMod = "U".

        /* Update the descrioption and version notes */
        ASSIGN
            hOcBuf::description = pcObjectSummary
            hOcBuf::upd-notes   = pcObjectUpdNotes.

        ASSIGN
            iNumEntries = NUM-ENTRIES(pcObjectDescription,CHR(10)).
        IF iNumEntries > 16 THEN
        DO:
            MESSAGE
                "Part of the version notes has not been written to Roundtable as" SKIP
                "Roundtable has a maximum of 16 lines for version notes"
                VIEW-AS ALERT-BOX WARNING BUTTONS OK.
            ASSIGN
                iNumEntries = 16.
        END.
        ELSE
            ASSIGN hOcBuf::verTextDesc = pcObjectDescription.

        RUN rtb/proxy/p/rtbSetRowValues.p ON ghRtbAs (
            INPUT "rtbVersion":U,
            INPUT-OUTPUT TABLE-HANDLE hOcTT,
            OUTPUT cError).

        IF VALID-HANDLE(hOcTT) THEN
            DELETE OBJECT hOcTT.
    END.

    IF cError <> "" THEN
        MESSAGE cError
            VIEW-AS ALERT-BOX ERROR.

    ERROR-STATUS:ERROR = NO.
    RETURN.

    FINALLY:
        /* Clean up */
        IF VALID-HANDLE(hTaskData) THEN
            DELETE OBJECT hTaskData.

        IF VALID-HANDLE(hObjRow) THEN
            DELETE OBJECT hObjRow.

        IF VALID-HANDLE(hVerRow) THEN
            DELETE OBJECT hVerRow.
    END FINALLY.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rtb-set-taskinfo) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rtb-set-taskinfo Procedure
PROCEDURE rtb-set-taskinfo :
    /*------------------------------------------------------------------------------
             Purpose:      To update task information into Roundtable - the only task info
                           that may be updated is the user reference !
             Parameters:
               INPUT  piTaskNumber
               INPUT  pcTaskUserref

             Notes:
           ------------------------------------------------------------------------------*/
    DEFINE INPUT PARAMETER piTaskNumber  AS INTEGER   NO-UNDO.
    DEFINE INPUT PARAMETER pcTaskUserref AS CHARACTER NO-UNDO.

    DEFINE VARIABLE cError    AS CHARACTER NO-UNDO.
    DEFINE VARIABLE hTaskBuf  AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hOcBuf    AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hOcTT     AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hTaskData AS HANDLE    NO-UNDO.
    DEFINE VARIABLE cRowIdent AS CHARACTER NO-UNDO INITIAL "FIRST".

    /* Find passed in task to get current workspace */
    IF piTaskNumber > 0 AND
        pcTaskUserref NE "":U THEN
    DO:
        IF NOT VALID-HANDLE(ghRtbAs)  THEN
            PUBLISH "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

        /* Get task info */
        hTaskData = oRtbProxyHelper:rtbGetTaskHandle(piTaskNumber).

        hTaskBuf = hTaskData:DEFAULT-BUFFER-HANDLE.
        hTaskBuf:FIND-FIRST() NO-ERROR.

        IF NOT hTaskBuf:AVAILABLE THEN
        DO:
            MESSAGE
                "Could not update task - Task not found !"
                VIEW-AS ALERT-BOX.
            IF VALID-HANDLE(hTaskData) THEN
                DELETE OBJECT hTaskData.
            RETURN.
        END.
        ELSE
        DO ON ERROR UNDO:
            /* Create a copy of the original record we received */
            CREATE TEMP-TABLE hOcTT.
            hOcTT:CREATE-LIKE(hTaskData).
            hOcTT:TEMP-TABLE-PREPARE(hTaskBuf:NAME).

            hOcBuf = hOcTT:DEFAULT-BUFFER-HANDLE.
            hOcBuf:BUFFER-CREATE.
            hOcBuf:BUFFER-COPY(hTaskBuf).

            /*
                  Create another copy to hold the updated values
                 */
            hOcBuf:BUFFER-CREATE.
            hOcBuf:BUFFER-COPY(hTaskBuf).
            ASSIGN
                hOcBuf::user-task-ref = pcTaskUserref.
            hOcBuf::rowMod = "U".

            /* Set task info */
            oRtbProxyHelper:rtbSetRowValues(
                INPUT "rtbTask",
                INPUT-OUTPUT TABLE-HANDLE hOcTT).

            CATCH err AS Progress.Lang.Error :
                ASSIGN
                    cError = err:GetMessage(1).
            END CATCH.
        END.
    END.

    ERROR-STATUS:ERROR = NO.

    RETURN.

    CATCH err AS Progress.Lang.Error :
        ASSIGN
            cError = err:GetMessage(1).

    END CATCH.

    FINALLY:
        /* Clean up */
        IF VALID-HANDLE(hTaskData) THEN
            DELETE OBJECT hTaskData.

        /* Clean up */
        IF VALID-HANDLE(hOcTT) THEN
            DELETE OBJECT hOcTT.
    END FINALLY.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rtb-update-history-notes) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rtb-update-history-notes Procedure
PROCEDURE rtb-update-history-notes :
    /*------------------------------------------------------------------------------
             Purpose:     To update task notes history records
             Parameters:  see below
             Notes:

             Status:  *** This procedure has not been converted to use Proxies.
           ------------------------------------------------------------------------------*/

    DEFINE INPUT PARAMETER  ip_tnot_rowid                   AS ROWID        NO-UNDO.
    DEFINE INPUT PARAMETER  ip_entered_when                 AS DATE         NO-UNDO.
    DEFINE INPUT PARAMETER  ip_completed_when               AS DATE         NO-UNDO.
    DEFINE INPUT PARAMETER  pcCompletedBy                   AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  ip_actual_hours                 AS DECIMAL      NO-UNDO.
    DEFINE INPUT PARAMETER  ip_estimate_hours               AS DECIMAL      NO-UNDO.
    DEFINE INPUT PARAMETER  ip_note_priority                AS INTEGER      NO-UNDO.
    DEFINE INPUT PARAMETER  ip_note_status                  AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  ip_note_type                    AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  ip_note_user                    AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  ip_status_notes                 AS CHARACTER    NO-UNDO.
    DEFINE OUTPUT PARAMETER pcError                         AS CHARACTER    NO-UNDO.
    /*
      DEFINE BUFFER lb1_rtb_tnot FOR rtb_tnot.

      DEFINE VARIABLE iLoop                                 AS INTEGER      NO-UNDO.
      DEFINE VARIABLE cCharacter                            AS CHARACTER    NO-UNDO.

      DO FOR lb1_rtb_tnot:

        FIND FIRST lb1_rtb_tnot EXCLUSIVE-LOCK
          WHERE ROWID(lb1_rtb_tnot) = ip_tnot_rowid
          NO-WAIT NO-ERROR.

        IF NOT AVAILABLE lb1_rtb_tnot AND
           LOCKED lb1_rtb_tnot THEN
        DO:
          ASSIGN pcError = "Cannot update RTB History Task Notes as they are locked by another user".
          RETURN.
        END.

        IF NOT AVAILABLE lb1_rtb_tnot THEN DO:
          ASSIGN pcError = "Cannot update RTB History Task Notes as they have been deleted by another user".
          RETURN.
        END.

        /* Record found or created - update rest of details */
        DO iLoop = 1 TO 15:
          IF iLoop <= NUM-ENTRIES(ip_status_notes,CHR(10)) THEN
            ASSIGN cCharacter = REPLACE(ENTRY(iLoop,ip_status_notes,CHR(10)),"|":U," ":U).
          ELSE
            ASSIGN cCharacter = "":U.
          ASSIGN lb1_rtb_tnot.description[iLoop] = cCharacter.
        END.

        ASSIGN
          lb1_rtb_tnot.entered-when   = ip_entered_when
          lb1_rtb_tnot.compltd-when   = ip_completed_when
          lb1_rtb_tnot.compltd-by     = pcCompletedBy
          lb1_rtb_tnot.act-hours      = ip_actual_hours
          lb1_rtb_tnot.est-hours      = ip_estimate_hours
          lb1_rtb_tnot.note-priority  = ip_note_priority
          lb1_rtb_tnot.note-status    = ip_note_status
          lb1_rtb_tnot.note-type      = ip_note_type
          lb1_rtb_tnot.user-name      = ip_note_user
          NO-ERROR.
        IF ERROR-STATUS:ERROR THEN
        DO:
          ASSIGN pcError = "Cannot update RTB History Task Notes due to invalid data" NO-ERROR.
          RETURN.
        END.

        /* No point in doing validation keyword as RTB has no triggers */
        RELEASE lb1_rtb_tnot NO-ERROR.

        ASSIGN pcError = "":U NO-ERROR.
      END.    /* do for */
    */
    ERROR-STATUS:ERROR = NO.
    RETURN.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rtb-update-history-notes-control) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rtb-update-history-notes-control Procedure
PROCEDURE rtb-update-history-notes-control :
    /*------------------------------------------------------------------------------
             Purpose:     To update task notes history records
             Parameters:  see below
             Notes:
           ------------------------------------------------------------------------------*/

    DEFINE INPUT PARAMETER  ip_tnot_rowid                   AS ROWID        NO-UNDO.
    DEFINE INPUT PARAMETER  ip_entered_when                 AS DATE         NO-UNDO.
    DEFINE INPUT PARAMETER  ip_completed_when               AS DATE         NO-UNDO.
    DEFINE INPUT PARAMETER  pcCompletedBy                 AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  ip_actual_hours                 AS DECIMAL      NO-UNDO.
    DEFINE INPUT PARAMETER  ip_estimate_hours               AS DECIMAL      NO-UNDO.
    DEFINE INPUT PARAMETER  ip_note_priority                AS INTEGER      NO-UNDO.
    DEFINE INPUT PARAMETER  ip_note_status                  AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  ip_note_type                    AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  ip_note_user                    AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  ip_status_notes                 AS CHARACTER    NO-UNDO.
    DEFINE OUTPUT PARAMETER pcError                    AS CHARACTER    NO-UNDO.

    TRANSACTION-BLOCK:
    DO TRANSACTION:
        RUN rtb-update-history-notes (INPUT ip_tnot_rowid,
            INPUT ip_entered_when,
            INPUT ip_completed_when,
            INPUT pcCompletedBy,
            INPUT ip_actual_hours,
            INPUT ip_estimate_hours,
            INPUT ip_note_priority,
            INPUT ip_note_status,
            INPUT ip_note_type,
            INPUT ip_note_user,
            INPUT ip_status_notes,
            OUTPUT pcError).

        IF pcError <> "":U
            THEN
            UNDO TRANSACTION-BLOCK, LEAVE TRANSACTION-BLOCK.

    END. /* transaction-block */

    ERROR-STATUS:ERROR = NO.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rtb-update-task) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rtb-update-task Procedure
PROCEDURE rtb-update-task :
    /*------------------------------------------------------------------------------
             Purpose:     To update all task details for an existing task
             Parameters:  SEE BELOW
             Notes:
           ------------------------------------------------------------------------------*/
    DEFINE INPUT PARAMETER  piTaskNumber                  AS INTEGER      NO-UNDO.
    DEFINE INPUT PARAMETER  pcTaskSummary                 AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  pcCompletedBy                 AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  pcCompletedDate               AS DATE         NO-UNDO.
    DEFINE INPUT PARAMETER  pdEnteredDate                 AS DATE         NO-UNDO.
    DEFINE INPUT PARAMETER  pcManager                     AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  pcProgrammer                  AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  pcShareStatus                 AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  pcTaskDirectory               AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  pcUserReference               AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  pcWorkspace                   AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  pcTaskNotes                   AS CHARACTER    NO-UNDO.
    DEFINE OUTPUT PARAMETER prTask_rowid                  AS ROWID        NO-UNDO.
    DEFINE OUTPUT PARAMETER pcError                       AS CHARACTER    NO-UNDO.

    DEFINE VARIABLE hTaskData AS HANDLE NO-UNDO.
    DEFINE VARIABLE hTaskBuf  AS HANDLE NO-UNDO.
    DEFINE VARIABLE hOcBuf    AS HANDLE NO-UNDO.
    DEFINE VARIABLE hOcTT     AS HANDLE NO-UNDO.

    IF NOT VALID-HANDLE(ghRtbAs)  THEN
        PUBLISH "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

    /* Get task info */
    RUN rtb/proxy/p/rtbGetTask.p ON ghRtbAs
        (INPUT piTaskNumber,
        OUTPUT TABLE-HANDLE hTaskData).

    hTaskBuf = hTaskData:DEFAULT-BUFFER-HANDLE.
    hTaskBuf:FIND-FIRST() NO-ERROR.

    IF hTaskBuf:AVAILABLE THEN
    DO ON ERROR UNDO:
        /* Create a copy of the original record we received */
        CREATE TEMP-TABLE hOcTT.
        hOcTT:CREATE-LIKE(hTaskData).
        hOcTT:TEMP-TABLE-PREPARE(hTaskBuf:NAME).

        hOcBuf = hOcTT:DEFAULT-BUFFER-HANDLE.
        hOcBuf:BUFFER-CREATE.
        hOcBuf:BUFFER-COPY(hTaskBuf).

        /* Create another copy to hold the updated values */
        hOcBuf:BUFFER-CREATE.
        hOcBuf:BUFFER-COPY(hTaskBuf).
        hOcBuf::rowMod = "U".

        ASSIGN
            hOcBuf::summary                                       = pcTaskSummary
            hOcBuf::compltd-by                                    = pcCompletedBy
            hOcBuf::compltd-when                                  = pcCompletedDate
            hOcBuf::entered-when                                  = pdEnteredDate
            hOcBuf::manager                                       = pcManager
            hOcBuf::programmer                                    = pcProgrammer
            hOcBuf::share-status                                  = pcShareStatus
            hOcBuf::task-directory                                = pcTaskDirectory
            hOcBuf::wspace-id                                     = pcWorkspace
            hOcBuf::user-task-ref                                 = pcUserReference
            hOcBuf:BUFFER-FIELD('taskDescription':U):BUFFER-VALUE = pcTaskNotes.

        /* Set task info */
        oRtbProxyHelper:rtbSetRowValues(
            INPUT "rtbTask",
            INPUT-OUTPUT TABLE-HANDLE hOcTT).

        CATCH err AS Progress.Lang.Error :
            ASSIGN
                pcError = err:GetMessage(1).
        END CATCH.
    END.
    ELSE
    DO:
        ASSIGN
            pcError = "Unable to update RTB Task due to invalid data" NO-ERROR.
        RETURN.
    END.

    ASSIGN
        prTask_rowid = TO-ROWID(hTaskBuf:BUFFER-FIELD('rowident':U):BUFFER-VALUE).

    IF VALID-HANDLE(hTaskBuf) THEN
        DELETE OBJECT hTaskBuf.

    IF VALID-HANDLE(hTaskData) THEN
        DELETE OBJECT hTaskData.

    IF VALID-HANDLE(hOcTT) THEN
        DELETE OBJECT hOcTT.

    ERROR-STATUS:ERROR = NO.
    RETURN.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rtb-update-task-control) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rtb-update-task-control Procedure
PROCEDURE rtb-update-task-control :
    /*------------------------------------------------------------------------------
             Purpose:     To update all task details for an existing task
             Parameters:  SEE BELOW
             Notes:
           ------------------------------------------------------------------------------*/

    DEFINE INPUT PARAMETER  piTaskNumber                  AS INTEGER      NO-UNDO.
    DEFINE INPUT PARAMETER  pcTaskSummary                 AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  pcCompletedBy                 AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  pcCompletedDate               AS DATE         NO-UNDO.
    DEFINE INPUT PARAMETER  pdEnteredDate                 AS DATE         NO-UNDO.
    DEFINE INPUT PARAMETER  pcManager                      AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  pcProgrammer                   AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  pcShareStatus                 AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  pcTaskDirectory               AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  pcUserReference               AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  pcWorkspace                    AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  pcTaskDescription             AS CHARACTER    NO-UNDO.
    DEFINE OUTPUT PARAMETER prTask_rowid                   AS ROWID        NO-UNDO.
    DEFINE OUTPUT PARAMETER pcError                    AS CHARACTER    NO-UNDO.

    TRANSACTION-BLOCK:
    DO TRANSACTION:

        RUN rtb-update-task (INPUT piTaskNumber,
            INPUT pcTaskSummary,
            INPUT pcCompletedBy,
            INPUT pcCompletedDate,
            INPUT pdEnteredDate,
            INPUT pcManager,
            INPUT pcProgrammer,
            INPUT pcShareStatus,
            INPUT pcTaskDirectory,
            INPUT pcUserReference,
            INPUT pcWorkspace,
            INPUT pcTaskDescription,
            OUTPUT prTask_rowid,
            OUTPUT pcError).

        IF pcError <> "":U
            THEN
            UNDO TRANSACTION-BLOCK, LEAVE TRANSACTION-BLOCK.

    END. /* transaction-block */

    ERROR-STATUS:ERROR = NO.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rtb-update-task-notes) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rtb-update-task-notes Procedure
PROCEDURE rtb-update-task-notes :
    /*------------------------------------------------------------------------------
             Purpose:     To update / create task notes
             Parameters:  See below
             Notes:

             Status:  *** This procedure has not been converted to use Proxies.
           -----------------------------------------------------------------------------*/

    DEFINE INPUT PARAMETER  piTaskNumber                  AS INTEGER      NO-UNDO.
    DEFINE INPUT PARAMETER  ip_pmod                         AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  ip_obj_type                     AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  pcObject                       AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  piVersion                      AS INTEGER      NO-UNDO.
    DEFINE INPUT PARAMETER  ip_entered_when                 AS DATE         NO-UNDO.
    DEFINE INPUT PARAMETER  ip_completed_when               AS DATE         NO-UNDO.
    DEFINE INPUT PARAMETER  pcCompletedBy                 AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  ip_actual_hours                 AS DECIMAL      NO-UNDO.
    DEFINE INPUT PARAMETER  ip_estimate_hours               AS DECIMAL      NO-UNDO.
    DEFINE INPUT PARAMETER  ip_note_priority                AS INTEGER      NO-UNDO.
    DEFINE INPUT PARAMETER  ip_note_status                  AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  ip_note_type                    AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  ip_note_user                    AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  ip_status_notes                 AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  ip_current_area                 AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  ip_new_area                     AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  ip_current_status               AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  ip_new_status                   AS CHARACTER    NO-UNDO.
    DEFINE OUTPUT PARAMETER op_tnot_rowid                   AS ROWID        NO-UNDO.
    DEFINE OUTPUT PARAMETER pcError                    AS CHARACTER    NO-UNDO.
    /*
      DEFINE BUFFER lb1_rtb_tnot FOR rtb_tnot.
      DEFINE BUFFER lb2_rtb_tnot FOR rtb_tnot.

      DEFINE VARIABLE iLoop                                 AS INTEGER      NO-UNDO.
      DEFINE VARIABLE cCharacter                            AS CHARACTER    NO-UNDO.

      DO FOR lb1_rtb_tnot, lb2_rtb_tnot:

        /* If status changed, update existing notes to complete them */
        IF (ip_current_area <> ip_new_area
        OR ip_current_status <> ip_new_status)
        AND ip_current_area <> "":U
        AND ip_current_status <> "":U
        THEN DO:
          FIND FIRST lb1_rtb_tnot EXCLUSIVE-LOCK
            WHERE lb1_rtb_tnot.task-num = piTaskNumber
            AND   lb1_rtb_tnot.obj-type = "pcode":U
            NO-WAIT NO-ERROR.
          IF NOT AVAILABLE lb1_rtb_tnot
          AND LOCKED lb1_rtb_tnot
          THEN DO:
            ASSIGN
              pcError = "Cannot update RTB Task Notes as they are locked by another user".
            RETURN.
          END.
          IF AVAILABLE lb1_rtb_tnot
          THEN DO:
            ASSIGN
              lb1_rtb_tnot.obj-type     = "doc":U
              lb1_rtb_tnot.compltd-when = TODAY
              lb1_rtb_tnot.compltd-by   = gcRtbCurrentUser
              NO-ERROR.
            IF ERROR-STATUS:ERROR
            THEN DO:
              ASSIGN
                pcError = "Cannot update existing RTB Task Notes due to invalid data" NO-ERROR.
              RETURN.
            END.
          END.
        END.

        /* Update / create new task notes, coping with change back to old status */
        FIND FIRST lb2_rtb_tnot EXCLUSIVE-LOCK
          WHERE lb2_rtb_tnot.task-num = piTaskNumber
          AND   lb2_rtb_tnot.pmod     = ip_new_area
          AND   lb2_rtb_tnot.object   = ip_new_status
          NO-WAIT NO-ERROR.
        IF NOT AVAILABLE lb2_rtb_tnot
        AND LOCKED lb2_rtb_tnot
        THEN DO:
          ASSIGN
            pcError = "Cannot update new RTB Task Notes as they are locked by another user".
          RETURN.
        END.
        IF NOT AVAILABLE lb2_rtb_tnot
        THEN DO:
          CREATE lb2_rtb_tnot NO-ERROR.
          IF ERROR-STATUS:ERROR
          THEN DO:
            ASSIGN
              pcError = "Cannot create new RTB Task Notes due to invalid data"
              NO-ERROR.
            RETURN.
          END.
          ASSIGN
            lb2_rtb_tnot.task-num = piTaskNumber
            lb2_rtb_tnot.pmod     = ip_new_area
            lb2_rtb_tnot.obj-type = ip_obj_type
            lb2_rtb_tnot.object   = ip_new_status
            lb2_rtb_tnot.version  = 1
            NO-ERROR.
          IF ERROR-STATUS:ERROR
          THEN DO:
            ASSIGN
              pcError = "Cannot create / update new RTB Task Notes due to invalid data"
              NO-ERROR.
            RETURN.
          END.
        END.

        DO iLoop = 1 TO 15:
          IF iLoop <= NUM-ENTRIES(ip_status_notes,CHR(10))
          THEN
            ASSIGN
              cCharacter = REPLACE(ENTRY(iLoop,ip_status_notes,CHR(10)),"|":U," ":U).
          ELSE
            ASSIGN
              cCharacter = "":U.
          ASSIGN
            lb2_rtb_tnot.description[iLoop] = cCharacter.
        END.

        /* Record found or created - update rest of details */
        ASSIGN
          lb2_rtb_tnot.obj-type       = ip_obj_type
          lb2_rtb_tnot.version        = piVersion
          lb2_rtb_tnot.entered-when   = ip_entered_when
          lb2_rtb_tnot.compltd-when   = ip_completed_when
          lb2_rtb_tnot.compltd-by     = pcCompletedBy
          lb2_rtb_tnot.act-hours      = ip_actual_hours
          lb2_rtb_tnot.est-hours      = ip_estimate_hours
          lb2_rtb_tnot.note-priority  = ip_note_priority
          lb2_rtb_tnot.note-status    = ip_note_status
          lb2_rtb_tnot.note-type      = ip_note_type
          lb2_rtb_tnot.user-name      = ip_note_user
          NO-ERROR.
        IF ERROR-STATUS:ERROR
        THEN DO:
          ASSIGN
            pcError = "Cannot update new RTB Task Notes due to invalid data" NO-ERROR.
          RETURN.
        END.

        /* No point in doing validation keyword as RTB has no triggers */
        ASSIGN op_tnot_rowid = ROWID(lb2_rtb_tnot).
        RELEASE lb1_rtb_tnot NO-ERROR.
        RELEASE lb2_rtb_tnot NO-ERROR.

        ASSIGN
          pcError = "":U
          NO-ERROR.

      END.    /* do for */
    */
    ERROR-STATUS:ERROR = NO.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rtb-update-task-notes-control) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rtb-update-task-notes-control Procedure
PROCEDURE rtb-update-task-notes-control :
    /*------------------------------------------------------------------------------
             Purpose:     To update / create task notes
             Parameters:  see below
             Notes:
           ------------------------------------------------------------------------------*/

    DEFINE INPUT PARAMETER  piTaskNumber                  AS INTEGER      NO-UNDO.
    DEFINE INPUT PARAMETER  ip_pmod                         AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  ip_obj_type                     AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  pcObject                       AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  piVersion                      AS INTEGER      NO-UNDO.
    DEFINE INPUT PARAMETER  ip_entered_when                 AS DATE         NO-UNDO.
    DEFINE INPUT PARAMETER  ip_completed_when               AS DATE         NO-UNDO.
    DEFINE INPUT PARAMETER  pcCompletedBy                 AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  ip_actual_hours                 AS DECIMAL      NO-UNDO.
    DEFINE INPUT PARAMETER  ip_estimate_hours               AS DECIMAL      NO-UNDO.
    DEFINE INPUT PARAMETER  ip_note_priority                AS INTEGER      NO-UNDO.
    DEFINE INPUT PARAMETER  ip_note_status                  AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  ip_note_type                    AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  ip_note_user                    AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  ip_status_notes                 AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  ip_current_area                 AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  ip_new_area                     AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  ip_current_status               AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  ip_new_status                   AS CHARACTER    NO-UNDO.
    DEFINE OUTPUT PARAMETER op_tnot_rowid                   AS ROWID        NO-UNDO.
    DEFINE OUTPUT PARAMETER pcError                    AS CHARACTER    NO-UNDO.

    TRANSACTION-BLOCK:
    DO TRANSACTION:

        RUN rtb-update-task-notes (INPUT piTaskNumber
            ,INPUT ip_pmod
            ,INPUT ip_obj_type
            ,INPUT pcObject
            ,INPUT piVersion
            ,INPUT ip_entered_when
            ,INPUT ip_completed_when
            ,INPUT pcCompletedBy
            ,INPUT ip_actual_hours
            ,INPUT ip_estimate_hours
            ,INPUT ip_note_priority
            ,INPUT ip_note_status
            ,INPUT ip_note_type
            ,INPUT ip_note_user
            ,INPUT ip_status_notes
            ,INPUT ip_current_area
            ,INPUT ip_new_area
            ,INPUT ip_current_status
            ,INPUT ip_new_status
            ,OUTPUT op_tnot_rowid
            ,OUTPUT pcError).

        IF pcError <> "":U
            THEN      UNDO TRANSACTION-BLOCK, LEAVE TRANSACTION-BLOCK.

    END. /* transaction-block */

    ERROR-STATUS:ERROR = NO.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmADOExtAdd) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmADOExtAdd Procedure
PROCEDURE scmADOExtAdd :
    /*------------------------------------------------------------------------------
             Purpose:
             Parameters:  <none>
             Notes:
           ------------------------------------------------------------------------------*/

    DEFINE INPUT-OUTPUT PARAMETER pcObjectAddADO AS CHARACTER  NO-UNDO.

    /* Add .ado extension to logical Dynamics Data Objects */
    IF NUM-ENTRIES(pcObjectAddADO,".":U) > 1 AND
        LOOKUP( ENTRY(NUM-ENTRIES(pcObjectAddADO,".":U),pcObjectAddADO,".":U) , "r,i,p,w,ado,xml,v,d,df" ) > 0 THEN
        ASSIGN pcObjectAddADO = pcObjectAddADO.
    ELSE
        ASSIGN pcObjectAddADO = pcObjectAddADO + ".ado":U.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmADOExtDelete) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmADOExtDelete Procedure
PROCEDURE scmADOExtDelete :
    /*------------------------------------------------------------------------------
             Purpose:
             Parameters:  <none>
             Notes:
           ------------------------------------------------------------------------------*/

    DEFINE INPUT-OUTPUT PARAMETER pcObjectDelADO AS CHARACTER  NO-UNDO.

    /* Del .ado extension from logical Dynamics Data Objects */
    ASSIGN
        pcObjectDelADO = REPLACE(pcObjectDelADO,".ado":U,"":U).

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmADOExtReplace) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmADOExtReplace Procedure
PROCEDURE scmADOExtReplace :
    /*------------------------------------------------------------------------------
             Purpose:
             Parameters:  <none>
             Notes:
           ------------------------------------------------------------------------------*/

    DEFINE INPUT-OUTPUT PARAMETER pcObjectReplaceADO AS CHARACTER  NO-UNDO.

    /* Replace .ado extension for logical Dynamics Data Objects */
    IF NUM-ENTRIES(pcObjectReplaceADO,".":U) > 1 AND
        LOOKUP( ENTRY(NUM-ENTRIES(pcObjectReplaceADO,".":U),pcObjectReplaceADO,".":U) , "r,i,p,w,ado,xml,v,d,df" ) > 0 THEN
        ASSIGN pcObjectReplaceADO = SUBSTRING(pcObjectReplaceADO,1,R-INDEX(pcObjectReplaceADO,".":U)) + "ado":U.
    ELSE    ASSIGN pcObjectReplaceADO = pcObjectReplaceADO + ".ado":U.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmAssignObject) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmAssignObject Procedure
PROCEDURE scmAssignObject :
    /*------------------------------------------------------------------------------
             Purpose:     To assign an object version into a workspace
             Parameters:  SEE BELOW
             Notes:       Object type is PCODE
                          Version is versioned being assigned to current workspace
                          recid is recird of object record assigned
           ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcProductModule               AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcObjectType    /* PCODE */   AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcObjectName                  AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  piVersion                     AS INTEGER      NO-UNDO.
    DEFINE OUTPUT PARAMETER  prRowid                       AS ROWID        NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcError                       AS CHARACTER    NO-UNDO.

    DEFINE VARIABLE cScmProductModule AS CHARACTER NO-UNDO.
    DEFINE VARIABLE dProductModuleObj AS DECIMAL   NO-UNDO.
    DEFINE VARIABLE cError            AS CHARACTER NO-UNDO.

    DEFINE VARIABLE hObjBuf           AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hObjRow           AS HANDLE    NO-UNDO.

    IF NOT VALID-HANDLE(ghRtbAs)  THEN
        PUBLISH "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

    IF pcProductModule <> "":U THEN
        RUN scmGetScmXref (INPUT  "RTB":U,
            INPUT  "GSCPM":U,
            INPUT  pcProductModule,
            INPUT  0,
            OUTPUT cScmProductModule,
            OUTPUT cError).

    IF cScmProductModule = "":U THEN
    DO:
        pcError = "Product module " + pcProductModule + " not found in Xref table":U.
        RETURN.
    END.
    ELSE
        /* Add the site prefix so that we are using the correct product module in RTB, which
          requires prefixes to be used */
        RUN scmSitePrefixAdd (INPUT-OUTPUT cScmProductModule).

    RUN rtb/proxy/p/rtbAssignObject.p ON ghRtbAs
        (INPUT gcRtbCurrentWorkspace,    /* pcWorkspace  */
        INPUT pcObjectType,             /* pcObjType    */
        INPUT pcObjectName,             /* pcObject     */
        INPUT cScmProductModule,        /* pcPmod       */
        INPUT piVersion,                /* piVersion    */
        INPUT "":U,                     /* pcObjGroup   */
        INPUT 0,                        /* piGroupLevel */
        OUTPUT pcError).             /* pcError      */

    /* Get the ROWID of the object to return to the calling procedure */
    RUN rtb/proxy/p/rtbGetObject.p ON ghRtbAs
        (INPUT gcRtbCurrentWorkspace,
        INPUT "PCODE":U,
        INPUT pcObjectName,
        INPUT pcProductModule,
        OUTPUT TABLE-HANDLE hObjRow).

    hObjBuf = hObjRow:DEFAULT-BUFFER-HANDLE.
    hObjBuf:FIND-FIRST() NO-ERROR.
    IF hObjBuf:AVAILABLE THEN
        ASSIGN prRowid = hObjBuf:BUFFER-FIELD('rowIdent'):BUFFER-VALUE.

    /* Clean up  */
    IF VALID-HANDLE(hObjRow) THEN
        DELETE OBJECT hObjRow.

    ERROR-STATUS:ERROR = NO.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmAssignObjectControl) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmAssignObjectControl Procedure
PROCEDURE scmAssignObjectControl :
    /*------------------------------------------------------------------------------
             Purpose:     To assign an object version into a workspace
             Parameters:  SEE BELOW
             Notes:       Object type is PCODE
                          Version is versioned being assigned to current workspace
                          recid is recird of object record assigned
           ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcProductModule               AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcObjectType    /* PCODE */   AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcObjectName                  AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  piVersion                     AS INTEGER      NO-UNDO.
    DEFINE OUTPUT PARAMETER  prRowid                       AS ROWID        NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcError                   AS CHARACTER    NO-UNDO.

    TRANSACTION-BLOCK:
    DO TRANSACTION:
        RUN scmAssignObject (INPUT  pcProductModule,
            INPUT  pcObjectType,
            INPUT  pcObjectName,
            INPUT  piVersion,
            OUTPUT prRowid,
            OUTPUT pcError).

        IF pcError <> "":U THEN
            UNDO TRANSACTION-BLOCK, LEAVE TRANSACTION-BLOCK.
    END. /* transaction-block */

    ERROR-STATUS:ERROR = NO.
    RETURN.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmCheckInObject) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmCheckInObject Procedure
PROCEDURE scmCheckInObject :
    /*------------------------------------------------------------------------------
             Purpose:     To check in an object
             Parameters:  SEE BELOW
             Notes:       If basline = YES then store full source forthis version
                          Object type is PCODE
                          Version is versioned being assigned to current workspace
                          recid is recird of object record assigned
                          NOTE: Not implemented warning for orphan conditions at this stage
                          which is why ui_on flag is not checked - but is passed in to make
                          it easy to add the mod later if required.

                          /* ICF-SCM-XML */
                          Ensure .ado file is not empty.
                          If empty populate with template xml file.

           ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcBaseline                     AS LOGICAL      NO-UNDO.
    DEFINE INPUT  PARAMETER  pcProductModule                AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcObjectType   /* PCODE */     AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcObjectName                   AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  piTaskNumber                   AS INTEGER      NO-UNDO.
    DEFINE INPUT  PARAMETER  plUiOn                         AS LOGICAL      NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcError                    AS CHARACTER    NO-UNDO.

    DEFINE VARIABLE cAdoFileName      AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cAdoTemplate      AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cWorkspaceRoot    AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cRelativePath     AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cWorkspacePath    AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cScmProductModule AS CHARACTER NO-UNDO.
    DEFINE VARIABLE dProductModuleObj AS DECIMAL   NO-UNDO.
    DEFINE VARIABLE cError            AS CHARACTER NO-UNDO.

    DEFINE VARIABLE hSdo              AS HANDLE    NO-UNDO.
    DEFINE VARIABLE cPmod             AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cModDef           AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cModuleDir        AS CHARACTER NO-UNDO.

    DEFINE VARIABLE hObjRow           AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hObjBuf           AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hWSBuf            AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hPmodBuf          AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hModdefBuf        AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hSubtypeBuf       AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hTaskBuf          AS HANDLE    NO-UNDO.
    DEFINE VARIABLE cObjVersionRowid  AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cObjSubtype       AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cWorkspaceID      AS CHARACTER NO-UNDO.
    DEFINE VARIABLE hTaskData         AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hWsData           AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hSubtypeData      AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hModuleDefData    AS HANDLE    NO-UNDO.

    IF NOT VALID-HANDLE(ghRtbAs)  THEN
        PUBLISH "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

    IF pcProductModule <> "":U THEN
        RUN scmGetScmXref (INPUT "RTB":U,
            INPUT "GSCPM":U,
            INPUT pcProductModule,
            INPUT 0,
            OUTPUT cScmProductModule,
            OUTPUT cError).

    IF cScmProductModule = "":U THEN
    DO:
        pcError = "Product module " + pcProductModule + " not found in Xref table":U.
        RETURN.
    END.
    ELSE

        /* Add the site prefix so that we are using the correct product module in RTB, which
           requires prefixes to be used */
        RUN scmSitePrefixAdd (INPUT-OUTPUT cScmProductModule).

    /* Get task info */
    RUN rtb/proxy/p/rtbGetTask.p ON ghRtbAs (
        INPUT piTaskNumber,
        OUTPUT TABLE-HANDLE hTaskData).

    hTaskBuf = hTaskData:DEFAULT-BUFFER-HANDLE.
    hTaskBuf:FIND-FIRST() NO-ERROR.
    ASSIGN
        cWorkspaceID = hTaskBuf::wspace-id.

    IF VALID-HANDLE(hTaskData) THEN
        DELETE OBJECT hTaskData.

    /* Get the workspace record */
    RUN rtb/proxy/p/rtbGetWorkspace.p ON ghRtbAs
        (INPUT cWorkspaceID,
        OUTPUT TABLE-HANDLE hWsData).

    hWSBuf = hWsData:DEFAULT-BUFFER-HANDLE.
    hWSBuf:FIND-FIRST() NO-ERROR.
    IF hWSBUf:AVAILABLE THEN
        ASSIGN cWorkspacePath = hWSBuf::wspace-path.
    ELSE
    DO:
        ASSIGN
            pcError = "Failed to create object: "    + pcObjectName
                       + " due to invalid workspace: "  + cWorkspaceID.
        RETURN.
    END.

    /* Find current version of object in the workspace*/
    RUN rtb/proxy/p/rtbGetObject.p ON ghRtbAs
        (INPUT cWorkspaceID,
        INPUT "PCODE",
        INPUT pcObjectName,
        INPUT pcProductModule,
        OUTPUT TABLE-HANDLE hObjRow).

    hObjBuf = hObjRow:DEFAULT-BUFFER-HANDLE.
    hObjBuf:FIND-FIRST() NO-ERROR.

    ASSIGN
        cObjSubtype = hObjBuf::objSubtype
        cModDef     = hObjBuf::Module.

    /* Get the subtype record */
    RUN rtb/proxy/p/rtbGetSubtype.p ON ghRtbAs
        (INPUT cObjSubtype,
        OUTPUT TABLE-HANDLE hSubtypeData).

    hSubtypeBuf = hSubtypeData:DEFAULT-BUFFER-HANDLE.
    hSubtypeBuf:FIND-FIRST() NO-ERROR.

    /* If we have a subtype and there are .ado file parts, we need to do some dataset processing */
    IF hSubtypeBuf:AVAILABLE AND
        LOOKUP("ado":U, hSubtypeBuf::subtPart-exts) NE 0 THEN
    adoFileBlock:
    DO:
        ASSIGN
            cAdoFileName = pcObjectName
            cAdoFileName = SUBSTRING(cAdoFileName,1,R-INDEX(cAdoFileName,".":U)) + "ado":U
            cAdoTemplate = "emptyxml.ado".

        /* Now, get the workspace module */
        IF cModDef NE "":U THEN
        DO:
            RUN rtb/proxy/p/rtbGetModuleDef.p ON ghRtbAs
                (INPUT cModDef,
                OUTPUT TABLE-HANDLE hModuleDefData).

            hModdefBuf = hModuleDefData:DEFAULT-BUFFER-HANDLE.
            hModdefBuf:FIND-FIRST() NO-ERROR.

            ASSIGN
                cModuleDir = hModdefBuf::directory.
        END.

        /* Get module relative path and tidy up - also remove leading slash */
        ASSIGN
            cRelativePath = ENTRY(1,cModuleDir)
            cRelativePath = REPLACE(cRelativePath,"~\":U,"~/":U).

        IF cRelativePath NE "":U THEN
        DO WHILE SUBSTRING(cRelativePath,LENGTH(cRelativePath),1) = "/":
            cRelativePath = SUBSTRING(cRelativePath,1,LENGTH(cRelativePath) - 1).
        END.
        IF LENGTH(cRelativePath) > 1 THEN
        DO WHILE SUBSTRING(cRelativePath,1,1) = "/":
            cRelativePath = SUBSTRING(cRelativePath,2,LENGTH(cRelativePath)).
        END.

        /* Check if the file exist and if the file is not 0 size */
        IF SEARCH(cRelativePath + "/":U + cAdoFileName) <> ? THEN
        DO:
            FILE-INFO:FILENAME = SEARCH(cRelativePath + "/":U + cAdoFileName).
            IF FILE-INFO:FILE-SIZE > 0 THEN
                LEAVE adoFileBlock.
        END.

        /* Get workspace root directory and replace back slashes with forward slashes and remove any trailing slashes */
        IF cWorkspacePath <> "":U THEN
            ASSIGN
                cWorkspaceRoot = ENTRY(1,cWorkspacePath)
                cWorkspaceRoot = REPLACE(cWorkspaceRoot,"~\":U,"/":U).
        IF cWorkspaceRoot <> "":U THEN
        DO WHILE SUBSTRING(cWorkspaceRoot,LENGTH(cWorkspaceRoot),1) = "/":U:
            cWorkspaceRoot = SUBSTRING(cWorkspaceRoot,1,LENGTH(cWorkspaceRoot) - 1).
        END.

        /* Now work out full path to object for workspace */
        ASSIGN
            cWorkspacePath = cWorkspaceRoot + (IF cRelativePath <> "":U THEN "/":U ELSE "":U) + cRelativePath.

        /* First see if directory exists and if not create it */
        ASSIGN
            pcError = "":U.
        FILE-INFO:FILENAME = cWorkspacePath.
        IF FILE-INFO:FILE-TYPE = ? OR
         INDEX(FILE-INFO:FILE-TYPE,"D":U) = 0 THEN
            RUN createDirectory (INPUT cWorkspacePath, OUTPUT pcError).

        IF pcError <> "":U THEN
            RETURN.

        IF cAdoTemplate <> "":U AND
            SEARCH(cAdoTemplate) <> ? THEN
        DO:
            OS-COPY VALUE(SEARCH(cAdoTemplate)) VALUE(cWorkspacePath + "/":U + cAdoFileName).
        END.
        ELSE
        DO:
            OUTPUT TO VALUE(cWorkspacePath + "/":U + cAdoFileName).
            DISPLAY "/* ICF-SCM-XML */ Dynamic Object":U.
            OUTPUT CLOSE.
        END.
        IF SEARCH(cWorkspacePath + "/":U + cAdoFileName) = ? THEN
        DO:
            ASSIGN
                pcError = "Failed to create physical file: " + cWorkspacePath + "/":U + cAdoFileName.
            RETURN.
        END.
    /* End of new code */
    END.

    /* Now, check in the object*/
    RUN rtb/proxy/p/rtbCheckInObject.p ON ghRtbAs
        (INPUT hObjBuf:BUFFER-FIELD('rowident':U):BUFFER-VALUE,
        INPUT pcBaseline,
        OUTPUT pcError).

    ERROR-STATUS:ERROR = NO.
    RETURN.

    FINALLY:
        /* Clean up objects*/
        IF VALID-HANDLE(hModdefBuf) THEN
            DELETE OBJECT hWSBuf.

        IF VALID-HANDLE(hObjBuf) THEN
            DELETE OBJECT hObjBuf.

        IF VALID-HANDLE(hTaskBuf) THEN
            DELETE OBJECT hTaskBuf.

        IF VALID-HANDLE(hSubtypeBuf) THEN
            DELETE OBJECT hSubtypeBuf.

        IF VALID-HANDLE(hPmodBuf) THEN
            DELETE OBJECT hPmodBuf.

        IF VALID-HANDLE(hModdefBuf) THEN
            DELETE OBJECT hModdefBuf.

        IF VALID-HANDLE(hSubtypeData)THEN
            DELETE OBJECT hSubtypeData.

        IF VALID-HANDLE(hTaskData)THEN
            DELETE OBJECT hTaskData.

        IF VALID-HANDLE(hWsData)THEN
            DELETE OBJECT hWsData.

        IF VALID-HANDLE(hModuleDefData)THEN
            DELETE OBJECT hModuleDefData.

        IF VALID-HANDLE(hObjRow)THEN
            DELETE OBJECT hObjRow.
    END FINALLY.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmCheckInObjectControl) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmCheckInObjectControl Procedure
PROCEDURE scmCheckInObjectControl :
    /*------------------------------------------------------------------------------
             Purpose:     To check in an object
             Parameters:  SEE BELOW
             Notes:       If basline = YES then store full source forthis version
                          Object type is PCODE
                          Version is versioned being assigned to current workspace
                          recid is recird of object record assigned
           ------------------------------------------------------------------------------*/

    DEFINE INPUT PARAMETER  pcBaseline                     AS LOGICAL      NO-UNDO.
    DEFINE INPUT PARAMETER  pcProductModule               AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  pcObjectType   /* PCODE */    AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  pcObjectName                  AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  piTaskNumber                  AS INTEGER      NO-UNDO.
    DEFINE INPUT PARAMETER  plUiOn                        AS LOGICAL      NO-UNDO.
    DEFINE OUTPUT PARAMETER pcError                    AS CHARACTER    NO-UNDO.

    TRANSACTION-BLOCK:
    DO TRANSACTION:
        RUN scmCheckInObject (INPUT pcBaseline,
            INPUT pcProductModule,
            INPUT pcObjectType,
            INPUT pcObjectName,
            INPUT piTaskNumber,
            INPUT plUiOn,
            OUTPUT pcError).
        IF pcError <> "":U
            THEN
            UNDO TRANSACTION-BLOCK, LEAVE TRANSACTION-BLOCK.
    END. /* transaction-block */

    ERROR-STATUS:ERROR = NO.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmCheckOutObject) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmCheckOutObject Procedure
PROCEDURE scmCheckOutObject :
    /*------------------------------------------------------------------------------
             Purpose:     To check out an object in a workspace under an open task
             Parameters:  SEE BELOW
             Notes:       Change type is patch, revision, or version
                          Object type is PCODE
                          recid is recid of object record checked out
                         - If UI enabled, display messages for following errors, otherwise
                           just stop and report an error - depending on flags
                         - Display a warning if the object is in a product module that is not
                           primary to the workspace.
                         - Display a warning if orphan conditions exist
           ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcChangeType                  AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcScmProductModule            AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcObjectType    /* PCODE */   AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcObjectName                  AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  piTaskNumber                  AS INTEGER      NO-UNDO.
    DEFINE INPUT  PARAMETER  plUiOn                        AS LOGICAL      NO-UNDO.
    DEFINE INPUT  PARAMETER  plAllowNonprimary             AS LOGICAL      NO-UNDO.
    DEFINE INPUT  PARAMETER  plAllowOrphans                AS LOGICAL      NO-UNDO.
    DEFINE OUTPUT PARAMETER  prRowid                       AS ROWID        NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcError                       AS CHARACTER    NO-UNDO.

    DEFINE VARIABLE lNonprimary AS LOGICAL NO-UNDO.
    DEFINE VARIABLE lOrphans    AS LOGICAL NO-UNDO.
    DEFINE VARIABLE lContinue   AS LOGICAL NO-UNDO.
    DEFINE VARIABLE Morphan     AS LOGICAL NO-UNDO.

    DEFINE VARIABLE phTT        AS HANDLE  NO-UNDO.
    DEFINE VARIABLE phTTbin     AS HANDLE  NO-UNDO.
    DEFINE VARIABLE hObjBuf     AS HANDLE  NO-UNDO.
    DEFINE VARIABLE hObjectData AS HANDLE  NO-UNDO.

    IF NOT VALID-HANDLE(ghRtbAs)  THEN
        PUBLISH "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

    RUN rtb/proxy/p/rtbGetObject ON ghRtbAs
        (INPUT gcRtbCurrentWorkspace,  /* Workspace   */
        INPUT pcObjectType,           /* Object type */
        INPUT pcObjectName,           /* Object name */
        INPUT pcScmProductModule,
        OUTPUT TABLE-HANDLE hObjectData).

    hObjBuf = hObjectData:DEFAULT-BUFFER-HANDLE.
    hObjBuf:FIND-FIRST() NO-ERROR.
    IF hObjBuf:AVAILABLE THEN
    DO:
        ASSIGN
            prRowid = TO-ROWID(hObjBuf::rowIdent).

        RUN rtb/proxy/p/rtbCheckOutObject ON ghRtbAs
            (INPUT hObjBuf::rowIdent,
            INPUT pcChangeType,
            INPUT piTaskNumber,
            INPUT "",                      /* process that is performing the check-out*/
            INPUT "",                      /* default update note for the new version */
            INPUT YES,                      /* use the OS copy of the object           */
            OUTPUT Morphan,                /* an orphan was created              */
            OUTPUT pcError,                /* error message */
            OUTPUT TABLE-HANDLE phTT,     /* text contents of object */
            OUTPUT TABLE-HANDLE phTTbin). /* binary contents of object */

    /*      hBuf = phTT:DEFAULT-BUFFER-HANDLE. */
    /*      hBuf:FIND-FIRST() NO-ERROR.        */
    END.

    ERROR-STATUS:ERROR = NO.
    RETURN.

    FINALLY:
        /* Clean up */
        IF VALID-HANDLE(hObjectData) THEN
            DELETE OBJECT hObjectData.

        IF VALID-HANDLE(phTT) THEN
            DELETE OBJECT phTT.

        IF VALID-HANDLE(phTTbin) THEN
            DELETE OBJECT phTTbin.
    END FINALLY.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmCheckOutObjectControl) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmCheckOutObjectControl Procedure
PROCEDURE scmCheckOutObjectControl :
    /*------------------------------------------------------------------------------
             Purpose:     To check out an object in a workspace under an open task
             Parameters:  SEE BELOW
             Notes:       Change type is patch, revision, or version
                          Object type is PCODE
                          recid is recid of object record checked out
                         - If UI enabled, display messages for following errors, otherwise
                           just stop and report an error - depending on flags
                         - Display a warning if the object is in a product module that is not
                           primary to the workspace.
                         - Display a warning if orphan conditions exist
           ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcChangeType                  AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcProductModule               AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcObjectType    /* PCODE */   AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcObjectName                  AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  piTaskNumber                  AS INTEGER      NO-UNDO.
    DEFINE INPUT  PARAMETER  plUiOn                        AS LOGICAL      NO-UNDO.
    DEFINE INPUT  PARAMETER  plAllowNonprimary             AS LOGICAL      NO-UNDO.
    DEFINE INPUT  PARAMETER  plAllowOrphans                AS LOGICAL      NO-UNDO.
    DEFINE OUTPUT PARAMETER  prRowid                       AS ROWID        NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcError                       AS CHARACTER    NO-UNDO.

    TRANSACTION-BLOCK:
    DO TRANSACTION:
        RUN scmCheckOutObject (INPUT pcChangeType,
            INPUT pcProductModule,
            INPUT pcObjectType,
            INPUT pcObjectName,
            INPUT piTaskNumber,
            INPUT plUiOn,
            INPUT plAllowNonprimary,
            INPUT plAllowOrphans,
            OUTPUT prRowid,
            OUTPUT pcError).

        IF pcError <> "":U THEN
            UNDO TRANSACTION-BLOCK, LEAVE TRANSACTION-BLOCK.
    END. /* transaction-block */

    ERROR-STATUS:ERROR = NO.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmCompileObject) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmCompileObject Procedure
PROCEDURE scmCompileObject :
    /*------------------------------------------------------------------------------
             Purpose:     To compile a single object
             Parameters:  SEE BELOW
             Notes:       Object type is PCODE
                          Show errors should be set to NO

             Status:  *** This procedure has not been converted to use Proxies.
           ------------------------------------------------------------------------------*/

    DEFINE INPUT  PARAMETER  pcObjectType    /* PCODE */   AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcObjectName                  AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  plSaveRcode                   AS LOGICAL      NO-UNDO.
    DEFINE INPUT  PARAMETER  plWithXref                    AS LOGICAL      NO-UNDO.
    DEFINE INPUT  PARAMETER  plWithListings                AS LOGICAL      NO-UNDO.
    DEFINE INPUT  PARAMETER  plShowErrors                  AS LOGICAL      NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcError                   AS CHARACTER    NO-UNDO.

    DEFINE VARIABLE hSdo AS HANDLE NO-UNDO.
    /*
      /* New code start */
      RUN rtb/proxy/p/rtbCompilePost.p ON ghRtbAs
         (INPUT  pcClientTempDir,
          INPUT  pcWorkspace,
          INPUT  piTaskNum,
          INPUT  pcModule,
          INPUT  pcObjGroup,
          INPUT  pcObjType,
          INPUT  pcObject,
          INPUT  plWithXref,
          INPUT  plWithListings,
          INPUT  YES, /* plForce */,
          INPUT  NO , /*plSelective,*/
          INPUT  plIgnoreWarnings,
          INPUT  plTaskCompletion,
          INPUT  plServerCompile,
          OUTPUT piObjsSelected,
          OUTPUT TABLE-HANDLE phTTcompobj,
          OUTPUT pcError).

      RUN rtb/proxy/p/rtbCompileObjects.p ON ghRtbAs
         (INPUT pcConfigID,
          INPUT-OUTPUT TABLE-HANDLE phTTCompSpecs,
          OUTPUT pcError).

      RUN rtb/proxy/p/rtbCompilePost.p (INPUT-OUTPUT TABLE-HANDLE phTTcompobj).
      /* New code end */
      */
    RUN rtb/sdo/rtb_u_obj.w PERSISTENT ON ghRtbAs SET hSdo.

    /*hSdo = DYNAMIC-FUNCTION('fnRtbStartSuperSdo':U,"rtb_u_obj.w", THIS-PROCEDURE).*/
    IF VALID-HANDLE(hSdo) THEN
    DO:
        pcError = DYNAMIC-FUNCTION('fnRtbCompileObject':U IN hSdo,
            INPUT giRtbSid,
            INPUT gcRtbCurrentWorkspace,
            INPUT pcObjectType,
            INPUT pcObjectName,
            INPUT plWithXref,
            INPUT plWithListings,
            INPUT 0).
        IF RETURN-VALUE NE "":U THEN
            ASSIGN pcError = RETURN-VALUE.

        RUN destroyObject IN hSdo.
    END.
    ELSE
        pcError = "Unable to initialize rtb_u_obj.w.".

    ERROR-STATUS:ERROR = NO.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmCompileObjectControl) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmCompileObjectControl Procedure
PROCEDURE scmCompileObjectControl :
    /*------------------------------------------------------------------------------
             Purpose:     To compile a single object
             Parameters:  SEE BELOW
             Notes:       Object type is PCODE
                          Show errors should be set to NO
           ------------------------------------------------------------------------------*/

    DEFINE INPUT PARAMETER  pcObjectType    /* PCODE */   AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  pcObjectName                  AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  plSaveRcode                   AS LOGICAL      NO-UNDO.
    DEFINE INPUT PARAMETER  plWithXref                    AS LOGICAL      NO-UNDO.
    DEFINE INPUT PARAMETER  plWithListings                AS LOGICAL      NO-UNDO.
    DEFINE INPUT PARAMETER  plShowErrors                  AS LOGICAL      NO-UNDO.
    DEFINE OUTPUT PARAMETER pcError                   AS CHARACTER    NO-UNDO.

    TRANSACTION-BLOCK:
    DO TRANSACTION:
        RUN scmCompileObject (INPUT pcObjectType,
            INPUT pcObjectName,
            INPUT plSaveRcode,
            INPUT plWithXref,
            INPUT plWithListings,
            INPUT plShowErrors,
            OUTPUT pcError).

        IF pcError <> "":U THEN
            UNDO TRANSACTION-BLOCK, LEAVE TRANSACTION-BLOCK.
    END. /* transaction-block */

    ERROR-STATUS:ERROR = NO.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmCompleteTask) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmCompleteTask Procedure
PROCEDURE scmCompleteTask :
    /*------------------------------------------------------------------------------
             Purpose:     To complete a task
             Parameters:  SEE BELOW
             Notes:
           ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER piTaskNumber                  AS INTEGER      NO-UNDO.
    DEFINE OUTPUT PARAMETER pcError                   AS CHARACTER    NO-UNDO.

    IF NOT VALID-HANDLE(ghRtbAs)  THEN
        PUBLISH "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

    RUN rtb/proxy/p/rtbCompleteTask.p ON ghRtbAs
        (INPUT  piTaskNumber,
        OUTPUT pcError).

    ERROR-STATUS:ERROR = NO.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmCompleteTaskControl) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmCompleteTaskControl Procedure
PROCEDURE scmCompleteTaskControl :
    /*------------------------------------------------------------------------------
             Purpose:     To complete a task
             Parameters:  SEE BELOW
             Notes:
           ------------------------------------------------------------------------------*/

    DEFINE INPUT  PARAMETER  piTaskNumber                  AS INTEGER      NO-UNDO.
    DEFINE OUTPUT PARAMETER pcError                    AS CHARACTER    NO-UNDO.

    TRANSACTION-BLOCK:
    DO TRANSACTION:
        RUN scmCompleteTask (INPUT piTaskNumber,
            OUTPUT pcError).

        IF pcError <> "":U THEN
            UNDO TRANSACTION-BLOCK, LEAVE TRANSACTION-BLOCK.
    END. /* transaction-block */

    ERROR-STATUS:ERROR = NO.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmCreateObject) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmCreateObject Procedure
PROCEDURE scmCreateObject :
    /*------------------------------------------------------------------------------
             Purpose:     To create an object
             Parameters:  SEE BELOW
             Notes:       Object type is usually PCODE
                          If the object name parameter begins with the "@" character (an
                          alias), this routine will check for part names in the pcOptions
                          string.  This should be a comma delimited list of relative path
                          name and file name.(ex: "reports/rpt1.p")
                          If ui_on is set to TRUE, you want user interaction...
                          If this is set to FALSE, Roundtable will not prompt for user
                          intervention and default to YES on all questions.
                          The SCM tool API does not provide a facility to create the object
                          centrally, even though the task is a share status other than
                          central, plus it does not create the physical file on the disk,
                          therefore we do all this manually with extra input parameters
                          into this procedure.
           ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcObjectName                  AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcObjectType    /* PCODE */   AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcSubType                     AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcProductModule               AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcGroup                       AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  piLevel                       AS INTEGER      NO-UNDO.
    DEFINE INPUT  PARAMETER  pcObjectDescription           AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOptions                     AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  piTaskNumber                  AS INTEGER      NO-UNDO.
    DEFINE INPUT  PARAMETER  plUiOn                        AS LOGICAL      NO-UNDO.
    DEFINE INPUT  PARAMETER  pcShareStatus                 AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  plCreatePhysicalFile          AS LOGICAL      NO-UNDO.
    DEFINE INPUT  PARAMETER  pcPhysicalFileTemplate        AS CHARACTER    NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcRowident                    AS CHARACTER    NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcError                       AS CHARACTER    NO-UNDO.

    DEFINE VARIABLE cFullObjectName    AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cRelativePath      AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cTaskRoot          AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cTaskPath          AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cWorkspaceRoot     AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cWorkspacePath     AS CHARACTER NO-UNDO.
    DEFINE VARIABLE iObjectLoop        AS INTEGER   NO-UNDO.
    DEFINE VARIABLE cObjectRoot        AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cObjectPath        AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cXMLRelativeName   AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cScmProductModule  AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cProductModuleCode AS CHARACTER NO-UNDO.
    DEFINE VARIABLE dProductModuleObj  AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cError             AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cScmObjectType     AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cObjectType        AS CHARACTER NO-UNDO.
    DEFINE VARIABLE dObjectTypeObj     AS DECIMAL   NO-UNDO.
    DEFINE VARIABLE hTable01           AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hTable02           AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hTaskBuf           AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hWSBuf             AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hPmodBuf           AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hModDefBuf         AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hObjRow            AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hObjBuf            AS HANDLE    NO-UNDO.
    DEFINE VARIABLE cWorkspaceID       AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cPmod              AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cModDef            AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cModuleDir         AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cTaskDirectory     AS CHARACTER NO-UNDO.
    DEFINE VARIABLE hTaskData          AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hWsData            AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hPmodData          AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hModdefData        AS HANDLE    NO-UNDO.

    IF NOT VALID-HANDLE(ghRtbAs)  THEN
        PUBLISH "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

    /* Get the Code Subtype for the passed in ICFDB Object Type Code */
    IF pcSubtype NE "":U THEN
        RUN scmGetScmXref (
            INPUT  "RTB":U,
            INPUT  "GSCOT":U,
            INPUT  pcSubtype,
            INPUT  0,
            OUTPUT cScmObjectType,
            OUTPUT cError)
            NO-ERROR.

    IF cScmObjectType = "":U THEN
    DO:
        cError = "SCM Object Type for " + pcSubtype + " not found in Xref table":U.
        RETURN ERROR cError.
    END.
    ELSE
        ASSIGN pcGroup = cScmObjectType.

    ASSIGN
        cFullObjectName = pcObjectName.
    RUN scmADOExtAdd (INPUT-OUTPUT cFullObjectName).

    IF pcProductModule <> "":U THEN
        RUN scmGetScmXref (
            INPUT "RTB":U,
            INPUT "GSCPM":U,
            INPUT pcProductModule,
            INPUT 0,
            OUTPUT cScmProductModule,
            OUTPUT cError) NO-ERROR.

    IF cScmProductModule = "":U THEN
    DO:
        pcError = "SCM product module " + pcProductModule + " not found in Xref table":U.
        RETURN.
    END.
    ELSE
        /* Add the site prefix so that we are using the correct product module in RTB, which
          requires prefixes to be used */
        RUN scmSitePrefixAdd (INPUT-OUTPUT cScmProductModule).

    /* Get task info */
    RUN rtb/proxy/p/rtbGetTask.p ON ghRtbAs (
        INPUT piTaskNumber,
        OUTPUT TABLE-HANDLE hTaskData).

    hTaskBuf = hTaskData:DEFAULT-BUFFER-HANDLE.
    hTaskBuf:FIND-FIRST() NO-ERROR.

    IF NOT hTaskBuf:AVAILABLE THEN
    DO:
        ASSIGN
            pcError = "Failed to create object: " + pcObjectName + " due to invalid task: " + STRING(piTaskNumber).
        RETURN.
    END.

    ASSIGN
        cWorkspaceID = hTaskBuf::wspace-id.

    /* Get workspace root directory and replace back slashes with forward slashes and remove any trailing slashes*/
    ASSIGN
        cTaskDirectory = hTaskBuf::task-directory.

    /* Get the workspace record */
    RUN rtb/proxy/p/rtbGetWorkspace.p ON ghRtbAs (
        INPUT cWorkspaceID,
        OUTPUT TABLE-HANDLE hWsData).

    hWSBuf = hWsData:DEFAULT-BUFFER-HANDLE.
    hWSBuf:FIND-FIRST() NO-ERROR.
    IF hWSBUf:AVAILABLE THEN
        ASSIGN cWorkspacePath = hWSBuf::wspace-path.
    ELSE
    DO:
        ASSIGN
            pcError = "Failed to create object: " + pcObjectName + " due to invalid workspace: " + cWorkspaceID.
        RETURN.
    END.

    RUN rtb/proxy/p/rtbGetPmod.p ON ghRtbAs
        (INPUT cScmProductModule,
        OUTPUT TABLE-HANDLE hPmodData).

    hPmodBuf = hPmodData:DEFAULT-BUFFER-HANDLE.
    hPmodBuf:FIND-FIRST() NO-ERROR.

    IF hPmodBuf:AVAILABLE THEN
    DO:
        ASSIGN
            cPmod   = hPmodBuf::pmod
            cModDef = hPmodBuf::module.
    END.
    ELSE
    DO:
        ASSIGN
            pcError = "Failed to create object: " + pcObjectName + " due to invalid product module: " + cScmProductModule.
        RETURN.
    END.

    /* Now, get the workspace module */
    IF cModDef NE "":U THEN
    DO:
        RUN rtb/proxy/p/rtbGetModuleDef.p ON ghRtbAs (
            INPUT cModDef,
            OUTPUT TABLE-HANDLE hModdefData).

        hModdefBuf = hModdefData:DEFAULT-BUFFER-HANDLE.
        hModdefBuf:FIND-FIRST() NO-ERROR.

        IF NOT hModdefBuf:AVAILABLE THEN
        DO:
            ASSIGN
                pcError = "Failed to create object: " + pcObjectName + " due to invalid workspace module for product module: " + cScmProductModule.
            RETURN.
        END.
        ELSE
            ASSIGN cModuleDir = hModdefBuf::directory.
    END.

    IF plCreatePhysicalFile = YES THEN
    createPhysicalFileBlock:
    DO:
        /* Get workspace root directory and replace back slashes with forward slashes and remove any trailing slashes*/
        IF cWorkspacePath NE "":U THEN
            ASSIGN
                cWorkspaceRoot = ENTRY(1,cWorkspacePath)
                cWorkspaceRoot = REPLACE(cWorkspaceRoot,"~\":U,"/":U).

        IF cWorkspaceRoot NE "":U THEN
        DO WHILE SUBSTRING(cWorkspaceRoot,LENGTH(cWorkspaceRoot),1) = "/":U:
            cWorkspaceRoot = SUBSTRING(cWorkspaceRoot,1,LENGTH(cWorkspaceRoot) - 1).
        END.

        /* Get task root directory and clean it up */
        IF cTaskDirectory NE "":U THEN
            ASSIGN
                cTaskRoot = ENTRY(1,cTaskDirectory)
                cTaskRoot = REPLACE(cTaskRoot,"~\":U,"/":U).
        IF cTaskRoot NE "":U THEN
        DO WHILE SUBSTRING(cTaskRoot,LENGTH(cTaskRoot),1) = "/":
            cTaskRoot = SUBSTRING(cTaskRoot,1,LENGTH(cTaskRoot) - 1).
        END.

        /* Get module relative path and tidy up - also remove leading slash */
        ASSIGN
            cRelativePath = ENTRY(1,cModuleDir)
            cRelativePath = REPLACE(cRelativePath,"~\":U,"/":U).
        IF cRelativePath <> "":U THEN
        DO WHILE SUBSTRING(cRelativePath,LENGTH(cRelativePath),1) = "/":U:
            cRelativePath = SUBSTRING(cRelativePath,1,LENGTH(cRelativePath) - 1).
        END.

        IF LENGTH(cRelativePath) > 1 THEN
        DO WHILE SUBSTRING(cRelativePath,1,1) = "/":U :
            cRelativePath = SUBSTRING(cRelativePath,2,LENGTH(cRelativePath)).
        END.

        /* Now work out full path to object for workspace and task */
        ASSIGN
            cWorkspacePath = cWorkspaceRoot + (IF cRelativePath <> "":U THEN "/":U ELSE "":U) + cRelativePath
            cTaskPath      = cTaskRoot      + (IF cRelativePath <> "":U THEN "/":U ELSE "":U) + cRelativePath.

        ASSIGN
            cXMLRelativeName = cRelativePath + "~/":U + cFullObjectName.

        createObjectBlock:
        DO iObjectLoop = 1 TO 2:
            /* iObjectLoop = 1 : Create in workspace directory even if share status is task */
            /* iObjectLoop = 2 : If share status of task the create in task directory       */
            IF iObjectLoop = 1 THEN
                ASSIGN
                    cObjectRoot = cWorkspaceRoot
                    cObjectPath = cWorkspacePath.
            ELSE
                IF iObjectLoop = 2 AND
                    pcShareStatus BEGINS "T":U  THEN  /* task share status - create in task directory */
                    ASSIGN
                        cObjectRoot = cTaskRoot
                        cObjectPath = cTaskPath.

            ASSIGN
                pcError = "":U.
            FILE-INFO:FILENAME = cObjectPath.
            IF FILE-INFO:FILE-TYPE = ? OR INDEX(FILE-INFO:FILE-TYPE,"D":U) = 0 THEN
                RUN createDirectory (INPUT cObjectPath, OUTPUT pcError).
            IF pcError <> "":U THEN
                RETURN.

            IF SEARCH( cXMLRelativeName ) NE ? THEN
            DO:
                FILE-INFO:FILENAME = SEARCH(cXMLRelativeName).
                IF FILE-INFO:FILE-SIZE > 0 THEN
                    LEAVE createPhysicalFileBlock.
            END.

            IF pcPhysicalFileTemplate <> "":U AND
                SEARCH(pcPhysicalFileTemplate) NE ? THEN
            DO:
                OS-COPY VALUE(SEARCH(pcPhysicalFileTemplate)) VALUE(cObjectRoot + "~/":U + cXMLRelativeName).
            END.
            ELSE
            DO:
                ASSIGN
                    hTable01 = ?
                    hTable02 = ?.

                {launch.i &PLIP = 'af/app/gscddxmlp.p'
                     &IProc = 'writeDeploymentDataset'
                     &PList = "(INPUT 'RYCSO':U,~
                               INPUT pcObjectName,~
                               INPUT cXMLRelativeName,~
                               INPUT cObjectRoot,~
                               INPUT YES,~
                               INPUT YES,~
                               INPUT TABLE-HANDLE hTable01,~
                               INPUT TABLE-HANDLE hTable02,~
                               OUTPUT pcError)"
                     &OnApp = 'no'
                     &Autokill = YES}
            END.
            /* Check if the file exist and if the file is not 0 size */
            IF SEARCH(cXMLRelativeName) NE ? THEN
            DO:
                FILE-INFO:FILENAME = SEARCH(cXMLRelativeName).
                IF FILE-INFO:FILE-SIZE = 0 THEN
                DO:
                    OUTPUT TO VALUE(SEARCH(cXMLRelativeName)).
                    DISPLAY "/* DYNAMICS-SCM-XML : Dynamic Object */ ":U.
                    OUTPUT CLOSE.
                END.
            END.
            ELSE
            DO:
                OUTPUT TO VALUE(cObjectRoot + "~/":U + cXMLRelativeName).
                DISPLAY "/* ICF-SCM-XML : Dynamic Object */ ":U.
                OUTPUT CLOSE.

                IF SEARCH(cXMLRelativeName) = ? THEN
                DO:
                    ASSIGN
                        pcError = "Failed to create physical file: " + cXMLRelativeName.
                    RETURN.
                END.
            END.
        END.
    END.  /* If create physical file = yes */

    RUN rtb/proxy/p/rtbCreateObject.p ON ghRtbAs (
        INPUT  cWorkspaceID, /* workspace */
        INPUT  piTaskNumber,          /* task */
        INPUT  cFullObjectName,       /* object */
        INPUT  pcObjectType,          /* obj type */
        INPUT  cScmObjectType,        /* subtype */
        INPUT  cScmProductModule,     /* pmod */
        INPUT  Pcgroup,               /* group */
        INPUT  pcObjectDescription,   /* description */
        INPUT  pcOptions,             /* option */
        OUTPUT pcError,
        OUTPUT TABLE-HANDLE hObjRow).

    IF pcError = "":U THEN
    DO:
        hObjBuf = hObjRow:DEFAULT-BUFFER-HANDLE NO-ERROR.
        hObjBuf:FIND-FIRST() NO-ERROR.
        IF hObjBuf:AVAILABLE THEN
            ASSIGN pcRowident = STRING(hObjBuf::rowIdent).
    END.

    ERROR-STATUS:ERROR = NO.
    RETURN.

    FINALLY:
        IF VALID-HANDLE(hObjRow) THEN
            DELETE OBJECT hObjRow.

        IF VALID-HANDLE(hTaskData) THEN
            DELETE OBJECT hTaskData.

        IF VALID-HANDLE(hWsData) THEN
            DELETE OBJECT hWsData.

        IF VALID-HANDLE(hPmodData) THEN
            DELETE OBJECT hPmodData.

        IF VALID-HANDLE(hModdefData) THEN
            DELETE OBJECT hModdefData.

    END FINALLY.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmCreateObjectControl) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmCreateObjectControl Procedure
PROCEDURE scmCreateObjectControl :
    /*------------------------------------------------------------------------------
             Purpose:     To create an object
             Parameters:  SEE BELOW
             Notes:       Object type is usually PCODE
                          If the object name parameter begins with the "@" character (an
                          alias), this routine will check for part names in the pcOptions
                          string.  This should be a comma delimited list of relative path
                          name and file name.(ex: "reports/rpt1.p")
                          If ui_on is set to TRUE, you want user interaction...
                          If this is set to FALSE, Roundtable will not prompt for user
                          intervention and default to YES on all questions.
                          The SCM tool API does not provide a facility to create the object
                          centrally, even though the task is a share status other than
                          central, plus it does not create the physical file on the disk,
                          therefore we do all this manually with extra input parameters
                          into this procedure.
           ------------------------------------------------------------------------------*/

    DEFINE INPUT  PARAMETER  pcObjectName                  AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcObjectType    /* PCODE */   AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcSubType                     AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcScmProductModule            AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcGroup                       AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  piLevel                       AS INTEGER      NO-UNDO.
    DEFINE INPUT  PARAMETER  pcObjectDescription           AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcOptions                     AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  piTaskNumber                  AS INTEGER      NO-UNDO.
    DEFINE INPUT  PARAMETER  plUiOn                        AS LOGICAL      NO-UNDO.
    DEFINE INPUT  PARAMETER  pcShareStatus                 AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  plCreatePhysicalFile          AS LOGICAL      NO-UNDO.
    DEFINE INPUT  PARAMETER  pcPhysicalFileTemplate        AS CHARACTER    NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcRowid                       AS CHARACTER    NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcError                       AS CHARACTER    NO-UNDO.

    TRANSACTION-BLOCK:
    DO TRANSACTION:
        RUN scmCreateObject (INPUT pcObjectName,
            INPUT pcObjectType,
            INPUT pcSubType,
            INPUT pcScmProductModule,
            INPUT pcGroup,
            INPUT piLevel,
            INPUT pcObjectDescription,
            INPUT pcOptions,
            INPUT piTaskNumber,
            INPUT plUiOn,
            INPUT pcShareStatus,
            INPUT plCreatePhysicalFile,
            INPUT pcPhysicalFileTemplate,
            OUTPUT pcRowid,
            OUTPUT pcError).

        IF pcError <> "":U THEN
            UNDO TRANSACTION-BLOCK, LEAVE TRANSACTION-BLOCK.
    END. /* transaction-block */

    ERROR-STATUS:ERROR = NO.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmCreateTask) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmCreateTask Procedure
PROCEDURE scmCreateTask :
    /*------------------------------------------------------------------------------
             Purpose:     To create a new task
             Parameters:  SEE BELOW
             Notes:
           ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcTaskSummary                 AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcCompletedBy                 AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcCompletedDate               AS DATE         NO-UNDO.
    DEFINE INPUT  PARAMETER  pdEnteredDate                 AS DATE         NO-UNDO.
    DEFINE INPUT  PARAMETER  pcManager                     AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcProgrammer                  AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcShareStatus                 AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcTaskDirectory               AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcUserReference               AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcWorkspace                   AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcTaskNotes                   AS CHARACTER    NO-UNDO.
    DEFINE OUTPUT PARAMETER  piTaskNumber                  AS INTEGER      NO-UNDO.
    DEFINE OUTPUT PARAMETER  prTask_rowid                  AS ROWID        NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcError                       AS CHARACTER    NO-UNDO.

    DEFINE VARIABLE rRecid    AS RECID  NO-UNDO.
    DEFINE VARIABLE hTaskBuf  AS HANDLE NO-UNDO.
    DEFINE VARIABLE hOcBuf    AS HANDLE NO-UNDO.
    DEFINE VARIABLE hOcTT     AS HANDLE NO-UNDO.
    DEFINE VARIABLE hTaskData AS HANDLE NO-UNDO.

    IF NOT VALID-HANDLE(ghRtbAs)  THEN
        PUBLISH "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

    RUN rtb/proxy/p/rtbCreateTask.p ON ghRtbAs
        (INPUT  pcWorkspace,
        OUTPUT piTaskNumber,
        OUTPUT pcError).

    IF pcError NE "":U THEN
        RETURN.

    RUN rtb/proxy/p/rtbGetTask.p ON ghRtbAs
        (INPUT piTaskNumber,
        OUTPUT TABLE-HANDLE hTaskData).

    hTaskBuf = hTaskData:DEFAULT-BUFFER-HANDLE.
    hTaskBuf:FIND-FIRST() NO-ERROR.

    IF hTaskBuf:AVAILABLE THEN
    DO:
        ASSIGN
            pcError = "Unable to find newly created task with task number " + STRING(piTaskNumber, "999999999").
        RETURN.
    END.

    /* Create a copy of the original record we received */
    CREATE TEMP-TABLE hOcTT.
    hOcTT:CREATE-LIKE(hTaskData).
    hOcTT:TEMP-TABLE-PREPARE(hTaskBuf:NAME).

    hOcBuf = hOcTT:DEFAULT-BUFFER-HANDLE.
    hOcBuf:BUFFER-CREATE.
    hOcBuf:BUFFER-COPY(hTaskBuf).

    /* Create another copy to hold the updated values */
    hOcBuf:BUFFER-CREATE.
    hOcBuf:BUFFER-COPY(hTaskBuf).
    hOcBuf::rowMod = "U".
    ASSIGN
        hOcBuf:BUFFER-FIELD('summary':U):BUFFER-VALUE         = pcTaskSummary
        hOcBuf:BUFFER-FIELD('compltd-by':U):BUFFER-VALUE      = pcCompletedBy
        hOcBuf:BUFFER-FIELD('compltd-when':U):BUFFER-VALUE    = pcCompletedDate
        hOcBuf:BUFFER-FIELD('entered-when':U):BUFFER-VALUE    = pdEnteredDate
        hOcBuf:BUFFER-FIELD('manager':U):BUFFER-VALUE         = pcManager
        hOcBuf:BUFFER-FIELD('programmer':U):BUFFER-VALUE      = pcProgrammer
        hOcBuf:BUFFER-FIELD('share-status':U):BUFFER-VALUE    = pcShareStatus
        hOcBuf:BUFFER-FIELD('task-directory':U):BUFFER-VALUE  = pcTaskDirectory
        hOcBuf:BUFFER-FIELD('wspace-id':U):BUFFER-VALUE       = pcWorkspace
        hOcBuf:BUFFER-FIELD('user-task-ref':U):BUFFER-VALUE   = pcUserReference
        hOcBuf:BUFFER-FIELD('taskDescription':U):BUFFER-VALUE = pcTaskNotes.

    /* Set task info in the repository */
    /* Set task info */
    oRtbProxyHelper:rtbSetRowValues(
        INPUT "rtbTask",
        INPUT-OUTPUT TABLE-HANDLE hOcTT).

    ASSIGN
        prTask_rowid = hTaskBuf::RowIdent.

    RETURN.

    CATCH err AS Progress.Lang.Error :
        ASSIGN
            pcError = err:GetMessage(1).

        IF pcError NE "":U THEN
            RETURN.
    END CATCH.

    FINALLY:
        /* Clean up the hData handle */
        IF VALID-HANDLE(hTaskData) THEN
            DELETE OBJECT hTaskData.

    IF VALID-HANDLE(hOcTT) THEN
        DELETE OBJECT hOcTT.
    END FINALLY.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmCreateTaskControl) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmCreateTaskControl Procedure
PROCEDURE scmCreateTaskControl :
    /*------------------------------------------------------------------------------
             Purpose:     To create a new task
             Parameters:  SEE BELOW
             Notes:
           ------------------------------------------------------------------------------*/

    DEFINE INPUT  PARAMETER  pcTaskSummary                 AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcCompletedBy                 AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcCompletedDate               AS DATE         NO-UNDO.
    DEFINE INPUT  PARAMETER  pdEnteredDate                 AS DATE         NO-UNDO.
    DEFINE INPUT  PARAMETER  pcManager                     AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcProgrammer                  AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcShareStatus                 AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcTaskDirectory               AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcUserReference               AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcWorkspace                   AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcTaskDescription             AS CHARACTER    NO-UNDO.
    DEFINE OUTPUT PARAMETER  piTaskNumber                  AS INTEGER      NO-UNDO.
    DEFINE OUTPUT PARAMETER  prTask_rowid                  AS ROWID        NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcError                   AS CHARACTER    NO-UNDO.

    TRANSACTION-BLOCK:
    DO TRANSACTION:
        RUN scmCreateTask (INPUT pcTaskSummary,
            INPUT pcCompletedBy,
            INPUT pcCompletedDate,
            INPUT pdEnteredDate,
            INPUT pcManager,
            INPUT pcProgrammer,
            INPUT pcShareStatus,
            INPUT pcTaskDirectory,
            INPUT pcUserReference,
            INPUT pcWorkspace,
            INPUT pcTaskDescription,
            OUTPUT piTaskNumber,
            OUTPUT prTask_rowid,
            OUTPUT pcError).

        IF pcError <> "":U THEN
            UNDO TRANSACTION-BLOCK, LEAVE TRANSACTION-BLOCK.
    END. /* transaction-block */

    ERROR-STATUS:ERROR = NO.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmCreateXref) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmCreateXref Procedure
PROCEDURE scmCreateXref :
    /*------------------------------------------------------------------------------
             Purpose:     To create XREF records for non progress objects
             Parameters:  SEE BELOW
             Notes:       input xref temp-table and a log filename for where to log errors
                          The temp-table structure is defined at the top of this file and
                          contains a record for every object relation you want to create
                          where.
                          src-object    = Name of object in the selected workspace that
                                          contains the reference (e.g. if "program.java"
                                          references "java.class", this field should
                                          contain "program.java").
                          ref-type      = Valid reference type as listed in the Progress
                                          Language Reference under the COMPILE statement
                                          following the XREF parameter (i.e. "RUN",
                                          "INCLUDE", "CREATE", etc.).
                          obj-text[1-4] = Valid object identifier as shown in the Progress
                                          Language Reference under the COMPILE statement
                                          following the XREF parameter. Each element of
                                          the object identifier separated by a space should
                                          be placed in an extent of this field.
                                          Examples:
                                          ref-type    : INCLUDE
                                          obj-text[1] : include-file-name
                                          obj-text[2] : ""
                                          obj-text[3] : ""
                                          obj-text[4] : ""

                                          ref-type    : ACCESS
                                          obj-text[1] : database.table
                                          obj-text[2] : field
                                          obj-text[3] : ""
                                          obj-text[4] : ""

                                          ref-type    : FUNCTION
                                          obj-text[1] : function-name,return-type
                                          obj-text[2] : ""
                                          obj-text[3] : ""
                                          obj-text[4] : ""

           ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER TABLE FOR TTxref.
    DEFINE INPUT  PARAMETER pcLogFile                      AS CHARACTER    NO-UNDO.
    DEFINE OUTPUT PARAMETER pcError                    AS CHARACTER    NO-UNDO.

    IF NOT VALID-HANDLE(hRtbApi) THEN
    DO:
        pcError = "Roundtable API not available." + "~n":U + "Reselect the workspace to retstart the Roundtable API and try again".
        RETURN.
    END.
    ELSE
        RUN create_xrefs IN hRtbApi
            (INPUT  TABLE TTxref,
            INPUT  pcLogFile,
            OUTPUT pcError).

    ERROR-STATUS:ERROR = NO.
    RETURN.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmCreateXrefControl) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmCreateXrefControl Procedure
PROCEDURE scmCreateXrefControl :
    /*------------------------------------------------------------------------------
             Purpose:     To create XREF records for non progress objects
             Parameters:  SEE BELOW
             Notes:       input xref temp-table and a log filename for where to log errors
                          The temp-table structure is defined at the top of this file and
                          contains a record for every object relation you want to create
                          where.
                          src-object    = Name of object in the selected workspace that
                                          contains the reference (e.g. if "program.java"
                                          references "java.class", this field should
                                          contain "program.java").
                          ref-type      = Valid reference type as listed in the Progress
                                          Language Reference under the COMPILE statement
                                          following the XREF parameter (i.e. "RUN",
                                          "INCLUDE", "CREATE", etc.).
                          obj-text[1-4] = Valid object identifier as shown in the Progress
                                          Language Reference under the COMPILE statement
                                          following the XREF parameter. Each element of
                                          the object identifier separated by a space should
                                          be placed in an extent of this field.
                                          Examples:
                                          ref-type    : INCLUDE
                                          obj-text[1] : include-file-name
                                          obj-text[2] : ""
                                          obj-text[3] : ""
                                          obj-text[4] : ""

                                          ref-type    : ACCESS
                                          obj-text[1] : database.table
                                          obj-text[2] : field
                                          obj-text[3] : ""
                                          obj-text[4] : ""

                                          ref-type    : FUNCTION
                                          obj-text[1] : function-name,return-type
                                          obj-text[2] : ""
                                          obj-text[3] : ""
                                          obj-text[4] : ""

           ------------------------------------------------------------------------------*/

    DEFINE INPUT  PARAMETER TABLE FOR TTxref.
    DEFINE INPUT  PARAMETER  pcLogFile                     AS CHARACTER    NO-UNDO.
    DEFINE OUTPUT PARAMETER pcError                    AS CHARACTER    NO-UNDO.

    TRANSACTION-BLOCK:
    DO TRANSACTION:
        RUN scmCreateXref (INPUT TABLE TTxref,
            INPUT pcLogFile,
            OUTPUT pcError).

        IF pcError <> "":U THEN
            UNDO TRANSACTION-BLOCK, LEAVE TRANSACTION-BLOCK.
    END. /* transaction-block */

    ERROR-STATUS:ERROR = NO.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmDeleteObject) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmDeleteObject Procedure
PROCEDURE scmDeleteObject :
    /*------------------------------------------------------------------------------
             Purpose:     To delete an object
             Parameters:  SEE BELOW
             Notes:       Object type is PCODE
                          Task number may be 0 but is required if object is WIP
                          Params is a comma delimited list of optional parameters, e.g.
                          "No-Prompt", "No-Delete-Source"
           ------------------------------------------------------------------------------*/

    DEFINE INPUT PARAMETER  pcScmProductModule            AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  pcObjectType    /* PCODE */   AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  pcObjectName                  AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  piTaskNumber                  AS INTEGER      NO-UNDO.
    DEFINE INPUT PARAMETER  pcParams                      AS CHARACTER    NO-UNDO.
    DEFINE OUTPUT PARAMETER pcError                       AS CHARACTER    NO-UNDO.

    DEFINE VARIABLE cError        AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cFilelist     AS CHARACTER NO-UNDO.
    DEFINE VARIABLE hObjRow       AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hObjBuf       AS HANDLE    NO-UNDO.
    DEFINE VARIABLE cDebugMessage AS CHARACTER NO-UNDO.

    IF NOT VALID-HANDLE(ghRtbAs)  THEN
        PUBLISH "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

    IF glDebug THEN
    DO:
        ASSIGN
            cDebugMessage = "gcRTBCurrentWorkspace : " + gcRTBCUrrentWorkspace + "~n":U +
         "pcObjectName : " + pcObjectName + "~n":U +
         "pcScmProductModule : " + pcScmProductModule.

        LOG-MANAGER:WRITE-MESSAGE (cDebugMessage).

        /***DIAG***/
        MESSAGE {&line-number} PROGRAM-NAME(1) SKIP
            cDebugMessage
            VIEW-AS ALERT-BOX INFO BUTTONS OK.
    END.

    RUN rtb/proxy/p/rtbGetObject.p ON ghRtbAs (
        INPUT gcRTBCUrrentWorkspace,
        INPUT "PCODE",
        INPUT pcObjectName,
        INPUT pcScmProductModule,
        OUTPUT TABLE-HANDLE hObjRow).

    IF VALID-HANDLE(hObjRow) THEN
    DO:
        hObjBuf = hObjRow:DEFAULT-BUFFER-HANDLE.
        hObjBuf:FIND-FIRST() NO-ERROR.

        IF NOT hObjBuf:AVAILABLE THEN
            RETURN.

        RUN rtb/proxy/p/rtbDeleteObject.p ON ghRtbAs (
            INPUT  hObjBuf::Rowident,
            INPUT  NO,  /*plRevert*/
            OUTPUT cFilelist, /* Comma-delimited list of files to delete from Task directory (when applicable)*/
            OUTPUT pcError).
    END.

    ERROR-STATUS:ERROR = NO.
    RETURN.

    FINALLY:
        /* Clean up the hData handle */
        DELETE OBJECT hObjRow NO-ERROR.
    END FINALLY.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmDeleteObjectControl) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmDeleteObjectControl Procedure
PROCEDURE scmDeleteObjectControl :
    /*------------------------------------------------------------------------------
             Purpose:     To delete an object
             Parameters:  SEE BELOW
             Notes:       Object type is PCODE
                          Task number may be 0 but is requierd if object is WIP
                          Params is a comma delimited list of optional parameters, e.g.
                          "No-Prompt", "No-Delete-Source"
           ------------------------------------------------------------------------------*/

    DEFINE INPUT  PARAMETER  pcProductModule               AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcObjectType    /* PCODE */   AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcObjectName                  AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  piTaskNumber                  AS INTEGER      NO-UNDO.
    DEFINE INPUT  PARAMETER  pcParams                      AS CHARACTER    NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcError                   AS CHARACTER    NO-UNDO.

    TRANSACTION-BLOCK:
    DO TRANSACTION:
        RUN scmDeleteObject (INPUT pcProductModule,
            INPUT pcObjectType,
            INPUT pcObjectName,
            INPUT piTaskNumber,
            INPUT pcParams,
            OUTPUT pcError).

        IF pcError <> "":U THEN
            UNDO TRANSACTION-BLOCK, LEAVE TRANSACTION-BLOCK.
    END. /* transaction-block */

    ERROR-STATUS:ERROR = NO.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmExtractObject) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmExtractObject Procedure
PROCEDURE scmExtractObject :
    /*------------------------------------------------------------------------------
             Purpose:     To extract source code from the repository
             Parameters:  SEE BELOW
             Notes:       Object type is PCODE
                          version is version to extract from the repository
                          root directory is directory to put extracted object under
           ------------------------------------------------------------------------------*/

    DEFINE INPUT  PARAMETER  pcProductModule               AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcObjectType    /* PCODE */   AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcObjectName                  AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcRootDir                     AS CHARACTER    NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcError                   AS CHARACTER    NO-UNDO.

    DEFINE VARIABLE cFilelist AS CHARACTER NO-UNDO.
    DEFINE VARIABLE phTT      AS HANDLE    NO-UNDO.
    DEFINE VARIABLE phTTbin   AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hObjBuf   AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hObjRow   AS HANDLE    NO-UNDO.

    IF NOT VALID-HANDLE(ghRtbAs)  THEN
        PUBLISH "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

    /* Code below is commented out , as we no longer use the product module to find objects */
    /*   IF pcProductModule <> "":U THEN                                                     */
    /*     RUN scmGetScmXref (INPUT "RTB":U,                                                 */
    /*                        INPUT "GSCPM":U,                                               */
    /*                        INPUT pcProductModule,                                         */
    /*                        INPUT 0,                                                       */
    /*                        OUTPUT cScmProductModule,                                      */
    /*                        OUTPUT cError).                                                */
    /*                                                                                       */
    /*   IF cScmProductModule = "":U THEN                                                    */
    /*   DO:                                                                                 */
    /*     pcError = "Product module " + pcProductModule + " not found in Xref table":U. */
    /*     RETURN.                                                                           */
    /*   END.                                                                                */
    /*   ELSE                                                                                */
    /*   /* Add the site prefix so that we are using the correct product module in RTB, which*/
    /*     requires prefixes to be used */                                                   */
    /*   RUN scmSitePrefixAdd (INPUT-OUTPUT cScmProductModule).                              */

    /* New code start  */
    RUN rtb/proxy/p/rtbGetObject.p ON ghRtbAs (
        INPUT  gcRTBCurrentWorkspace,
        INPUT  pcObjectType,
        INPUT  pcObjectName,
        INPUT  pcProductModule,
        OUTPUT TABLE-HANDLE hObjRow).

    hObjBuf = hObjRow:DEFAULT-BUFFER-HANDLE.
    hObjBuf:FIND-FIRST() NO-ERROR.

    IF NOT hObjBuf:AVAILABLE THEN
    DO:
        IF VALID-HANDLE(hObjRow) THEN
            DELETE OBJECT hObjRow.
        RETURN.
    END.

    /* First, fetch the contents of the file to memory */
    RUN rtb/proxy/p/rtbGetObjectContents.p ON ghRtbAs
        (INPUT  hObjBuf::Rowident,
        INPUT  0, /* piPartNum, 0 for all  */
        OUTPUT pcError,
        OUTPUT TABLE-HANDLE phTT,
        OUTPUT TABLE-HANDLE phTTbin).

    IF pcError NE "":U THEN
        RETURN pcError.

    /* Then, write the contents to disk */
    RUN rtb/proxy/p/rtbWriteObjectContents.p ON ghRtbAs
        (INPUT  pcRootDir,
        INPUT  TABLE-HANDLE phTT,
        INPUT  TABLE-HANDLE phTTbin,
        OUTPUT pcError).

    IF pcError NE "":U THEN
        RETURN pcError.

    /* Clean up the hData handle */
    IF VALID-HANDLE(hObjRow) THEN
        DELETE OBJECT hObjRow.

    ERROR-STATUS:ERROR = NO.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmExtractObjectControl) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmExtractObjectControl Procedure
PROCEDURE scmExtractObjectControl :
    /*------------------------------------------------------------------------------
             Purpose:     To extract source code from the repository
             Parameters:  SEE BELOW
             Notes:       Object type is PCODE
                          version is version to extract from the repository
                          root directory is directory to put extracted object under
           ------------------------------------------------------------------------------*/

    DEFINE INPUT  PARAMETER  pcProductModule               AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcObjectType    /* PCODE */   AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcObjectName                  AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  piVersion                     AS INTEGER      NO-UNDO.
    DEFINE INPUT  PARAMETER  pcRootDir                     AS CHARACTER    NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcError                   AS CHARACTER    NO-UNDO.

    TRANSACTION-BLOCK:
    DO TRANSACTION:
        RUN scmExtractObject (INPUT pcProductModule,
            INPUT pcObjectType,
            INPUT pcObjectName,
            INPUT piVersion,
            INPUT pcRootDir,
            OUTPUT pcError).

        IF pcError <> "":U THEN
            UNDO TRANSACTION-BLOCK, LEAVE TRANSACTION-BLOCK.
    END. /* transaction-block */

    ERROR-STATUS:ERROR = NO.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmFullObjectInfo) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmFullObjectInfo Procedure
PROCEDURE scmFullObjectInfo :
    /*------------------------------------------------------------------------------
             Purpose:     To retrieve LOTS of details about an object in the SCM tool
                          depending on what is passed in.
             Parameters:  input object name (including extension and .ado if logical)
                          input product module of the object
                          input current / required workspace
                          input current / required task (to get workspace from)
                          output object exists in Workspace flag
                          output object version number in workspace
                          output object product module in workspace
                          output object checked out in workspace flag
                          output object version created in which task number
                          output object latest version number for current module
                          output summary description of object
                          output pipe delimited list for full object description
                          output current version update notes
                          output comma seperated list of object versions before the current version

             Notes:       If no workspace is passed in, current workspace will be used
                          If no task is passed in, current task will be used.
                          If no current workspace or task and not passed in - certain
                          details will not be available.
           ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER pcObject                   AS CHARACTER  NO-UNDO.
    DEFINE INPUT  PARAMETER pcScmProductModule         AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER pcWorkspace                AS CHARACTER  NO-UNDO.
    DEFINE INPUT  PARAMETER piTask                     AS INTEGER    NO-UNDO.
    DEFINE OUTPUT PARAMETER plExistsInWorkspace        AS LOGICAL    NO-UNDO.
    DEFINE OUTPUT PARAMETER piWorkspaceVersion         AS INTEGER    NO-UNDO.
    DEFINE OUTPUT PARAMETER plWorkspaceCheckedOut      AS LOGICAL    NO-UNDO.
    DEFINE OUTPUT PARAMETER piVersioninTask            AS INTEGER    NO-UNDO.
    DEFINE OUTPUT PARAMETER piLatestVersion            AS INTEGER    NO-UNDO.
    DEFINE OUTPUT PARAMETER pcObjectSummary            AS CHARACTER  NO-UNDO.
    DEFINE OUTPUT PARAMETER pcObjectDescription        AS CHARACTER  NO-UNDO.
    DEFINE OUTPUT PARAMETER pcObjectUpdNotes           AS CHARACTER  NO-UNDO.
    DEFINE OUTPUT PARAMETER pcPrevVersions             AS CHARACTER  NO-UNDO.

    DEFINE VARIABLE iLoop              AS INTEGER   NO-UNDO.
    DEFINE VARIABLE iEntries           AS INTEGER   NO-UNDO.
    DEFINE VARIABLE cChar              AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cLine              AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cText              AS CHARACTER NO-UNDO.

    DEFINE VARIABLE cProductModule     AS CHARACTER NO-UNDO.
    DEFINE VARIABLE dProductModuleObj  AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cError             AS CHARACTER NO-UNDO.

    DEFINE VARIABLE iRtbCurrentTaskNum AS INTEGER   NO-UNDO.
    DEFINE VARIABLE iRowsToReturn      AS INTEGER   NO-UNDO.
    DEFINE VARIABLE cRowIdent          AS CHARACTER NO-UNDO.

    DEFINE VARIABLE hTaskRow           AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hTaskBuf           AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hObjRow            AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hVerRow            AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hObjBuf            AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hVerBuf            AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hQry               AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hBuf               AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hVersionsData      AS HANDLE    NO-UNDO.

    IF NOT VALID-HANDLE(ghRtbAs)  THEN
        PUBLISH "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

    /* Get the current task */
    PUBLISH "evRtbGetCurrentTask":U (OUTPUT iRtbCurrentTaskNum).

    /* If passed in a task but not a workspace, then assign workpsace to task workspace */
    RUN rtb/proxy/p/rtbGetTask.p ON ghRtbAs
        (INPUT piTask,
        OUTPUT TABLE-HANDLE hTaskRow).

    hTaskBuf = hTaskRow:DEFAULT-BUFFER-HANDLE.
    hTaskBuf:FIND-FIRST() NO-ERROR.

    IF piTask > 0         AND
        hTaskBuf:AVAILABLE AND
        pcWorkspace = "":U THEN
        ASSIGN pcWorkspace = hTaskBuf::wspace-id.

    /* if workspace or task not set-up, try to use current ones */
    IF pcWorkspace = "":U THEN
        ASSIGN pcWorkspace = gcRtbCurrentWorkspace.

    IF piTask = 0 THEN
        ASSIGN piTask = iRtbCurrentTaskNum.

    RUN rtb/proxy/p/rtbGetObject.p ON ghRtbAs
        (INPUT  pcWorkspace,
        INPUT  "PCODE":U,
        INPUT  pcObject,
        INPUT  pcScmProductModule,
        OUTPUT TABLE-HANDLE hObjRow).

    hObjBuf = hObjRow:DEFAULT-BUFFER-HANDLE.
    hObjBuf:FIND-FIRST() NO-ERROR.

    IF hObjBuf:AVAILABLE THEN
        ASSIGN
            plExistsInWorkspace = YES
            piWorkspaceVersion  = hObjBuf::VERSION
            pcScmProductModule  = hObjBuf::pmod.
    ELSE
        ASSIGN
            plExistsInWorkspace = NO
            piWorkspaceVersion  = 0
            pcScmProductModule  = "":U.

    /* Find latest version of object that exists in the given product module*/
    ASSIGN
        cRowIdent = "FIRST":U.
    RUN rtb/proxy/p/rtbGetVersions.p ON ghRtbAs (
        INPUT-OUTPUT cRowIdent,
        INPUT  0,
        INPUT  "PCODE",
        INPUT  pcObject,
        INPUT  pcSCMProductModule,
        OUTPUT TABLE-HANDLE hVersionsData).

    hVerBuf = hVersionsData:DEFAULT-BUFFER-HANDLE.
    hVerBuf:FIND-FIRST() NO-ERROR.

    IF hVerBuf:AVAILABLE THEN
        ASSIGN piLatestVersion = hVerBuf::VERSION.

    /* get any previous version numbers for the object */
    CREATE QUERY hQry.
    hQry:SET-BUFFERS(hVerBuf).
    hQry:QUERY-PREPARE("FOR EACH " + hVersionsData:NAME).
    hQry:QUERY-OPEN.
    hQry:GET-FIRST.

    DO WHILE NOT hQry:QUERY-OFF-END:
        ASSIGN
            pcPrevVersions = pcPrevVersions +
                             (IF NUM-ENTRIES(pcPrevVersions) > 0 THEN ",":U ELSE "":U) +
                             STRING(hVerBuf::VERSION).
        hQry:GET-NEXT.
    END.

    /* If version exists in workspace, see if checked out and under what task */
    IF hObjBuf:AVAILABLE THEN
    DO:
        RUN rtb/proxy/p/rtbGetVersion.p ON ghRtbAs
            (INPUT hObjBuf::obj-type,
            INPUT hObjBuf::object,
            INPUT hObjBuf::pmod,
            INPUT hObjBuf::VERSION,
            OUTPUT TABLE-HANDLE hVerRow).

        hVerBuf = hVerRow:DEFAULT-BUFFER-HANDLE.
        hVerBuf:FIND-FIRST() NO-ERROR.

        IF hVerBuf:AVAILABLE THEN
        DO:
            ASSIGN
                plWorkspaceCheckedOut = (IF hverBuf::obj-status = "w":U THEN YES ELSE NO)
                piVersioninTask       = hverBuf::task-num
                pcObjectSummary       = hverBuf::description
                pcObjectUpdNotes      = hverBuf::upd-notes
                pcObjectDescription   = hverBuf::verTextDesc.

            IF pcObjectUpdNotes = "":U AND hTaskBuf:AVAILABLE THEN
                ASSIGN pcObjectUpdNotes = hTaskBuf::taskDescription.

            IF pcObjectUpdNotes = "":U AND hTaskBuf:AVAILABLE THEN
                ASSIGN pcObjectUpdNotes = hTaskBuf::summary.
        END.
        ELSE
            ASSIGN
                plWorkspaceCheckedOut = NO
                piVersioninTask       = 0.
    END.
    ELSE
        ASSIGN
            plWorkspaceCheckedOut = NO
            piVersioninTask       = 0.

    IF VALID-HANDLE(hTaskRow) THEN
        DELETE OBJECT hTaskRow.

    IF VALID-HANDLE(hVerRow) THEN
        DELETE OBJECT hVerRow.

    IF VALID-HANDLE(hVersionsData) THEN
        DELETE OBJECT hVersionsData.

    IF VALID-HANDLE(hObjRow) THEN
        DELETE OBJECT hObjRow.

    IF VALID-HANDLE(hQry) THEN
        DELETE OBJECT hQry.

    ERROR-STATUS:ERROR = NO.
    RETURN.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmGetCustomDataSets) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmGetCustomDataSets Procedure
PROCEDURE scmGetCustomDataSets :
    /*------------------------------------------------------------------------------
             Purpose:     Get the Custom DataSets in SCM
             Parameters:  pcDataSetName - the name of the dataset file INCLUDING the .ado extension.
             Notes:       We are looking for objects such as 011at_gscdd.ado.
                          **This has not yet been converted to proxies, as there is no
                          proxy procedure to get objects with wildcards
           ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER pcDataSetName     AS CHARACTER  NO-UNDO.
    DEFINE OUTPUT PARAMETER pcCustomDataSets  AS CHARACTER  NO-UNDO.

    DEFINE VARIABLE cDynamicsObjectName AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cObjectParts        AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cRowIdent           AS CHARACTER NO-UNDO.
    DEFINE VARIABLE hWorkspaceObjects   AS HANDLE    NO-UNDO.

    cRowIdent = "FIRST".

    RUN rtb/proxy/p/rtbGetWorkspaceObjects.p ON ghRtbAs
        (INPUT-OUTPUT cRowIdent,
        INPUT 0,
        INPUT gcRtbCurrentWorkspace,
        INPUT "PCODE":U,
        INPUT "*":U + "_":U + pcDataSetName,
        OUTPUT TABLE-HANDLE hWorkspaceObjects).

    CREATE QUERY hQry.
    hBuf = hWorkspaceObjects:DEFAULT-BUFFER-HANDLE.
    hQry:SET-BUFFERS(hBuf).
    hQry:QUERY-PREPARE("FOR EACH " + hWorkspaceObjects:NAME).
    hQry:QUERY-OPEN.
    hQry:GET-FIRST.

    DO WHILE NOT hQry:QUERY-OFF-END:

        ASSIGN
            pcDataSetName = hBuf::object.

        /* Remove the .ado extension */
        RUN scmADOExtDelete (INPUT-OUTPUT pcDataSetName).

        RUN scmGetObjectParts (
            INPUT  hBuf::object,
            INPUT  "":U,
            INPUT  hBuf::pmod,
            OUTPUT cObjectParts).
        ASSIGN
            pcCustomDataSets = TRIM(pcCustomDataSets + ",":U + ENTRY(1, cObjectParts), ",":U).
        hQry:GET-NEXT.
    END.

    FINALLY:
        IF VALID-HANDLE(hWorkspaceObjects) THEN
            DELETE OBJECT hWorkspaceObjects.
    END FINALLY.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmGetModuleDetails) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmGetModuleDetails Procedure
PROCEDURE scmGetModuleDetails :
    /*------------------------------------------------------------------------------
             Purpose:     To return product and module details for passed in module code
             Parameters:  input module code
                          output product code
                          output product desc
                          output module desc

             Notes:
           ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER pcScmProductModule      AS CHARACTER  NO-UNDO.
    DEFINE OUTPUT PARAMETER pcScmProduct            AS CHARACTER  NO-UNDO.
    DEFINE OUTPUT PARAMETER pcScmProductDesc        AS CHARACTER  NO-UNDO.
    DEFINE OUTPUT PARAMETER pcScmProductModuleDesc  AS CHARACTER  NO-UNDO.

    DEFINE VARIABLE hPmodRow AS HANDLE NO-UNDO.
    DEFINE VARIABLE hPmodBuf AS HANDLE NO-UNDO.
    DEFINE VARIABLE hProdRow AS HANDLE NO-UNDO.
    DEFINE VARIABLE hProdBuf AS HANDLE NO-UNDO.

    IF NOT VALID-HANDLE(ghRtbAs)  THEN
        PUBLISH "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

    /* Get the record for the passed in product module */
    RUN rtb/proxy/p/rtbGetPmod.p ON ghRtbAs
        (INPUT pcScmProductModule,
        OUTPUT TABLE-HANDLE hPmodRow).

    hPmodBuf = hPmodRow:DEFAULT-BUFFER-HANDLE.
    hPmodBuf:FIND-FIRST() NO-ERROR.

    IF hPmodBuf:AVAILABLE THEN
    DO:
        /* Get the product record */
        RUN rtb/proxy/p/rtbGetProduct.p ON ghRtbAs
            (INPUT hPmodBuf::product-id,
            OUTPUT TABLE-HANDLE hProdRow).

        hProdBuf = hProdRow:DEFAULT-BUFFER-HANDLE.
        hProdBuf:FIND-FIRST() NO-ERROR.

        IF hProdBuf:AVAILABLE THEN
            ASSIGN
                pcScmProduct           = hProdBuf::product-id
                pcScmProductDesc       = hProdBuf::product-name
                pcScmProductModuleDesc = hPmodBuf::description.
    END.

    ERROR-STATUS:ERROR = NO.
    RETURN.

    FINALLY:
        IF VALID-HANDLE(hPmodRow) THEN
            DELETE OBJECT hPmodRow.

        IF VALID-HANDLE(hProdRow) THEN
            DELETE OBJECT hProdRow.
    END FINALLY.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmGetModuleDir) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmGetModuleDir Procedure
PROCEDURE scmGetModuleDir :
    /*------------------------------------------------------------------------------
             Purpose:     To retrieve product module directory
             Parameters:  input product module code
                          output corresponding workspace module directory
             Notes:
           ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER pcProductModule        AS CHARACTER  NO-UNDO.
    DEFINE INPUT  PARAMETER pcModuleSource         AS CHARACTER  NO-UNDO.
    DEFINE OUTPUT PARAMETER pcDir                  AS CHARACTER  NO-UNDO.

    DEFINE VARIABLE cRepoProductModuleCode AS CHARACTER NO-UNDO.
    DEFINE VARIABLE dRepoXrefObj           AS DECIMAL   NO-UNDO.
    DEFINE VARIABLE cScmProductModuleCode  AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cError                 AS CHARACTER NO-UNDO.
    DEFINE VARIABLE hPmodRow               AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hPmodBuf               AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hProdRow               AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hProdBuf               AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hModdefRow             AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hModdefBuf             AS HANDLE    NO-UNDO.

    IF NOT VALID-HANDLE(ghRtbAs)  THEN
        PUBLISH "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

    /* If the source of the product module is not RTB, then we need to
       find the corresponding RTB module before we can determine the
       realative directory */

    IF pcModuleSource NE "RTB":U THEN
    DO:
        RUN scmGetScmXref (INPUT "RTB":U,
            INPUT "GSCPM":U,
            INPUT  pcProductModule,
            INPUT 0,
            OUTPUT cScmProductModuleCode,
            OUTPUT cError).

        IF cError NE "":U THEN
            RETURN ERROR cError.

        /* Add the site prefix so that we are using the correct product module in RTB, which
          requires prefixes to be used */
        RUN scmSitePrefixAdd (INPUT-OUTPUT cScmProductModuleCode).
    END.
    ELSE
        ASSIGN cScmProductModuleCode = pcProductModule.

    /* Get the record for the passed in product module */
    RUN rtb/proxy/p/rtbGetPmod.p ON ghRtbAs
        (INPUT cScmProductModuleCode,
        OUTPUT TABLE-HANDLE hPmodRow).

    hPmodBuf = hPmodRow:DEFAULT-BUFFER-HANDLE.
    hPmodBuf:FIND-FIRST() NO-ERROR.

    IF hPmodBuf:AVAILABLE THEN
    DO:
        /* Get the record for the passed in product module */
        RUN rtb/proxy/p/rtbGetModuleDef.p ON ghRtbAs
            (INPUT hPmodBuf:BUFFER-FIELD('module'):BUFFER-VALUE,
            OUTPUT TABLE-HANDLE hModdefRow).

        hModdefBuf = hModdefRow:DEFAULT-BUFFER-HANDLE.
        hModdefBuf:FIND-FIRST() NO-ERROR.
        IF hModdefBuf:AVAILABLE THEN
            pcDir = hModdefBuf:BUFFER-FIELD('directory'):BUFFER-VALUE.
        ELSE
            ASSIGN cError = "RTB workspace module for product module " + cScmProductModuleCode + " could not be found.".
    END.
    ELSE
        ASSIGN cError = "RTB product module " + cScmProductModuleCode + " could not be found.".


    IF VALID-HANDLE(hPmodRow) THEN
        DELETE OBJECT hPmodRow.

    IF VALID-HANDLE(hModdefRow) THEN
        DELETE OBJECT hModdefRow.

    IF cError NE "":U THEN
    DO:
        RETURN ERROR cError.
    END.
    ELSE
    DO:
        ERROR-STATUS:ERROR = NO.
        RETURN cError.
    END.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmGetObjectModule) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmGetObjectModule Procedure
PROCEDURE scmGetObjectModule :
    /*------------------------------------------------------------------------------
             Purpose:     Get current product module for workspace object
             Parameters:  input workspace code
                          input object name
                          input object type
                          output product module code
                          output relative path for product module
             Notes:
           ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcWorkspace                AS CHARACTER  NO-UNDO.
    DEFINE INPUT  PARAMETER  pcObject                   AS CHARACTER  NO-UNDO.
    DEFINE INPUT  PARAMETER  pcProductModule            AS CHARACTER  NO-UNDO.
    DEFINE INPUT  PARAMETER  pcObjectSubType            AS CHARACTER  NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcScmProductModule         AS CHARACTER  NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcWorkspaceModulePath      AS CHARACTER  NO-UNDO.

    DEFINE VARIABLE cScmObjectType AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cError         AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cRepoCode      AS CHARACTER NO-UNDO.
    DEFINE VARIABLE dRepoXrefObj   AS DECIMAL   NO-UNDO.
    DEFINE VARIABLE hObjRow        AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hObjBuf        AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hVerRow        AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hVerBuf        AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hPmodRow       AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hPmodBuf       AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hProdRow       AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hProdBuf       AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hModdefRow     AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hModdefBuf     AS HANDLE    NO-UNDO.

    IF NOT VALID-HANDLE(ghRtbAs)  THEN
        PUBLISH "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

    /* check to see if there is an Xref record for the object type in gsm_scm_xref.*/
    IF pcObjectSubType <> "":U THEN
    DO:
        RUN scmGetScmXref (INPUT "RTB":U,
            INPUT "GSCOT":U,
            INPUT pcObjectSubType,
            INPUT 0,
            OUTPUT cScmObjectType,
            OUTPUT cError).

        IF cScmObjectType = "":U THEN
            RETURN ERROR  "Object Type " + cScmObjectType + " not found in Xref table":U.
    END.

    RUN rtb/proxy/p/rtbGetObject.p ON ghRtbAs
        (INPUT pcWorkspace,
        INPUT  "PCODE",
        INPUT  pcObject,
        INPUT  pcProductModule,
        OUTPUT TABLE-HANDLE hObjRow).

    hObjBuf = hObjRow:DEFAULT-BUFFER-HANDLE.
    hObjBuf:FIND-FIRST() NO-ERROR.

    IF NOT hObjBuf:AVAILABLE THEN
    DO:
        IF VALID-HANDLE(hObjRow) THEN
            DELETE OBJECT hObjRow.
        RETURN.
    END.

    RUN rtb/proxy/p/rtbGetVersion.p ON ghRtbAs
        (INPUT hObjBuf::obj-type,
        INPUT hObjBuf::object,
        INPUT hObjBuf::pmod,
        INPUT hObjBuf::VERSION,
        OUTPUT TABLE-HANDLE hVerRow).

    hVerBuf = hVerRow:DEFAULT-BUFFER-HANDLE.
    hVerBuf:FIND-FIRST() NO-ERROR.

    IF NOT hVerBuf:AVAILABLE THEN

        IF hVerBuf:AVAILABLE THEN
            ASSIGN pcScmProductModule = hObjBuf::pmod.

    IF pcScmProductModule <> "":U THEN
    DO:
        /* Get the record for the passed in product module */
        RUN rtb/proxy/p/rtbGetPmod.p ON ghRtbAs
            (INPUT pcScmProductModule,
            OUTPUT TABLE-HANDLE hPmodRow).

        hPmodBuf = hPmodRow:DEFAULT-BUFFER-HANDLE.
        hPmodBuf:FIND-FIRST() NO-ERROR.

        /* Get the record for the passed in product module */
        RUN rtb/proxy/p/rtbGetModdef.p ON ghRtbAs
            (INPUT hPmodBuf:BUFFER-FIELD('module'):BUFFER-VALUE,
            OUTPUT TABLE-HANDLE hModdefRow).

        hModdefBuf = hModdefRow:DEFAULT-BUFFER-HANDLE.
        hModdefBuf:FIND-FIRST() NO-ERROR.
        IF hModdefBuf:AVAILABLE THEN
            ASSIGN pcWorkspaceModulePath = hModdefBuf:BUFFER-FIELD('directory'):BUFFER-VALUE.
    END.

    IF VALID-HANDLE(hObjRow) THEN
        DELETE OBJECT hObjRow.

    IF VALID-HANDLE(hVerRow) THEN
        DELETE OBJECT hVerRow.

    IF VALID-HANDLE(hPmodRow) THEN
        DELETE OBJECT hPmodRow.

    IF VALID-HANDLE(hModdefRow) THEN
        DELETE OBJECT hModdefRow.

    ERROR-STATUS:ERROR = NO.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmGetObjectParts) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmGetObjectParts Procedure
PROCEDURE scmGetObjectParts :
    /*------------------------------------------------------------------------------
             Purpose:     Return the physical parts for the object in RTB
             Parameters:  pcObjectname - the SCM name of the object
                          pcRootPath   - the root workspace path. Leave this blank if
                                         only the relative part names are wanted
                          pcObjectParts - The output of physical parts of the object
             Notes:
           ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER pcScmObjectName  AS CHARACTER  NO-UNDO.
    DEFINE INPUT  PARAMETER pcRootPath       AS CHARACTER  NO-UNDO.
    DEFINE INPUT  PARAMETER pcProductmodule  AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER pcObjectParts    AS CHARACTER  NO-UNDO.

    DEFINE VARIABLE cError            AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cRowIdent         AS CHARACTER NO-UNDO.
    DEFINE VARIABLE hObjRow           AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hObjBuf           AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hWorkspaceObjects AS HANDLE    NO-UNDO.

    IF NOT VALID-HANDLE(ghRtbAs)  THEN
        PUBLISH "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

    /* If the product module is blank, then we need to try and find the object without.
       This is not such a big problem in Dynamics, as we cannot have objects with the same
       name in the repository */
    IF pcProductmodule = "":U THEN
    DO:
        cRowIdent = "FIRST".

        RUN rtb/proxy/p/rtbGetWorkspaceObjects.p ON ghRtbAs (
            INPUT-OUTPUT cRowIdent,
            INPUT 0,
            INPUT gcRtbCurrentWorkspace,
            INPUT "PCODE":U,
            INPUT pcScmObjectName,
            OUTPUT TABLE-HANDLE hWorkspaceObjects).

        CREATE QUERY hQry.
        hObjBuf = hWorkspaceObjects:DEFAULT-BUFFER-HANDLE.
        hQry:SET-BUFFERS(hObjBuf).
        hQry:QUERY-PREPARE("FOR EACH " + hWorkspaceObjects:NAME).
        hQry:QUERY-OPEN.
        hQry:GET-FIRST.

        DO WHILE NOT hQry:QUERY-OFF-END:
            ASSIGN
                cRowIdent = cRowIdent + (IF cRowIdent NE "":U THEN ",":U ELSE "":U) + hObjBuf::rowident.
            hQry:GET-NEXT.
        END.
    END.
    ELSE
    DO:
        RUN rtb/proxy/p/rtbGetObject.p ON ghRtbAs
            (INPUT gcRtbCurrentWorkspace,
            INPUT "PCODE",
            INPUT pcScmObjectName,
            INPUT pcProductmodule,
            OUTPUT TABLE-HANDLE hObjRow).

        hObjBuf = hObjRow:DEFAULT-BUFFER-HANDLE.
        hObjBuf:FIND-FIRST() NO-ERROR.

        IF hObjBuf:AVAILABLE THEN
            ASSIGN
                cRowIdent = hObjBuf::rowident.
    END.

    IF cRowIdent NE "":U THEN
    DO:
        IF NUM-ENTRIES(cRowIdent) > 1 THEN
            MESSAGE
                SUBSTITUTE("Could not find object '&1' without a product module as there is more than one match on the object")
                VIEW-AS ALERT-BOX.
        ELSE
            RUN rtb/proxy/p/rtbGetObjectParts.p ON ghRtbAs (
                INPUT  cRowIdent,
                OUTPUT pcObjectParts).

    END.

    ERROR-STATUS:ERROR = NO.
    RETURN.

    FINALLY:
        IF VALID-HANDLE(hObjRow) THEN
            DELETE OBJECT hObjRow.

        IF VALID-HANDLE(hWorkspaceObjects) THEN
            DELETE OBJECT hWorkspaceObjects.
    END FINALLY.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmGetRepoXref) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmGetRepoXref Procedure
PROCEDURE scmGetRepoXref :
    /*------------------------------------------------------------------------------
            Purpose:   Get the ICFDB repository SCM Xref information for entities
                       coming from the SCM tool.

            Parameters: Input parameters:
                        pcSCMToolCode    - The code identifying the SCM tool to retrieve Xref data for
                        pcOwningEntity   - The ICFDB owning entity to retrieve data for
                        pcScmForeignKey  - The SCM code

                        Output parameters:
                        pcRepoXrefCode   - The ICFDB code for the entity to retrieve data for
                        pcRepoXrefObj    - The _obj value of the record for the ICFDB code
                        pcError          - Any errors encountered are returned in this parameter.

             Notes:
           ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER pcSCMToolCode         AS CHARACTER  NO-UNDO.
    DEFINE INPUT  PARAMETER pcOwningEntity        AS CHARACTER  NO-UNDO.
    DEFINE INPUT  PARAMETER pcScmForeignKey       AS CHARACTER  NO-UNDO.
    DEFINE OUTPUT PARAMETER pcRepoXrefCode        AS CHARACTER  NO-UNDO.
    DEFINE OUTPUT PARAMETER pdRepoXrefObj         AS DECIMAL    NO-UNDO.
    DEFINE OUTPUT PARAMETER pcError               AS CHARACTER  NO-UNDO.

    DEFINE VARIABLE hBufferHandle        AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hBufferHandle2       AS HANDLE    NO-UNDO.
    DEFINE VARIABLE cRepoWhereString     AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cScmWhereString      AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cRepoTableName       AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cScmTableName        AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cOwningObjFieldName  AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cOwningCodeFieldName AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cRepoKeyFieldName    AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cScmKeyFieldName     AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cRepoCodeFieldName   AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cXrefSource          AS CHARACTER NO-UNDO.
    DEFINE VARIABLE dObjValue            AS DECIMAL   NO-UNDO.
    DEFINE VARIABLE cScmKeyValue         AS CHARACTER NO-UNDO.
    DEFINE VARIABLE dSCMToolObj          AS DECIMAL   NO-UNDO.

    DEFINE VARIABLE cRepoCodeValue       AS CHARACTER NO-UNDO.

    DEFINE BUFFER b_gsc_scm_tool       FOR gsc_scm_tool.
    DEFINE BUFFER b_gsc_product_module FOR gsc_product_module.
    DEFINE BUFFER b_gsmsx              FOR gsm_scm_xref.

    /* Get the SCM Tool information */
    IF pcScmToolCode <> "":U THEN
    DO:
        FIND FIRST b_gsc_scm_tool WHERE b_gsc_scm_tool.scm_tool_code = "RTB":U NO-LOCK NO-ERROR.
        IF AVAILABLE b_gsc_scm_tool THEN
            ASSIGN dSCMToolObj = b_gsc_scm_tool.scm_tool_obj.
        IF NOT AVAILABLE b_gsc_scm_tool THEN
        DO:
            ASSIGN
                pcError = "SCM Tool " + pcScmToolCode + " not found. Cannot process SCM Xref information.".
            RETURN.
        END.
    END.
    ELSE
    DO:
        ASSIGN
            pcError = "SCM Tool code not specified. Cannot evaluate SCM Xref information".
        RETURN.
    END.

    IF pcOwningEntity = "":U THEN
    DO:
        ASSIGN
            pcError = "The Owning Entity Mnemonic has not been entered. Cannot process cross reference information. ".
        RETURN.
    END.

    /* Find the correct gsm_scm_xref record with the passed in owning entity and the scm_foreign_key */
    FIND FIRST gsm_scm_xref WHERE
        gsm_scm_xref.scm_tool_obj           = dSCMToolObj     AND
        gsm_scm_xref.owning_entity_mnemonic = pcOwningEntity  AND
        gsm_scm_xref.scm_foreign_key        = pcScmForeignKey
        NO-LOCK NO-ERROR.

    IF AVAILABLE gsm_scm_xref THEN
    DO:
        RUN getEntityTableName IN gshGenManager (
            INPUT pcOwningEntity,
            INPUT "ICFDB":U,
            OUTPUT cRepoTableName) NO-ERROR.

        /* Find the name of the _obj field and _code field for the table represented by the pcOwningEntity paremeter */
        ASSIGN
            cOwningObjFieldName = DYNAMIC-FUNCTION('getObjField':U IN gshGenManager, INPUT pcOwningEntity) NO-ERROR.
        IF cOwningObjFieldName <> "":U THEN
        DO:
            ASSIGN
                cOwningCodeFieldName = REPLACE(cOwningObjFieldName, "_obj":U, "_code":U)
                cRepoWhereString     = "WHERE " + cRepoTableName + ".":U + cOwningObjFieldName + " = ":U +
        QUOTER(gsm_scm_xref.owning_obj).
        END.

        /* Find the ICFDB recortd for the passed in entity to get the value of the code field.
           We only have the value of the _bj field in the reference table.
        */
        CREATE BUFFER hBufferHandle FOR TABLE cRepoTableName.
        hBufferHandle:FIND-FIRST(cRepoWherestring, NO-LOCK) NO-ERROR.
        IF hBufferHandle:AVAILABLE THEN
        DO:
            ASSIGN
                pcRepoXrefCode = hBufferHandle:BUFFER-FIELD(cOwningCodeFieldName):BUFFER-VALUE
                pdRepoXrefObj  = DECIMAL(REPLACE(gsm_scm_xref.owning_reference, ".":U, SESSION:NUMERIC-DECIMAL-POINT)).
        END.
        /* cleanup dynamic query */
        hBufferHandle:BUFFER-RELEASE() NO-ERROR.
        DELETE OBJECT hBufferHandle.
        ASSIGN
            hBufferHandle = ?.

    END.
    ELSE
    DO:
        /* We do not have a valid Xref record for the SCM Foreign Key passed in */
        pcError = "Cannot find valid Repository cross reference record with an SCM Foreign Key of " + cScmKeyValue + "for entity " + pcOwningEntity.
    END.

    ASSIGN
        ERROR-STATUS:ERROR = FALSE.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmGetScmXref) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmGetScmXref Procedure
PROCEDURE scmGetScmXref :
    /*------------------------------------------------------------------------------
             Purpose:   Get the SCM SCM Xref information for entities
                        coming from ICFDB.

             Parameters:   Input parameters:
                           pcSCMToolCode    - The code identifying the SCM tool to retrieve Xref data for
                           pcOwningEntity   - The ICFDB owning entity to retrieve data for
                           pcRepoXrefCode   - The ICFDB code for the entity to retrieve data for
                           pdOwningObj      - Optional parameter with the _obj value of the entity record to retrieve data for

                           Output parameters:
                           pcScmForeignKey  - The value of the SCM Foreign key - if found. Blank otherwise
                           pcError          - Any errors encountered are returned in this parameter.

             Notes:
           ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER pcSCMToolCode         AS CHARACTER  NO-UNDO.
    DEFINE INPUT  PARAMETER pcOwningEntity        AS CHARACTER  NO-UNDO.
    DEFINE INPUT  PARAMETER pcOwningCode          AS CHARACTER  NO-UNDO.
    DEFINE INPUT  PARAMETER pdOwningObj           AS DECIMAL    NO-UNDO.
    DEFINE OUTPUT PARAMETER pcScmForeignKey       AS CHARACTER  NO-UNDO.
    DEFINE OUTPUT PARAMETER pcError               AS CHARACTER  NO-UNDO.

    DEFINE VARIABLE hBufferHandle        AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hBufferHandle2       AS HANDLE    NO-UNDO.
    DEFINE VARIABLE cRepoWhereString     AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cScmWhereString      AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cRepoTableName       AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cScmTableName        AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cOwningObjFieldName  AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cOwningCodeFieldName AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cRepoKeyFieldName    AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cScmKeyFieldName     AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cRepoCodeFieldName   AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cXrefSource          AS CHARACTER NO-UNDO.
    DEFINE VARIABLE dObjValue            AS DECIMAL   NO-UNDO.
    DEFINE VARIABLE cScmKeyValue         AS CHARACTER NO-UNDO.
    DEFINE VARIABLE dSCMToolObj          AS DECIMAL   NO-UNDO.
    DEFINE VARIABLE cEnityTableName      AS CHARACTER NO-UNDO.

    DEFINE VARIABLE cRepoCodeValue       AS CHARACTER NO-UNDO.

    DEFINE BUFFER b_gsc_scm_tool       FOR gsc_scm_tool.
    DEFINE BUFFER b_gsc_product_module FOR gsc_product_module.
    DEFINE BUFFER b_gsmsx              FOR gsm_scm_xref.

    /* Get the SCM Tool information */
    IF pcScmToolCode <> "":U THEN
    DO:
        FIND FIRST b_gsc_scm_tool WHERE b_gsc_scm_tool.scm_tool_code = "RTB":U NO-LOCK NO-ERROR.
        IF AVAILABLE b_gsc_scm_tool THEN
            ASSIGN dSCMToolObj = b_gsc_scm_tool.scm_tool_obj.
        IF NOT AVAILABLE b_gsc_scm_tool THEN
        DO:
            ASSIGN
                pcError = "SCM Tool " + pcScmToolCode + " not found. Cannot process SCM Xref information.".
            RETURN.
        END.
    END.
    ELSE
    DO:
        ASSIGN
            pcError = "SCM Tool code not specified. Cannot evaluate SCM Xref information".
        RETURN.
    END.

    IF pcOwningEntity = "":U THEN
    DO:
        ASSIGN
            pcError = "The Owning Entity Mnemonic has not been entered. Cannot process cross reference information.".
        RETURN.
    END.

    /* Find the correct gsm_scm_xref record with the passed in owning entity and the owning_obj value */
    IF pdOwningObj NE 0.0 THEN
    DO:
        FIND FIRST b_gsmsx WHERE
            b_gsmsx.scm_tool_obj           = dSCMToolObj     AND
            b_gsmsx.owning_entity_mnemonic = pcOwningEntity  AND
            REPLACE(STRING(b_gsmsx.owning_reference),SESSION:NUMERIC-DECIMAL-POINT, ".":U) = REPLACE(STRING(pdOwningObj),SESSION:NUMERIC-DECIMAL-POINT, ".":U)
            NO-LOCK NO-ERROR.

        /* Found one, now we need to find the code for the owning_entity record */
        IF AVAILABLE b_gsmsx THEN
        DO:
            ASSIGN
                pcScmForeignKey = b_gsmsx.scm_foreign_key.
            RETURN.
        END.
        ELSE
        DO:
            /* We do not have a valid Xref record for the SCM Foreign Key passed in */
            ASSIGN
                pcError = "Cannot find valid SCM Cross Reference record for entity " + pcOwningEntity + " with a key value of " + STRING(pdOwningObj).
            RETURN.
        END.
    END.

    IF pcOwningCode NE "":U THEN
    DO:
        RUN getEntityTableName IN gshGenManager (INPUT pcOwningEntity,
            INPUT "ICFDB":U,
            OUTPUT cRepoTableName) NO-ERROR.



        /* Find the name of the _obj field and _code field for the table represented by the pcOwningEntity paremeter */
        ASSIGN
            cOwningObjFieldName = DYNAMIC-FUNCTION('getObjField':U IN gshGenManager, INPUT pcOwningEntity) NO-ERROR.
        IF cOwningObjFieldName <> "":U THEN
        DO:
            ASSIGN
                cOwningCodeFieldName = REPLACE(cOwningObjFieldName, "_obj":U, "_code":U)
                cRepoWhereString     = "WHERE " + cRepoTableName + ".":U + cOwningCodeFieldName + " = ":U +

      QUOTER(pcOwningCode).
        END.

        /* Find the ICFDB record for the passed in entity to get the value of the code field.
           We only have the value of the _obj field in the reference table. */
        CREATE BUFFER hBufferHandle FOR TABLE cRepoTableName.
        hBufferHandle:FIND-FIRST(cRepoWherestring, NO-LOCK) NO-ERROR.
        IF hBufferHandle:AVAILABLE THEN
        DO:
            ASSIGN
                dObjValue = hBufferHandle:BUFFER-FIELD(cOwningObjFieldName):BUFFER-VALUE.
            IF dObjValue <> 0.0 THEN
            DO:
                FIND FIRST b_gsmsx WHERE
                    b_gsmsx.scm_tool_obj           = dSCMToolObj     AND
                    b_gsmsx.owning_entity_mnemonic = pcOwningEntity  AND
                    REPLACE(STRING(b_gsmsx.owning_reference),SESSION:NUMERIC-DECIMAL-POINT, ".":U) = REPLACE(STRING(dObjValue),SESSION:NUMERIC-DECIMAL-POINT, ".":U)
                    NO-LOCK NO-ERROR.
                IF AVAILABLE b_gsmsx THEN
                    ASSIGN pcScmForeignKey = b_gsmsx.scm_foreign_key.
                ELSE
                DO:
                    /* We do not have a valid Xref record for the SCM Foreign Key passed in */
                    ASSIGN
                        pcError = "Cannot find valid SCM Cross Reference record for entity " + pcOwningEntity + " with a code " + pcOwningCode.
                    RETURN.
                END.
            END.
        END.
        ELSE
        DO:
            ASSIGN
                pcError = "Cannot find record for entity " + pcOwningEntity + " with code " + pcOwningCode.
        END.
        /* cleanup dynamic query */
        hBufferHandle:BUFFER-RELEASE() NO-ERROR.
        DELETE OBJECT hBufferHandle.
        ASSIGN
            hBufferHandle = ?.
    END.

    ASSIGN
        ERROR-STATUS:ERROR = FALSE.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmGetSiteNumber) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmGetSiteNumber Procedure
PROCEDURE scmGetSiteNumber :
    /*------------------------------------------------------------------------------
             Purpose:     Return development site number
             Parameters:  output site number
             Notes:       ***This has not been converted to use proxies, as there are no proxies for this yet.
                          Instead we are using an SDO call on the AppServer.
           ------------------------------------------------------------------------------*/
    DEFINE OUTPUT PARAMETER piSite AS INTEGER NO-UNDO.
    DEFINE VARIABLE hSDO AS HANDLE NO-UNDO.

    IF NOT glRTBSiteNumberFound THEN
    DO:
        IF NOT VALID-HANDLE(ghRtbAs)  THEN
            PUBLISH "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

        IF ghRtbAs = SESSION:HANDLE THEN
            RUN rtb/sdo/rtb_u_sys.w PERSISTENT SET hSdo.
        ELSE
            RUN rtb/sdo/rtb_u_sys.w PERSISTENT ON ghRtbAs SET hSdo.

        piSite  = DYNAMIC-FUNCTION('fnRtbGetSystemSite':U IN hSdo).

        RUN destroyObject IN hSdo.
        ASSIGN
            giRTBSiteNumber      = piSite
            glRTBSiteNumberFound = TRUE.
    END.
    ELSE
        ASSIGN piSite = giRTBSiteNumber.

    ERROR-STATUS:ERROR = NO.
    RETURN.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmGetTaskInfo) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmGetTaskInfo Procedure
PROCEDURE scmGetTaskInfo :
    /*------------------------------------------------------------------------------
             Purpose:     Retrieve task information for selected task.
             Parameters:  input-output task (if not input will default to current task)
                          output task summary
                          output task description
                          output task programmer
                          output task user reference
                          output task workspace
                          output task entered dated
                          output task status

             Notes:       Supercedes rtb-get-task-info as this does not contain the status
           ------------------------------------------------------------------------------*/
    DEFINE INPUT-OUTPUT PARAMETER piTaskNumber    AS INTEGER    NO-UNDO.
    DEFINE OUTPUT PARAMETER pcTaskSummary         AS CHARACTER  NO-UNDO.
    DEFINE OUTPUT PARAMETER pcTaskDescription     AS CHARACTER  NO-UNDO.
    DEFINE OUTPUT PARAMETER pcTaskProgrammer      AS CHARACTER  NO-UNDO.
    DEFINE OUTPUT PARAMETER pcTaskUserRef         AS CHARACTER  NO-UNDO.
    DEFINE OUTPUT PARAMETER pcTaskWorkspace       AS CHARACTER  NO-UNDO.
    DEFINE OUTPUT PARAMETER ptTaskEnteredDate     AS DATE       NO-UNDO.
    DEFINE OUTPUT PARAMETER pcTaskStatus          AS CHARACTER  NO-UNDO.

    DEFINE VARIABLE iRtbCurrentTaskNum AS INTEGER   NO-UNDO.
    DEFINE VARIABLE iLoop              AS INTEGER   NO-UNDO.
    DEFINE VARIABLE cCharacter         AS CHARACTER NO-UNDO.
    DEFINE VARIABLE hTaskBuf           AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hTaskData          AS HANDLE    NO-UNDO.

    IF NOT VALID-HANDLE(ghRtbAs)  THEN
        PUBLISH "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

    /* Get the current RTB task */
    PUBLISH "evRtbGetCurrentTask":U (OUTPUT iRtbCurrentTaskNum).

    IF piTaskNumber = 0 THEN
        ASSIGN piTaskNumber = iRtbCurrentTaskNum.

    IF piTaskNumber NE 0  THEN
    DO:
        RUN rtb/proxy/p/rtbGetTask.p ON ghRtbAs
            (INPUT piTaskNumber,
            OUTPUT TABLE-HANDLE hTaskData).

        hTaskBuf = hTaskData:DEFAULT-BUFFER-HANDLE.
        hTaskBuf:FIND-FIRST() NO-ERROR.

        ASSIGN
            pcTaskSummary     = hTaskBuf::summary
            pcTaskProgrammer  = hTaskBuf::programmer
            pcTaskUserRef     = hTaskBuf::user-task-ref
            pcTaskWorkspace   = hTaskBuf::wspace-id
            ptTaskEnteredDate = hTaskBuf::entered-when
            pcTaskStatus      = hTaskBuf::task-status
            pcTaskDescription = hTaskBuf::taskDescription.

    END.

    ERROR-STATUS:ERROR = NO.
    RETURN.

    FINALLY:
        IF VALID-HANDLE(hTaskData) THEN
            DELETE OBJECT hTaskData.
    END FINALLY.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmGetTaskShareStatus) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmGetTaskShareStatus Procedure
PROCEDURE scmGetTaskShareStatus :
    /*------------------------------------------------------------------------------
             Purpose:     Get task share status
             Parameters:  input task number
                          output task exists yes/no
                          output share status
             Notes:
           ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER piTaskNumber                  AS INTEGER    NO-UNDO.
    DEFINE OUTPUT PARAMETER plExists                      AS LOGICAL    NO-UNDO.
    DEFINE OUTPUT PARAMETER pcShareStatus                 AS CHARACTER  NO-UNDO.

    DEFINE VARIABLE hTaskBuf  AS HANDLE NO-UNDO.
    DEFINE VARIABLE hTaskData AS HANDLE NO-UNDO.

    IF NOT VALID-HANDLE(ghRtbAs)  THEN
        PUBLISH "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

    IF piTaskNumber NE 0  THEN
    DO:
        RUN rtb/proxy/p/rtbGetTask.p ON ghRtbAs
            (INPUT piTaskNumber,
            OUTPUT TABLE-HANDLE hTaskData).

        hTaskBuf = hTaskData:DEFAULT-BUFFER-HANDLE.
        hTaskBuf:FIND-FIRST() NO-ERROR.
        IF NOT hTaskBuf:AVAILABLE THEN
            ASSIGN
                plExists      = NO
                pcShareStatus = "":U.
        ELSE
            ASSIGN
                plExists      = YES
                pcShareStatus = hTaskBuf::share-status.
    END.

    ERROR-STATUS:ERROR = NO.
    RETURN.

    FINALLY:
        IF VALID-HANDLE(hTaskData) THEN
            DELETE OBJECT hTaskData.
    END FINALLY.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmGetWorkspaceRoot) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmGetWorkspaceRoot Procedure
PROCEDURE scmGetWorkspaceRoot :
    /*------------------------------------------------------------------------------
             Purpose:     Return workspace root directory
             Parameters:  input workspace code
                          output workspace root directory
             Notes:
           ------------------------------------------------------------------------------*/
    DEFINE INPUT PARAMETER pcWorkspace            AS CHARACTER  NO-UNDO.
    DEFINE OUTPUT PARAMETER pcRoot                AS CHARACTER  NO-UNDO.

    /* Get the current workspace path */
    PUBLISH "evRtbCustGetWorkspaceRoot" (OUTPUT pcRoot).

    ASSIGN
        pcRoot = RIGHT-TRIM(REPLACE(pcRoot,"~\":U,"/":U),"/":U).

    ERROR-STATUS:ERROR = NO.
    RETURN.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmModuleInWorkspace) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmModuleInWorkspace Procedure
PROCEDURE scmModuleInWorkspace :
    /*------------------------------------------------------------------------------
             Purpose:     To check if passed in module exists in passed in workspace
             Parameters:  input module code
                          input workspace code
                          output exists yes/no
             Notes:
           ------------------------------------------------------------------------------*/
    DEFINE INPUT PARAMETER  pcModule               AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  pcWorkspace            AS CHARACTER    NO-UNDO.
    DEFINE OUTPUT PARAMETER plExists               AS LOGICAL      NO-UNDO.

    DEFINE VARIABLE cScmProductModuleCode     AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cError                    AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cRowIdent                 AS CHARACTER NO-UNDO.
    DEFINE VARIABLE hWorkspaceSourcePmodsData AS HANDLE    NO-UNDO.

    IF NOT VALID-HANDLE(ghRtbAs)  THEN
        PUBLISH "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

    ASSIGN
        plExists = NO.

    RUN scmGetScmXref (INPUT "RTB":U,
        INPUT "GSCPM":U,
        INPUT  pcModule,
        INPUT 0,
        OUTPUT cScmProductModuleCode,
        OUTPUT cError).

    IF cError NE "":U THEN
        RETURN ERROR cError.

    /* Add the site prefix so that we are using the correct product module in RTB, which
     requires prefixes to be used */
    RUN scmSitePrefixAdd (INPUT-OUTPUT cScmProductModuleCode).

    cRowIdent = "FIRST":U.
    RUN rtb/proxy/p/rtbGetWorkspaceSourcePmods.p ON ghRtbAs
        (INPUT-OUTPUT cRowIdent,
        INPUT 0,
        INPUT pcWorkspace,
        INPUT "":U,  /* Source workspace - optional, leave blank for all */
        INPUT "":U,  /* Source product - optional, leave blank for all*/
        INPUT cScmProductModuleCode, /* Source pmod - optional, leave blank for all*/
        INPUT FALSE,
        INPUT TRUE,
        OUTPUT TABLE-HANDLE hWorkspaceSourcePmodsData).

    /* Although we potentially have multiple records returned here,
       we are just interested if there are any, so the first one is enough */
    hBuf = hWorkspaceSourcePmodsData:DEFAULT-BUFFER-HANDLE.
    hBuf:FIND-FIRST() NO-ERROR.
    IF hBuf:AVAILABLE THEN
        ASSIGN plExists = YES.

    /* Not sure if we need this any more, commenting out for now.
       if it is needed, then it needs to be converted to proxy style... */
    /*  IF plExists = NO THEN                                           */
    /*  DO:                                                             */
    /*    IF pcModule <> "":U THEN                                      */
    /*       RUN scmSitePrefixAdd (INPUT-OUTPUT pcModule).              */
    /*                                                                  */
    /*    FIND FIRST rtb_pmod NO-LOCK                                   */
    /*      WHERE rtb_pmod.pmod = pcModule                              */
    /*      NO-ERROR.                                                   */
    /*    IF AVAILABLE rtb_pmod THEN                                    */
    /*      IF CAN-FIND(FIRST rtb_module                                */
    /*                  WHERE rtb_module.module    = rtb_pmod.module AND*/
    /*                        rtb_module.wspace-id = pcWorkspace) THEN  */
    /*        ASSIGN plExists = YES.                                    */
    /*  END.                                                            */

    /* If we do not find the product module in the workspace sources, then
      return an error status and a value, as some of the Dynamics tools are
      dependong on this for filtering valid product modules for users to
      choose from.  */
    IF NOT plExists THEN
        RETURN ERROR "Product module not a valid workspace source for workspace " + pcWorkspace.

    ERROR-STATUS:ERROR = NO.
    RETURN.

    FINALLY:
        IF VALID-HANDLE(hWorkspaceSourcePmodsData) THEN
            DELETE OBJECT hWorkspaceSourcePmodsData.
    END FINALLY.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmObjectExists) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmObjectExists Procedure
PROCEDURE scmObjectExists :
    /*------------------------------------------------------------------------------
             Purpose:     To return whether the passed in object exists in the SCM Tool,
                          plus extra information about whether it is checked out, what
                          the checked out version is, the latest version, etc.
             Parameters:  input object name
                          input workspace to check if exists in / is checked out in
                          output exists in RTB flag
                          output exists in Workspace flag
                          output object version number in workspace
                          output object checked out in workspace flag
                          output object version created in task number
                          output object latest version number

             Notes:       This routine is used by the data versioning system to ensure
                          data is not created for objects that already exist in RTB, unless
                          the object is checked out in RTB under the same task as the data
                          is being created in.
                          It is also used in other places where we need to know if an object
                          simply already exists in RTB or not.
           ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER pcObject                   AS CHARACTER   NO-UNDO.
    DEFINE INPUT  PARAMETER pcProductModule            AS CHARACTER   NO-UNDO.
    DEFINE INPUT  PARAMETER pcWorkspace                AS CHARACTER   NO-UNDO.
    DEFINE OUTPUT PARAMETER plExistsInRtb              AS LOGICAL     NO-UNDO.
    DEFINE OUTPUT PARAMETER plExistsInWorkspace        AS LOGICAL     NO-UNDO.
    DEFINE OUTPUT PARAMETER piWorkspaceVersion         AS INTEGER     NO-UNDO.
    DEFINE OUTPUT PARAMETER plWorkspaceCheckedOut      AS LOGICAL     NO-UNDO.
    DEFINE OUTPUT PARAMETER piVersionTaskNumber        AS INTEGER     NO-UNDO.
    DEFINE OUTPUT PARAMETER piLatestVersion            AS INTEGER     NO-UNDO.

    DEFINE VARIABLE hObjRow       AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hObjBuf       AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hVerRow       AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hVerBuf       AS HANDLE    NO-UNDO.
    DEFINE VARIABLE cRowIdent     AS CHARACTER NO-UNDO.
    DEFINE VARIABLE hVersionsData AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hVersionData  AS HANDLE    NO-UNDO.

    IF NOT VALID-HANDLE(ghRtbAs) THEN
        PUBLISH "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

    ASSIGN
        cRowIdent = "FIRST":U.

    RUN rtb/proxy/p/rtbGetVersions.p ON ghRtbAs
        (INPUT-OUTPUT cRowIdent,
        INPUT 0,
        INPUT "PCODE",
        INPUT pcObject,
        INPUT "*":U,     /* Wild card for any module */
        OUTPUT TABLE-HANDLE hVersionsData).

    hVerBuf = hVersionsData:DEFAULT-BUFFER-HANDLE.
    hVerBuf:FIND-FIRST() NO-ERROR.
    IF hVerBuf:AVAILABLE THEN
        ASSIGN plExistsInRtb = YES.
    ELSE
    DO:
        ASSIGN
            plExistsInRtb         = NO
            plWorkspaceCheckedOut = NO
            piVersionTaskNumber   = 0
            piLatestVersion       = 0
            plExistsInWorkspace   = NO
            piWorkspaceVersion    = 0.

        /* Return - as there is no need to continue processing if the object does not exist in RTB */
        RETURN.
    END.

    /* Find current version of object in the workspace - if there is one*/
    RUN rtb/proxy/p/rtbGetObject.p ON ghRtbAs
        (INPUT pcWorkspace,
        INPUT "PCODE",
        INPUT pcObject,
        INPUT pcProductModule,
        OUTPUT TABLE-HANDLE hObjRow).

    hObjBuf = hObjRow:DEFAULT-BUFFER-HANDLE.
    hObjBuf:FIND-FIRST() NO-ERROR.

    IF hObjBuf:AVAILABLE THEN
    DO:
        ASSIGN
            plExistsInWorkspace = YES
            piWorkspaceVersion  = hObjBuf::VERSION.

        /* Find latest version of object that exists in the given product module*/
        ASSIGN
            cRowIdent = "FIRST":U.
        RUN rtb/proxy/p/rtbGetVersions.p ON ghRtbAs
            (INPUT-OUTPUT cRowIdent,
            INPUT 0,
            INPUT "PCODE",
            INPUT pcObject,
            INPUT hObjBuf::pmod,
            OUTPUT TABLE-HANDLE hVerRow).

        hVerBuf = hVerRow:DEFAULT-BUFFER-HANDLE.
        hVerBuf:FIND-FIRST() NO-ERROR.

        IF hVerBuf:AVAILABLE THEN
            ASSIGN
                plExistsInRtb   = YES
                piLatestVersion = hVerBuf::VERSION.
        ELSE
        DO:
            ASSIGN
                plWorkspaceCheckedOut = NO
                piVersionTaskNumber   = 0
                piLatestVersion       = 0.
        END.
    END.
    ELSE
    DO:
        ASSIGN
            plExistsInRtb         = NO
            plWorkspaceCheckedOut = NO
            piVersionTaskNumber   = 0
            piLatestVersion       = 0
            plExistsInWorkspace   = NO
            piWorkspaceVersion    = 0.

        /* Return - as there is no need to continue processing if the object does not exist in RTB */
        RETURN.
    END.

    /* If version exists in workspace, see if checked out and under what task */
    IF hObjBuf:AVAILABLE THEN
    DO:
        RUN rtb/proxy/p/rtbGetVersion.p ON ghRtbAs
            (INPUT hObjBuf:BUFFER-FIELD('obj-type':U):BUFFER-VALUE,
            INPUT hObjBuf:BUFFER-FIELD('object':U):BUFFER-VALUE,
            INPUT hObjBuf:BUFFER-FIELD('pmod':U):BUFFER-VALUE,
            INPUT hObjBuf:BUFFER-FIELD('version':U):BUFFER-VALUE,
            OUTPUT TABLE-HANDLE hVersionData).

        hVerBuf = hVersionData:DEFAULT-BUFFER-HANDLE.
        hVerBuf:FIND-FIRST() NO-ERROR.

        IF hVerBuf:AVAILABLE THEN
            ASSIGN
                plWorkspaceCheckedOut = (IF hVerBuf:BUFFER-FIELD('obj-status':U):BUFFER-VALUE = "W":U THEN YES ELSE NO)
                piVersionTaskNumber   = hVerBuf:BUFFER-FIELD('task-num':U):BUFFER-VALUE.
        ELSE
            ASSIGN
                plWorkspaceCheckedOut = NO
                piVersionTaskNumber   = 0.
    END.
    ELSE
        ASSIGN
            plWorkspaceCheckedOut = NO
            piVersionTaskNumber   = 0.

    ERROR-STATUS:ERROR = NO.
    RETURN.

    FINALLY:
        IF VALID-HANDLE(hVersionData) THEN
            DELETE OBJECT hVersionData.

        IF VALID-HANDLE(hObjRow) THEN
            DELETE OBJECT hObjRow.

        IF VALID-HANDLE(hVerRow) THEN
            DELETE OBJECT hVerRow.

        IF VALID-HANDLE(hVersionsData) THEN
            DELETE OBJECT hVersionsData.
    END FINALLY.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmObjectHasData) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmObjectHasData Procedure
PROCEDURE scmObjectHasData :
    /*------------------------------------------------------------------------------
             Purpose:     To check if passed in object has a part with a .ado extension
                          indicating it has associated repository data in an xml file
             Parameters:  input workspace code
                          input object name
                          output object has data flag yes/no
                          output product module code from the ICFDB (for use when load into repository)
             Notes:
           ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER pcWorkspace             AS CHARACTER   NO-UNDO.
    DEFINE INPUT  PARAMETER pcObjectName            AS CHARACTER   NO-UNDO.
    DEFINE INPUT  PARAMETER pcProductModule         AS CHARACTER   NO-UNDO.
    DEFINE OUTPUT PARAMETER plObjectHasData         AS LOGICAL     NO-UNDO.
    DEFINE OUTPUT PARAMETER pcRepoProductModuleCode AS CHARACTER   NO-UNDO.

    DEFINE VARIABLE cScmProductModuleCode AS CHARACTER NO-UNDO.
    DEFINE VARIABLE dProductModuleObj     AS DECIMAL   NO-UNDO.
    DEFINE VARIABLE cError                AS CHARACTER NO-UNDO.
    DEFINE VARIABLE hObjRow               AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hVerRow               AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hSubtypeRow           AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hObjBuf               AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hVerBuf               AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hSubtypeBuf           AS HANDLE    NO-UNDO.
    DEFINE VARIABLE cSubtypeExtensions    AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cRowIdent             AS CHARACTER NO-UNDO.

    IF NOT VALID-HANDLE(ghRtbAs)  THEN
        PUBLISH "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

    ASSIGN
        plObjectHasData = NO.

    RUN rtb/proxy/p/rtbGetObject.p ON ghRtbAs
        (INPUT pcWorkspace,
        INPUT "PCODE",
        INPUT pcObjectName,
        INPUT pcProductModule,
        OUTPUT TABLE-HANDLE hObjRow).

    hObjBuf = hObjRow:DEFAULT-BUFFER-HANDLE.
    hObjBuf:FIND-FIRST() NO-ERROR.

    /* If version exists in workspace, see if checked out and under what task */
    IF hObjBuf:AVAILABLE THEN
    DO:
        /*   Get object version details*/
        RUN rtb/proxy/p/rtbGetVersion.p ON ghRtbAs
            (INPUT hObjBuf::obj-type,
            INPUT hObjBuf::object,
            INPUT hObjBuf::pmod,
            INPUT hObjBuf::VERSION,
            OUTPUT TABLE-HANDLE hVerRow).


        hVerBuf = hVerRow:DEFAULT-BUFFER-HANDLE.
        hVerBuf:FIND-FIRST() NO-ERROR.

        IF hVerBuf:AVAILABLE THEN
        DO:
            RUN rtb/proxy/p/rtbGetSubtype.p ON ghRtbAs
                (INPUT hVerBuf::sub-type,
                OUTPUT TABLE-HANDLE hSubtypeRow).

            hSubtypeBuf = hSubtypeRow:DEFAULT-BUFFER-HANDLE.
            hSubtypeBuf:FIND-FIRST() NO-ERROR.

            IF hSubtypeBuf:AVAILABLE THEN
            DO:
                ASSIGN
                    cSubtypeExtensions = hSubtypeBuf::subtPart-exts.

                IF CAN-DO(cSubtypeExtensions, "ado":U) THEN
                    ASSIGN plObjectHasData = YES.
                ELSE
                    ASSIGN plObjectHasData = NO.
            END.
        END.
    END.

    IF hObjBuf:AVAILABLE     AND
        hVerBuf:AVAILABLE     AND
        hSubtypeBuf:AVAILABLE THEN
    DO:
        ASSIGN
            cScmProductModuleCode = hVerBuf::pmod.
        /* The product module may be prefixed with the site number
           - so we have to remove this first. This is because the
           SCM Xref codes being stored in the database are all
           stored without the site number. */
        IF cScmProductModuleCode  <> "":U THEN
        DO:
            RUN scmSitePrefixDel (INPUT-OUTPUT cScmProductModuleCode).

            RUN scmGetRepoXref (
                INPUT "RTB",
                INPUT "GSCPM",
                INPUT  cScmProductModuleCode,
                OUTPUT pcRepoProductModuleCode,
                OUTPUT dProductModuleObj,
                OUTPUT cError).

            IF cError NE "":U THEN
                RETURN cError.
        END.
    END.

    IF VALID-HANDLE(hObjRow) THEN
        DELETE OBJECT hObjRow.

    IF VALID-HANDLE(hVerRow) THEN
        DELETE OBJECT hVerRow.

    IF VALID-HANDLE(hSubtypeRow) THEN
        DELETE OBJECT hSubtypeRow.

    ERROR-STATUS:ERROR = NO.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmObjectIntegrity) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmObjectIntegrity Procedure
PROCEDURE scmObjectIntegrity :
    /*------------------------------------------------------------------------------
             Purpose:     To check an objects integrity between the repository and disk
             Parameters:  SEE BELOW
             Notes:       Object type is PCODE
           ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcWorkspace                   AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcProductModule               AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcObjectName                  AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcObjectType  /* PCODE */     AS CHARACTER    NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcError                       AS CHARACTER    NO-UNDO.

    DEFINE VARIABLE cScmProductModule AS CHARACTER NO-UNDO.
    DEFINE VARIABLE dProductModuleObj AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cError            AS CHARACTER NO-UNDO.
    DEFINE VARIABLE hSdo              AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hObjectData       AS HANDLE    NO-UNDO.

    IF NOT VALID-HANDLE(ghRtbAs)  THEN
        PUBLISH "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

    IF pcProductModule <> "":U THEN
        RUN scmGetScmXref (INPUT "RTB":U,
            INPUT "GSCPM":U,
            INPUT pcProductModule,
            INPUT 0,
            OUTPUT cScmProductModule,
            OUTPUT cError).

    IF cScmProductModule = "":U THEN
    DO:
        pcError = "SCM Product module " + pcProductModule + " not found in Xref table":U.
        RETURN.
    END.
    ELSE
        /* Add the site prefix so that we are using the correct product module in RTB, which
          requires prefixes to be used */
        RUN scmSitePrefixAdd (INPUT-OUTPUT cScmProductModule).

    RUN rtb/proxy/p/rtbGetObject ON ghRtbAs
        (INPUT pcWorkspace,
        INPUT pcObjectType,
        INPUT pcObjectName,
        INPUT pcProductModule,
        OUTPUT TABLE-HANDLE hObjectData).

    hBuf = hObjectData:DEFAULT-BUFFER-HANDLE.
    hBuf:FIND-FIRST() NO-ERROR.

    IF hBuf:AVAILABLE THEN
        RUN rtb/proxy/p/rtbVerifyObjectIntegrity.p ON ghRtbAs
            (INPUT hBuf::rowIdent,
            OUTPUT pcError).
    ELSE
        ASSIGN pcError = "Could not find RTB object pcObjectName for integrity check".

    ERROR-STATUS:ERROR = NO.
    RETURN.

    FINALLY:
        IF VALID-HANDLE(hObjectData) THEN
            DELETE OBJECT hObjectData.
    END FINALLY.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmObjectIntegrityControl) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmObjectIntegrityControl Procedure
PROCEDURE scmObjectIntegrityControl :
    /*------------------------------------------------------------------------------
             Purpose:     To check an objects integrity between the repository and disk
             Parameters:  SEE BELOW
             Notes:       Object type is PCODE
           ------------------------------------------------------------------------------*/

    DEFINE INPUT  PARAMETER  pcWorkspace                   AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcProductModule               AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcObjectName                  AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcObjectType   /* PCODE */    AS CHARACTER    NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcError                   AS CHARACTER    NO-UNDO.
    TRANSACTION-BLOCK:
    DO TRANSACTION:
        RUN scmObjectIntegrity (INPUT pcWorkspace,                            INPUT pcProductModule,
            INPUT pcObjectName,
            INPUT pcObjectType,
            OUTPUT pcError).

        IF pcError <> "":U THEN
            UNDO TRANSACTION-BLOCK, LEAVE TRANSACTION-BLOCK.
    END. /* transaction-block */

    ERROR-STATUS:ERROR = NO.
    RETURN.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmObjectSubType) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmObjectSubType Procedure
PROCEDURE scmObjectSubType :
    /*------------------------------------------------------------------------------
             Purpose:     To find and return the Code Subtype of the object being passed
                          in.

             Parameters:  input workspace code
                          input object name (this must be the SCM name of the object)
                          output Code Subtype for object
             Notes:
           ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER pcWorkspace          AS CHARACTER  NO-UNDO.
    DEFINE INPUT  PARAMETER pcScmObjectName      AS CHARACTER  NO-UNDO.
    DEFINE INPUT  PARAMETER pcProductModule      AS CHARACTER NO-UNDO.
    DEFINE OUTPUT PARAMETER pcScmObjectSubType   AS CHARACTER  NO-UNDO.

    DEFINE VARIABLE hObjRow     AS HANDLE NO-UNDO.
    DEFINE VARIABLE hObjBuf     AS HANDLE NO-UNDO.
    DEFINE VARIABLE hVerRow     AS HANDLE NO-UNDO.
    DEFINE VARIABLE hVerBuf     AS HANDLE NO-UNDO.
    DEFINE VARIABLE hSubtypeRow AS HANDLE NO-UNDO.
    DEFINE VARIABLE hSubtypeBuf AS HANDLE NO-UNDO.

    IF NOT VALID-HANDLE(ghRtbAs)  THEN
        PUBLISH "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

    RUN rtb/proxy/p/rtbGetObject.p ON ghRtbAs
        (INPUT  pcWorkspace,
        INPUT  "PCODE",
        INPUT  pcScmObjectName,
        INPUT  pcProductModule,
        OUTPUT TABLE-HANDLE hObjRow).

    hObjBuf = hObjRow:DEFAULT-BUFFER-HANDLE.
    hObjBuf:FIND-FIRST() NO-ERROR.

    /* If version exists in workspace, see if checked out and under what task */
    IF hObjBuf:AVAILABLE THEN
    DO:
        RUN rtb/proxy/p/rtbGetVersion.p ON ghRtbAs
            (INPUT hObjBuf::obj-type,
            INPUT hObjBuf::object,
            INPUT hObjBuf::pmod,
            INPUT hObjBuf::VERSION,
            OUTPUT TABLE-HANDLE hVerRow).

        /*   Get object version details*/
        hVerBuf = hVerRow:DEFAULT-BUFFER-HANDLE.
        hVerBuf:FIND-FIRST() NO-ERROR.

        IF hVerBuf:AVAILABLE THEN
        DO:
            RUN rtb/proxy/p/rtbGetSubtype.p ON ghRtbAs
                (INPUT hVerBuf::sub-type,
                OUTPUT TABLE-HANDLE hSubtypeRow).

            hSubtypeBuf = hSubtypeRow:DEFAULT-BUFFER-HANDLE.
            hSubtypeBuf:FIND-FIRST() NO-ERROR.

            IF hSubtypeBuf:AVAILABLE THEN
                ASSIGN pcScmObjectSubType = hSubtypeBuf::sub-type.
            ELSE
                ASSIGN pcScmObjectSubType = "":U.
        END.
    END.

    IF VALID-HANDLE(hObjRow) THEN
        DELETE OBJECT hObjRow.

    IF VALID-HANDLE(hVerRow) THEN
        DELETE OBJECT hVerRow.

    IF VALID-HANDLE(hSubtypeRow) THEN
        DELETE OBJECT hSubtypeRow.

    ERROR-STATUS:ERROR = NO.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmSelectiveCompile) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmSelectiveCompile Procedure
PROCEDURE scmSelectiveCompile :
    /*------------------------------------------------------------------------------
             Purpose:     To seletively compile objects
             Parameters:  SEE BELOW
             Notes:       Ptask-num  - task number to select objects from or 0 to ignore tasks
                          Pmodule    - module to select objects from or MATCHES pattern
                          Pobj-group - Object group to select objects from or MATCHES pattern
                          Pobj-type  - Object types to select (PCODE, PFILE, etc.) or MATCHES
                                       pattern
                          Pobject    - Object to select or MATCHES pattern
                          Pforce     - Logical YES to force compile of (current) objects
                          Plistings  - Logical YES to generate compile listings
                          Pxref      - Logical YES to perform xref of selected object(s)
                          pcError     - This will be non-blank if the process could no be performed
                          Compile errors and warnings will be recorded in the selcomp.log file
                          created in the rtb_temp directory of the Roundtable session temp
                          directory.

                          No user interface will be displayed during the compile.

                          **This procedure has not been converted to proxy style code
           ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  piTaskNumber                  AS INTEGER      NO-UNDO.
    DEFINE INPUT  PARAMETER  pcModule                      AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcObjectGroup                 AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcObjectType  /* PCODE */     AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcObjectName                  AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  plWithXref                    AS LOGICAL      NO-UNDO.
    DEFINE INPUT  PARAMETER  plWithListings                AS LOGICAL      NO-UNDO.
    DEFINE INPUT  PARAMETER  plForce                       AS LOGICAL      NO-UNDO.
    DEFINE INPUT  PARAMETER  plTaskRcode                   AS LOGICAL      NO-UNDO.
    DEFINE INPUT  PARAMETER  plIgnoreWarn                  AS LOGICAL      NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcError                       AS CHARACTER    NO-UNDO.

    DEFINE VARIABLE hSdo AS HANDLE NO-UNDO.

    RUN rtb/sdo/rtb_u_obj.w PERSISTENT ON ghRtbAs SET hSdo.

    IF VALID-HANDLE(hSdo) THEN
    DO:
        RUN selective_compile IN hSdo (
            INPUT  giRtbSid,
            INPUT  gcRtbCurrentWorkspace,
            INPUT  piTaskNumber,
            INPUT  pcModule,
            INPUT  pcObjectGroup,
            INPUT  pcObjectType,
            INPUT  pcObjectName,
            INPUT  "":U, /* pmod - blank for seective compile */
            INPUT  plWithXref,
            INPUT  plWithListings,
            INPUT  plForce,
            INPUT  NO, /* stop on error */
            INPUT  plTaskRcode, /* Task r-code */
            INPUT  plIgnoreWarn, /* ignore warnings */
            OUTPUT pcError).
        RUN destroyObject IN hSdo.

        IF NUM-ENTRIES(pcError,CHR(1)) > 1 THEN
        DO:
            IF ENTRY(1,pcError,CHR(1)) EQ "INFO":U THEN
                pcError = ENTRY(2,pcError,CHR(1)).
            ELSE
                pcError = SUBSTITUTE("Warnings/Errors encountered. See &1 for details.",
                    ENTRY(2,pcError,CHR(1))).
        END.
        ELSE IF pcError = "Cancel":U THEN
                pcError = "Selective compile cancelled.".
    END.
    ELSE
        pcError = "Unable to initialize rtb_u_obj.w.".

    ERROR-STATUS:ERROR = NO.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmSelectiveCompileControl) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmSelectiveCompileControl Procedure
PROCEDURE scmSelectiveCompileControl :
    /*------------------------------------------------------------------------------
             Purpose:     To seletively compile objects
             Parameters:  SEE BELOW
             Notes:       Ptask-num  - task number to select objects from or 0 to ignore tasks
                          Pmodule    - module to select objects from or MATCHES pattern
                          Pobj-group - Object group to select objects from or MATCHES pattern
                          Pobj-type  - Object types to select (PCODE, PFILE, etc.) or MATCHES
                                       pattern
                          Pobject    - Object to select or MATCHES pattern
                          Pforce     - Logical YES to force compile of (current) objects
                          Plistings  - Logical YES to generate compile listings
                          Pxref      - Logical YES to perform xref of selected object(s)
                          Perror     - This will be non-blank if the process could no be performed
                          Compile errors and warnings will be recorded in the selcomp.log file
                          created in the rtb_temp directory of the Roundtable session temp
                          directory.

                          No user interface will be displayed during the compile.
           ------------------------------------------------------------------------------*/

    DEFINE INPUT  PARAMETER  piTaskNumber                  AS INTEGER      NO-UNDO.
    DEFINE INPUT  PARAMETER  pcModule                      AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcObjectGroup                 AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcObjectType    /* PCODE */   AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcObjectName                  AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  plWithXref                    AS LOGICAL      NO-UNDO.
    DEFINE INPUT  PARAMETER  plWithListings                AS LOGICAL      NO-UNDO.
    DEFINE INPUT  PARAMETER  plForce                       AS LOGICAL      NO-UNDO.
    DEFINE INPUT  PARAMETER  plTaskRcode                   AS LOGICAL      NO-UNDO.
    DEFINE INPUT  PARAMETER  plIgnoreWarn                  AS LOGICAL      NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcError                       AS CHARACTER    NO-UNDO.

    TRANSACTION-BLOCK:
    DO TRANSACTION:
        RUN scmCompileObject (
            INPUT piTaskNumber,
            INPUT pcModule,
            INPUT pcObjectGroup,
            INPUT pcObjectType,
            INPUT pcObjectName,
            INPUT plWithXref,
            INPUT plWithListings,
            INPUT plForce,
            INPUT plTaskRcode,
            INPUT plIgnoreWarn,
            OUTPUT pcError).

        IF pcError <> "":U THEN
            UNDO TRANSACTION-BLOCK, LEAVE TRANSACTION-BLOCK.
    END. /* transaction-block */

    ERROR-STATUS:ERROR = NO.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmSetICFParams) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmSetICFParams Procedure
PROCEDURE scmSetICFParams :
    /*------------------------------------------------------------------------------
             Purpose:     Set the ICF parameters needed by ICF from RTB
             Parameters:  <none>
             Notes:
           ------------------------------------------------------------------------------*/
    /* Get the current workspace  */
    PUBLISH "evRtbGetCurrentWorkspace":U (OUTPUT gcRtbCurrentWorkspace).

    /* Get the curret workspace path */
    gcRtbCurrentWorkspacePath = DYNAMIC-FUNCTION('fnRtbGetWorkspacePath':U,gcRtbCurrentWorkspace).

    /* Get the current workspace root path  */
    gcRtbCurrentWorkspaceRoot = ENTRY(1, gcRtbCurrentWorkspacePath).

    /* Set the workspace Root as an SCM session parameter */
    DYNAMIC-FUNCTION ("setSessionParam":U IN THIS-PROCEDURE, "_scm_root_directory":U, gcRtbCUrrentWorkspaceRoot).

    /* Set the relative source code directory as an SCM session parameter */
    DYNAMIC-FUNCTION ("setSessionParam":U IN THIS-PROCEDURE, "_scm_relative_source_directory":U, "src/icf":U).

    /* Set the Currently Selected workspace as an SCM session parameter  */
    DYNAMIC-FUNCTION ("setSessionParam":U IN THIS-PROCEDURE, "_scm_current_workspace":U, gcRtbCurrentWorkspace ).

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmSitePrefixAdd) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmSitePrefixAdd Procedure
PROCEDURE scmSitePrefixAdd :
    /*------------------------------------------------------------------------------
             Purpose:
             Parameters:  <none>
             Notes:
           ------------------------------------------------------------------------------*/
    DEFINE INPUT-OUTPUT PARAMETER pcAddSitePrefix AS CHARACTER  NO-UNDO.

    DEFINE VARIABLE iSiteNumber     AS INTEGER   NO-UNDO.
    DEFINE VARIABLE cSiteNumber     AS CHARACTER NO-UNDO.

    DEFINE VARIABLE iExistingPrefix AS INTEGER   NO-UNDO.
    DEFINE VARIABLE cExistingPrefix AS CHARACTER NO-UNDO.

    RUN scmGetSiteNumber (OUTPUT iSiteNumber).

    ASSIGN
        cSiteNumber = STRING(iSiteNumber,"999":U).

    ASSIGN
        iExistingPrefix = INTEGER(SUBSTRING(pcAddSitePrefix,1,3)) NO-ERROR.
    IF ERROR-STATUS:ERROR THEN
        ASSIGN cExistingPrefix = "":U.
    ELSE
        ASSIGN cExistingPrefix = STRING(iExistingPrefix,"999":U).

    IF iSiteNumber > 0 AND
        cExistingPrefix = "":U
        /* OR cExistingPrefix <> cSiteNumber */ THEN
        pcAddSitePrefix = cSiteNumber + pcAddSitePrefix.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmSitePrefixDel) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmSitePrefixDel Procedure
PROCEDURE scmSitePrefixDel :
    /*------------------------------------------------------------------------------
             Purpose:
             Parameters:  <none>
             Notes:
           ------------------------------------------------------------------------------*/
    DEFINE INPUT-OUTPUT PARAMETER pcDelSitePrefix AS CHARACTER  NO-UNDO.

    DEFINE VARIABLE iSiteInteger AS INTEGER NO-UNDO.
    DEFINE VARIABLE iSiteNumber  AS INTEGER NO-UNDO.

    ASSIGN
        iSiteInteger = INTEGER( SUBSTRING(pcDelSitePrefix,1,3) ) NO-ERROR.

    RUN scmGetSiteNumber (OUTPUT iSiteNumber).

    IF (iSiteNumber  > 0 AND
        SUBSTRING(pcDelSitePrefix,1,3) = STRING(iSiteNumber,"999":U)) OR
        iSiteInteger > 0 THEN
    DO:
        ASSIGN
            pcDelSitePrefix = SUBSTRING(pcDelSitePrefix,4,LENGTH(pcDelSitePrefix)).
    END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmUnlockObject) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmUnlockObject Procedure
PROCEDURE scmUnlockObject :
    /*------------------------------------------------------------------------------
             Purpose:     To unlock an object
             Parameters:  SEE BELOW
             Notes:       Object type is PCODE
           ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER  pcWorkspace                   AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcProductModule               AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcObjectName                  AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER  pcObjectType    /* PCODE */   AS CHARACTER    NO-UNDO.
    DEFINE OUTPUT PARAMETER  pcError                       AS CHARACTER    NO-UNDO.

    DEFINE VARIABLE cScmProductModule AS CHARACTER NO-UNDO.
    DEFINE VARIABLE dProductModuleObj AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cError            AS CHARACTER NO-UNDO.

    DEFINE VARIABLE hObjRow           AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hObjBuf           AS HANDLE    NO-UNDO.
    DEFINE VARIABLE cRowIdent         AS CHARACTER NO-UNDO.

    IF NOT VALID-HANDLE(ghRtbAs)  THEN
        PUBLISH "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

    IF pcProductModule <> "":U THEN
        RUN scmGetScmXref (INPUT "RTB":U,
            INPUT "GSCPM":U,
            INPUT pcProductModule,
            INPUT 0,
            OUTPUT cScmProductModule,
            OUTPUT cError).

    IF cScmProductModule = "":U THEN
    DO:
        pcError = "Product module " + pcProductModule + " not found in Xref table":U.
        RETURN.
    END.
    ELSE
        /* Add the site prefix so that we are using the correct product module in RTB, which
          requires prefixes to be used */
        RUN scmSitePrefixAdd (INPUT-OUTPUT cScmProductModule).

    RUN rtb/proxy/p/rtbGetObject.p ON ghRtbAs
        (INPUT  pcWorkspace,
        INPUT  pcObjectType,
        INPUT  pcObjectName,
        INPUT  pcProductModule,
        OUTPUT TABLE-HANDLE hObjRow).

    hObjBuf = hObjRow:DEFAULT-BUFFER-HANDLE.
    hObjBuf:FIND-FIRST() NO-ERROR.

    IF hObjBuf:AVAILABLE THEN
    DO:
        ASSIGN
            cRowIdent = hObjBuf:BUFFER-FIELD('rowident':U):BUFFER-VALUE.
    END.

    RUN rtb/proxy/p/rtbUnlockObject.p ON ghRtbAs
        (INPUT cRowIdent,
        OUTPUT pcError).

    ERROR-STATUS:ERROR = NO.
    RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmUnlockObjectControl) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmUnlockObjectControl Procedure
PROCEDURE scmUnlockObjectControl :
    /*------------------------------------------------------------------------------
             Purpose:     To unlock an object
             Parameters:  SEE BELOW
             Notes:       Object type is PCODE
           ------------------------------------------------------------------------------*/
    DEFINE INPUT PARAMETER  pcWorkspace                   AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  pcProductModule               AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  pcObjectName                  AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  pcObjectType    /* PCODE */   AS CHARACTER    NO-UNDO.
    DEFINE OUTPUT PARAMETER pcError                       AS CHARACTER    NO-UNDO.

    TRANSACTION-BLOCK:
    DO TRANSACTION:
        RUN scmUnlockObject (INPUT pcWorkspace,
            INPUT pcProductModule,
            INPUT pcObjectName,
            INPUT pcObjectType,
            OUTPUT pcError).

        IF pcError <> "":U THEN
            UNDO TRANSACTION-BLOCK, LEAVE TRANSACTION-BLOCK.
    END. /* transaction-block */

    ERROR-STATUS:ERROR = NO.
    RETURN.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmUpdateObjectDescription) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE scmUpdateObjectDescription Procedure
PROCEDURE scmUpdateObjectDescription :
    /*------------------------------------------------------------------------------
             Purpose:     Update object description for current version in workspace
             Parameters:  input workspace code
                          input object name
                          input object type (pcode)
                          input overwrite existing description yes/no
                          input new description
             Notes:
           ------------------------------------------------------------------------------*/

    DEFINE INPUT PARAMETER  pcWorkspace                   AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  pcObject                      AS CHARACTER    NO-UNDO.
    DEFINE INPUT  PARAMETER pcProductModule               AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  pcObjType    /* PCODE */      AS CHARACTER    NO-UNDO.
    DEFINE INPUT PARAMETER  plOverwrite                   AS LOGICAL      NO-UNDO.
    DEFINE INPUT PARAMETER  pcDescription                 AS CHARACTER    NO-UNDO.

    DEFINE VARIABLE hObjRow AS HANDLE NO-UNDO.
    DEFINE VARIABLE hObjBuf AS HANDLE NO-UNDO.
    DEFINE VARIABLE hVerRow AS HANDLE NO-UNDO.
    DEFINE VARIABLE hVerBuf AS HANDLE NO-UNDO.
    DEFINE VARIABLE hOcBuf  AS HANDLE NO-UNDO.
    DEFINE VARIABLE hOcTT   AS HANDLE NO-UNDO.

    IF NOT VALID-HANDLE(ghRtbAs)  THEN
        PUBLISH "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

    RUN rtb/proxy/p/rtbGetObject.p ON ghRtbAs
        (INPUT pcWorkspace,
        INPUT pcObjType,
        INPUT pcObject,
        INPUT pcProductModule,
        OUTPUT TABLE-HANDLE hObjRow).

    hObjBuf = hObjRow:DEFAULT-BUFFER-HANDLE.
    hObjBuf:FIND-FIRST() NO-ERROR.

    IF hObjBuf:AVAILABLE THEN
    DO:
        RUN rtb/proxy/p/rtbGetVersion.p ON ghRtbAs
            (INPUT hObjBuf::obj-type,
            INPUT hObjBuf::object,
            INPUT hObjBuf::pmod,
            INPUT hObjBuf::VERSION,
            OUTPUT TABLE-HANDLE hVerRow).

        hVerBuf = hVerRow:DEFAULT-BUFFER-HANDLE.
        hVerBuf:FIND-FIRST() NO-ERROR.

        IF hVerBuf:AVAILABLE AND
            (plOverwrite = YES OR LENGTH(hVerBuf:BUFFER-FIELD('verTextDesc':U):BUFFER-VALUE) = 0) THEN
        DO:
            /* Create a copy of the original record we received */
            CREATE TEMP-TABLE hOcTT.
            hOcTT:CREATE-LIKE(hVerRow).
            hOcTT:TEMP-TABLE-PREPARE(hVerBuf:NAME).

            hOcBuf = hOcTT:DEFAULT-BUFFER-HANDLE.
            hOcBuf:BUFFER-CREATE.
            hOcBuf:BUFFER-COPY(hVerBuf).

            /* Create another copy to hold the updated values */

            hOcBuf:BUFFER-CREATE.
            hOcBuf:BUFFER-COPY(hVerBuf).
            ASSIGN
                hOcBuf:BUFFER-FIELD('verTextDesc':U):BUFFER-VALUE = pcDescription.
            hOcBuf::rowMod = "U".

            RUN rtb/proxy/p/rtbSetRowValues.p ON ghRtbAs (
                INPUT "rtbVersion",
                INPUT-OUTPUT TABLE-HANDLE hOcTT,
                OUTPUT cError).

            /* Clean up */
            IF VALID-HANDLE(hOcTT) THEN
                DELETE OBJECT hOcTT.
        END.
    END.

    /* Clean up */
    IF VALID-HANDLE(hObjRow) THEN
        DELETE OBJECT hObjRow.

    IF VALID-HANDLE(hVerRow) THEN
        DELETE OBJECT hVerRow.

    ERROR-STATUS:ERROR = NO.
    RETURN.
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-setupNotifyIcon) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE setupNotifyIcon Procedure
PROCEDURE setupNotifyIcon :
    /*------------------------------------------------------------------------------
               Purpose:
               Notes:
       ------------------------------------------------------------------------------*/
    DEFINE VARIABLE cIconFilename AS CHARACTER NO-UNDO.

    ASSIGN
        cIconFilename = SEARCH("rtb\images\rtbgears.ico").
    components = NEW System.ComponentModel.Container().

    IF VALID-OBJECT(components) AND
        cIconFilename NE ? THEN
    DO:
        notifyIcon1 = NEW System.Windows.Forms.NotifyIcon(components).
        notifyIcon1:Text = SUBSTITUTE("Roundtable TSMS Dynamics - &1", gcRtbCurrentWorkspace).
        notifyIcon1:Icon = NEW System.Drawing.Icon (cIconFilename).
        notifyIcon1:Visible = TRUE.
    END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-showNotifyBallonTip) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE showNotifyBallonTip Procedure
PROCEDURE showNotifyBallonTip :
    /*------------------------------------------------------------------------------
               Purpose:
               Notes:
       ------------------------------------------------------------------------------*/
    DEFINE INPUT  PARAMETER pcBallonTipTitle  AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER pcBallonTipText   AS CHARACTER NO-UNDO.
    DEFINE INPUT  PARAMETER piBallontipTime   AS INTEGER   NO-UNDO.
    IF NOT VALID-OBJECT(notifyIcon1) THEN
        RUN setupNotifyIcon IN TARGET-PROCEDURE.

    IF VALID-OBJECT(notifyIcon1) THEN
    DO:
        IF NOT notifyIcon1:Visible  THEN
            notifyIcon1:Visible = TRUE.

        IF pcBallonTipTitle NE "":U THEN
            notifyIcon1:BalloonTipTitle = pcBallonTipTitle.
        /*        ELSE                                                                                                     */
        /*            ASSIGN                                                                                               */
        /*                notifyIcon1:BalloonTipTitle = SUBSTITUTE("RTB Dynamics Integration - &1", gcRtbCurrentWorkspace).*/

        ASSIGN
            notifyIcon1:BalloonTipText = pcBallonTipText.
        notifyIcon1:ShowBalloonTip(piBallontipTime).
    END.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

/* ************************  Function Implementations ***************** */

&IF DEFINED(EXCLUDE-scmChecksOn) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION scmChecksOn Procedure
FUNCTION scmChecksOn RETURNS LOGICAL
    ( /* parameter-definitions */ ) :
    /*------------------------------------------------------------------------------
      Purpose:  Check if scm_checks-on in gsc-security_control
        Notes:
    ------------------------------------------------------------------------------*/
    IF NOT CAN-FIND(FIRST ttSecurityControl) THEN
        RUN getSecurityControl IN gshSecurityManager (OUTPUT TABLE ttSecurityControl).

    FIND FIRST ttSecurityControl NO-ERROR.
    IF AVAILABLE ttSecurityControl THEN
    DO:
        IF ttSecurityControl.scm_checks_on = TRUE THEN
            RETURN TRUE.
        ELSE
            RETURN FALSE.
    END.

    RETURN FALSE.   /* Function return value. */
END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmGetCurrentTask) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION scmGetCurrentTask Procedure
FUNCTION scmGetCurrentTask RETURNS INTEGER
    ( /* parameter-definitions */ ) :
    /*------------------------------------------------------------------------------
      Purpose: return the currently selected task number
        Notes:
    ------------------------------------------------------------------------------*/
    DEFINE VARIABLE iRtbCurrentTaskNum AS INTEGER NO-UNDO.

    /* Get the current task */
    PUBLISH "evRtbGetCurrentTask":U (OUTPUT iRtbCurrentTaskNum).

    RETURN iRtbCurrentTaskNum.   /* Function return value. */
END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmGetCurrentWorkspace) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION scmGetCurrentWorkspace Procedure
FUNCTION scmGetCurrentWorkspace RETURNS CHARACTER
    ( /* parameter-definitions */ ) :
    /*------------------------------------------------------------------------------
      Purpose:  Return the ID of the currently selected workspace
        Notes:
    ------------------------------------------------------------------------------*/
    RETURN gcRtbCurrentWorkspace.   /* Function return value. */
END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmGetCurrentWorkspaceRoot) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION scmGetCurrentWorkspaceRoot Procedure
FUNCTION scmGetCurrentWorkspaceRoot RETURNS CHARACTER
    ( /* parameter-definitions */ ) :
    /*------------------------------------------------------------------------------
      Purpose:  Return the root workspace dir for the currently selected workspace
        Notes:
    ------------------------------------------------------------------------------*/
    DEFINE VARIABLE cRtbWorkspaceRoot AS CHARACTER NO-UNDO.

    PUBLISH "evRtbCustGetWorkspaceRoot" (OUTPUT cRtbWorkspaceRoot).

    RETURN cRtbWorkspaceRoot.   /* Function return value. */
END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmGetModuleList) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION scmGetModuleList Procedure
FUNCTION scmGetModuleList RETURNS CHARACTER
    ( /* parameter-definitions */ ) :
    /*------------------------------------------------------------------------------
     Purpose:  Return a list of the product modules in the SCM tool
        Notes:
    ------------------------------------------------------------------------------*/
    DEFINE VARIABLE cModuleList  AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cRowIdent    AS CHARACTER NO-UNDO.
    DEFINE VARIABLE hProdBuf     AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hProdQry     AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hPmodRow     AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hPmodBuf     AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hPmodQry     AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hProductData AS HANDLE    NO-UNDO.

    IF NOT VALID-HANDLE(ghRtbAs)  THEN
        PUBLISH "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

    cRowIdent = "FIRST":U.
    RUN rtb/proxy/p/rtbGetProducts.p ON ghRtbAs
        (INPUT-OUTPUT cRowIdent,
        INPUT 0,
        OUTPUT TABLE-HANDLE hProductData).

    CREATE QUERY hProdQry.
    hProdBuf = hProductData:DEFAULT-BUFFER-HANDLE.
    hProdQry:SET-BUFFERS(hProdBuf).
    hProdQry:QUERY-PREPARE("FOR EACH " + hProductData:NAME).
    hProdQry:QUERY-OPEN.
    hProdQry:GET-FIRST.
    REPEAT WHILE NOT hProdQry:QUERY-OFF-END:
        cRowIdent = "FIRST":U.
        RUN rtb/proxy/p/rtbGetProductPmods.p ON ghRtbAs
            (INPUT-OUTPUT cRowIdent,
            INPUT 0,
            INPUT hProdBuf::product-id,
            OUTPUT TABLE-HANDLE hPmodRow).

        CREATE QUERY hPmodQry.
        hPmodBuf = hPmodRow:DEFAULT-BUFFER-HANDLE.
        hPmodQry:SET-BUFFERS(hPmodBuf).
        hPmodQry:QUERY-PREPARE("FOR EACH " + hPmodRow:NAME).
        hPmodQry:QUERY-OPEN.
        hPmodQry:GET-FIRST.
        REPEAT WHILE NOT hPmodQry:QUERY-OFF-END:
            ASSIGN
                cModuleList = IF cModuleList = "":U THEN hPmodBuf::pmod ELSE cModuleList + ",":U + hPmodBuf::pmod.
            hPmodQry:GET-NEXT.
        END.
        DELETE OBJECT hPmodRow.
        DELETE OBJECT hPmodQry.
        hProdQry:GET-NEXT.
    END.

    RETURN cModuleList.   /* Function return value. */

    FINALLY:
        IF VALID-HANDLE(hProdQry) THEN
            DELETE OBJECT hProdQry.

        IF VALID-HANDLE(hProductData) THEN
            DELETE OBJECT hProductData.
    END FINALLY.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-scmGetObjectTypeList) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _FUNCTION scmGetObjectTypeList Procedure
FUNCTION scmGetObjectTypeList RETURNS CHARACTER
    ( /* parameter-definitions */ ) :
    /*------------------------------------------------------------------------------
     Purpose:  Return a list of the Code subtypes in the SCM tool
        Notes:
    ------------------------------------------------------------------------------*/
    DEFINE VARIABLE cSubtypeList  AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cModuleList   AS CHARACTER NO-UNDO.
    DEFINE VARIABLE cRowIdent     AS CHARACTER NO-UNDO.
    DEFINE VARIABLE hSubtypeBuf   AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hSubtypeQry   AS HANDLE    NO-UNDO.
    DEFINE VARIABLE hSubtypesData AS HANDLE    NO-UNDO.

    IF NOT VALID-HANDLE(ghRtbAs)  THEN
        PUBLISH "evRtbCustGetASConnection":U (OUTPUT ghRtbAs).

    cRowIdent = "FIRST":U.
    RUN rtb/proxy/p/rtbGetSubtypes.p ON ghRtbAs (
        INPUT-OUTPUT cRowIdent,
        INPUT 0,
        INPUT YES, /* Get inactive Code Subtypes as well */
        OUTPUT TABLE-HANDLE hSubtypesData).

    CREATE QUERY hSubtypeQry.
    hSubtypeBuf = hSubtypesData:DEFAULT-BUFFER-HANDLE.
    hSubtypeQry:SET-BUFFERS(hSubtypeBuf).
    hSubtypeQry:QUERY-PREPARE("FOR EACH " + hSubtypesData:NAME).
    hSubtypeQry:QUERY-OPEN.
    hSubtypeQry:GET-FIRST.
    REPEAT WHILE NOT hSubtypeQry:QUERY-OFF-END:
        ASSIGN
            cSubtypeList = IF cSubtypeList = "":U THEN hSubtypeBuf:BUFFER-FIELD('sub-type':U):BUFFER-VALUE ELSE cSubtypeList + ",":U + hSubtypeBuf:BUFFER-FIELD('sub-type':U):BUFFER-VALUE.
        hSubtypeQry:GET-NEXT.
    END.

    RETURN cSubtypeList.   /* Function return value. */

    FINALLY:
        IF VALID-HANDLE(hSubtypeQry) THEN
            DELETE OBJECT hSubtypeQry.

        IF VALID-HANDLE(hSubtypesData) THEN
            DELETE OBJECT hSubtypesData.
    END FINALLY.

END FUNCTION.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF


